import md5

from sage.all import *

def coe(expr, invar):
    t = var('tmp_var_by_coe')
    t_expr=expr.subs_expr(invar==t)
    return t_expr.coeffs(t)


def col(expr, varlist, operation = lambda x: x):
    if varlist == []:
        return operation(expr)
    else:
        v = varlist[0]
        coeff_list = coe(expr, v)
        coeff_operated = 0
        for elem in coeff_list:
            coeff_operated += col(elem[0], varlist[1:], operation) * v**elem[1]
        return coeff_operated


def is_number(expr):
    try:
        CC(expr)
    except TypeError:
        return False
    else:
        return True

# this function is not tested, nor used, but might be useful
def operate_on_element(expr, operation):
    deno = expr.denominator()
    if deno != 1: # y=a/b: parse b
        new_deno = operate_on_element(deno, operation)
        return expr.numerator() / new_deno
    if expr.operator() == (var('tmp_ooe_x')+var('tmp_ooe_y')).operator(): # y=a+b
        s = 0
        for term in expr.operator:
            s += operate_on_element(term, operation)
        return s
    # if not a/b or a+b
    return operation(expr).expand()


def approx(expr, small_list, order=1):
    return # let me get it done quickly...

def simp(expr):
    if not isinstance(expr, Expression):
        expr = SR(expr)
    return expr.simplify_rational()


def hashed_fn(id_tuple, prefix_str, prefix_str2=''):
    '''Return hashed file name.'''
    m = md5.new()
    for expr in id_tuple:
        m.update(str(expr))
    id_md5 = m.hexdigest()
    fn = prefix_str + prefix_str2 + id_md5 + '.sobj'
    return fn


def save_cal(id_tuple, prefix_str, save_tuple,
             save_as_maxima = False):
    # save the list as a sage object
    if save_as_maxima:
        print('Save as maxima object -- this is a work around.')
        fn = hashed_fn(id_tuple, prefix_str, 'maxima_')
        save(maxima(save_tuple),fn)
    else:
        fn = hashed_fn(id_tuple, prefix_str)
        save(save_tuple,fn)

    print("Calculation saved to "+fn)


def load_cal(id_tuple, prefix_str,
             load_as_maxima = False):
    if load_as_maxima:
        print("Load from maxima object -- this is a work around.")
        fn = hashed_fn(id_tuple, prefix_str, 'maxima_')
        try:
            load_tuple = tuple(load(fn)._sage_())
        except:
            print("File not loadable: "+fn)
            load_tuple = None
        else:
            print("Calculation loaded from "+fn)
    else:
        fn = hashed_fn(id_tuple, prefix_str)
        try:
            load_tuple = load(fn)
        except:
            print("File not loadable: "+fn)
            load_tuple = None
        else:
            print("Calculation loaded from"+fn)
    return load_tuple


def show_components(expr, label='Component', compact = False):
    if isinstance(expr, list):
        for idx in range(len(expr)):
            idx_str = '['+str(idx)+']'
            self.array(expr[idx],label+idx_str)
    elif expr != 0:
        print label+' = ', expr
        if not compact: print

