(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    131185,       3331]
NotebookOptionsPosition[    118247,       3053]
NotebookOutlinePosition[    129801,       3286]
CellTagsIndexPosition[    129758,       3283]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"By", " ", "Yi", " ", "Wang", " ", 
   RowBox[{
    RowBox[{"tririverwangyi", "@", "gmail"}], ".", "com", ".", 
    "\[IndentingNewLine]", "Major"}], " ", 
   RowBox[{"verson", ":", " ", 
    RowBox[{"2014.", " ", "Minor", " ", "revision", " ", "2017", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
        "fix", " ", "\"\<Coefficient[f, 2x] no longer works\>\"", " ", "in", 
         " ", "new", " ", "version", " ", "of", " ", "Mathematica"}], ",", 
        " ", 
        RowBox[{"make", " ", "some", " ", "variables", " ", "local"}]}], 
       ")"}], "."}]}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.697196047956432*^9, 3.697196077767337*^9}, {
  3.697197179509986*^9, 3.6971972966938515`*^9}, {3.69719743821811*^9, 
  3.697197455292817*^9}, {3.697241111464455*^9, 3.697241139246519*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{
     RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
     RowBox[{"AutoGeneratedPackage", "\[Rule]", "Automatic"}]}], "]"}], ";"}],
   "*)"}]], "Input",
 CellChangeTimes->{{3.5968244052888308`*^9, 3.5968244099386044`*^9}, {
  3.6971960427889414`*^9, 3.697196044737804*^9}}],

Cell[CellGroupData[{

Cell["Initialization", "Section",
 CellChangeTimes->{{3.596817580886332*^9, 3.5968175838498697`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ClearAll", "[", 
   RowBox[{"\[DoubleStruckD]", ",", "GRETsr"}], "]"}], ";"}]], "Code",
 CellChangeTimes->{{3.596817974196206*^9, 3.596817976429234*^9}, {
   3.5968180108638773`*^9, 3.59681805247554*^9}, 3.6183064572267437`*^9, 
   3.618312198145337*^9, {3.618312783932631*^9, 3.6183128452247047`*^9}, 
   3.618313175493017*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"DefQ", ",", " ", "HoldAll"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DefQ", "[", "x_", "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"OwnValues", "[", "x", "]"}], ",", 
      RowBox[{"UpValues", "[", "x", "]"}], ",", 
      RowBox[{"DownValues", "[", "x", "]"}]}], "}"}], " ", "=!=", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"{", "}"}], ",", 
      RowBox[{"{", "}"}]}], "}"}]}]}], ";"}]}], "Code",
 CellChangeTimes->{{3.596848615510646*^9, 3.596848623038068*^9}, {
  3.596848802740808*^9, 3.596848838148775*^9}, {3.596848938341536*^9, 
  3.596848951867139*^9}, {3.596849378591852*^9, 3.596849394998781*^9}, {
  3.59684953941678*^9, 3.5968495467851686`*^9}, {3.5968496538164577`*^9, 
  3.596849654535128*^9}, {3.596849709105631*^9, 3.59684973353128*^9}, {
  3.5968498246300297`*^9, 3.596849894266198*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"DefQ", "[", "Col", "]"}]}], ",", 
    RowBox[{"Col", "=", 
     RowBox[{"{", 
      RowBox[{"Unique", "[", "]"}], "}"}]}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"DefQ", "[", "Simp", "]"}]}], ",", " ", 
    RowBox[{
     RowBox[{"Simp", "[", "e_", "]"}], " ", ":=", " ", 
     RowBox[{"Collect", "[", 
      RowBox[{"e", ",", " ", "Col", ",", " ", "Simplify"}], "]"}]}]}], "]"}], 
  ";"}]}], "Code",
 CellChangeTimes->{{3.596816908847351*^9, 3.5968169378700743`*^9}, 
   3.596817099051697*^9, {3.596817463793639*^9, 3.5968174655273037`*^9}, {
   3.596817556727461*^9, 3.5968175577241507`*^9}, {3.596848116455673*^9, 
   3.596848221855979*^9}, {3.5968486007319603`*^9, 3.5968486307484426`*^9}, {
   3.596849003400469*^9, 3.596849033882391*^9}, {3.596849130775736*^9, 
   3.5968491310756083`*^9}, {3.596849958298661*^9, 3.596849958301627*^9}, {
   3.5968499891287613`*^9, 3.5968500129497843`*^9}, {3.596850162873508*^9, 
   3.596850163712674*^9}, {3.59685027441041*^9, 3.59685027944622*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"DefQ", "[", "\[DoubleStruckX]", "]"}]}], ",", " ", 
    RowBox[{
     RowBox[{
     "Print", "[", "\"\<Please define coordinate before running GRE.\>\"", 
      "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"DefQ", "[", "\[DoubleStruckD]s2", "]"}], ",", " ", 
    RowBox[{"\[DoubleStruckG]Mat", " ", "=", " ", 
     RowBox[{"Simp", "[", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Coefficient", "[", 
           RowBox[{"\[DoubleStruckD]s2", ",", 
            RowBox[{
            "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
           "]"}], "/", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
            "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
            "1", ",", "2"}], "]"}]}], "&"}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"i", "===", "j"}], ",", 
            RowBox[{
             RowBox[{"\[DoubleStruckD]", "[", "i", "]"}], 
             RowBox[{"\[DoubleStruckD]", "[", "j", "]"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "\[DoubleStruckX]"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", "2", "}"}]}], "]"}], "]"}]}], ",", "\n", "\t", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"DefQ", "[", "\[DoubleStruckG]Mat", "]"}], ",", " ", 
      RowBox[{"\[DoubleStruckD]s2", " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"\[DoubleStruckD]", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}], ".", 
           "\[DoubleStruckG]Mat", ".", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\[DoubleStruckD]", "[", "i", "]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}], ")"}],
          "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "//", 
        "Simp"}]}], ",", " ", "\n", "\t\t", 
      RowBox[{
       RowBox[{
       "Print", "[", 
        "\"\<Please define either \[DoubleStruckD]s2 or \[DoubleStruckG] \
before running GRE.\>\"", "]"}], ";", 
       RowBox[{"Abort", "[", "]"}]}]}], "]"}]}], "]"}], ";"}]}], "Code",
 CellChangeTimes->{{3.596815349656412*^9, 3.596815390957973*^9}, {
   3.596815422248993*^9, 3.596815532599023*^9}, {3.596815589443541*^9, 
   3.596815642389872*^9}, {3.596815673967121*^9, 3.596815889856544*^9}, {
   3.596815984390456*^9, 3.596815988770637*^9}, {3.596816350087386*^9, 
   3.596816419711125*^9}, {3.596816487280202*^9, 3.596816497779874*^9}, 
   3.5968165949691887`*^9, {3.596816722422225*^9, 3.5968167617626457`*^9}, {
   3.596816876887929*^9, 3.596816880109996*^9}, {3.5968170930747623`*^9, 
   3.596817096604085*^9}, {3.596817711230188*^9, 3.596817772965972*^9}, 
   3.596817881579891*^9, {3.596818607929783*^9, 3.5968186083660107`*^9}, {
   3.5968248663538933`*^9, 3.596824869226959*^9}, 3.5968481473445597`*^9, {
   3.596848601862761*^9, 3.596848603922646*^9}, {3.5968499583074083`*^9, 
   3.596849958316677*^9}, {3.61831164408324*^9, 3.618311644773374*^9}, {
   3.697197173380103*^9, 3.6971971737013073`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Notations", "Section",
 CellChangeTimes->{{3.6183020580943327`*^9, 3.618302059389729*^9}}],

Cell[CellGroupData[{

Cell["Derivatives of scalar functions", "Subsection",
 CellChangeTimes->{{3.618306316655485*^9, 3.618306326033777*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PdBox", "[", "lst_", "]"}], ":=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"StyleBox", "[", 
        RowBox[{"#", ",", " ", 
         RowBox[{"FontSize", "\[Rule]", "10"}]}], "]"}], "&"}], "@", " ", 
      RowBox[{"GridBox", "[", 
       RowBox[{"#", ",", " ", 
        RowBox[{"Selectable", "\[Rule]", "True"}], ",", " ", 
        RowBox[{"ColumnSpacings", "\[Rule]", "0"}], ",", " ", 
        RowBox[{"RowSpacings", "\[Rule]", "0"}]}], "]"}]}], "&"}], "@", " ", 
    RowBox[{"Transpose", "@", 
     RowBox[{"DeleteCases", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"Map", "[", 
          RowBox[{"ToBoxes", ",", "lst", ",", 
           RowBox[{"{", "2", "}"}]}], "]"}], "]"}], "/.", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<1\>\"", ",", "dn_"}], "}"}], "\[RuleDelayed]", 
         RowBox[{"{", 
          RowBox[{"\"\<\>\"", ",", "dn"}], "}"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<0\>\"", ",", "_"}], "}"}]}], "]"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"MakeBoxes", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Derivative", "[", "d__", "]"}], "[", "f_", "]"}], "[", "x__", 
     "]"}], ",", "StandardForm"}], "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"TagBox", "[", 
    RowBox[{
     RowBox[{"RowBox", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"GridBox", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"\"\<\[PartialD]\>\"", ",", " ", 
             RowBox[{"PdBox", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", "d", "}"}], ",", 
                RowBox[{"{", "x", "}"}]}], "}"}], "]"}], ",", "\n", "\t", 
             RowBox[{"GridBox", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"ToBoxes", "@", 
                  RowBox[{"f", "@", "x"}]}], "}"}], "}"}], ",", " ", 
               RowBox[{"Selectable", "\[Rule]", "True"}]}], "]"}]}], "}"}], 
           "}"}], ",", " ", 
          RowBox[{"ColumnSpacings", "\[Rule]", "0"}], ",", " ", 
          RowBox[{"RowSpacings", "\[Rule]", "0"}]}], "]"}], ",", "\"\<\>\""}],
        "}"}], "]"}], ",", "\"\<GRED\>\"", ",", " ", 
     RowBox[{"Selectable", "\[Rule]", "False"}]}], "]"}], " ", "/;", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", 
      RowBox[{"{", "x", "}"}], "]"}], ">", "1"}], " ", "&&", " ", 
    RowBox[{
     RowBox[{"VectorQ", "[", 
      RowBox[{
       RowBox[{"{", "d", "}"}], ",", " ", "NumberQ"}], "]"}], " ", "\\\n"}], 
    "\t\t", "&&", " ", 
    RowBox[{
     RowBox[{"VectorQ", "[", 
      RowBox[{
       RowBox[{"{", "x", "}"}], ",", " ", "AtomQ"}], "]"}], " ", 
     RowBox[{"(*", " ", 
      RowBox[{"to", " ", "avoid", " ", "formatting", " ", 
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"f", "[", 
          RowBox[{
           RowBox[{"x", "+", "y"}], ",", 
           RowBox[{"z", "+", "w"}]}], "]"}], ",", " ", "x"}], "]"}]}], " ", 
      "*)"}], " ", "\\\n"}], "\t\t", "&&", " ", 
    RowBox[{
     RowBox[{"Length", "@", 
      RowBox[{"DeleteDuplicates", "@", 
       RowBox[{"{", "x", "}"}]}]}], "===", 
     RowBox[{"Length", "@", 
      RowBox[{"{", "x", "}"}], " ", 
      RowBox[{"(*", " ", 
       RowBox[{"to", " ", "avoid", " ", "formatting", " ", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"f", "[", 
           RowBox[{"x", ",", " ", "x"}], "]"}], ",", " ", "x"}], "]"}]}], " ",
        "*)"}]}]}]}]}]}]}], "Code",
 CellChangeTimes->{{3.5966866392294617`*^9, 3.596686717861463*^9}, {
   3.59668678654882*^9, 3.59668694292207*^9}, 3.596687023099049*^9, {
   3.596687060167426*^9, 3.596687081293727*^9}, {3.596687148599813*^9, 
   3.59668723575243*^9}, {3.5966872684083776`*^9, 3.5966872684827013`*^9}, {
   3.596687376196228*^9, 3.5966874336033697`*^9}, {3.5966876176102257`*^9, 
   3.596687659898636*^9}, {3.596687746562353*^9, 3.596687747861045*^9}, 
   3.596687879022101*^9, {3.596687928110132*^9, 3.5966880076053658`*^9}, {
   3.5966880872365923`*^9, 3.5966880963997602`*^9}, {3.596688184069468*^9, 
   3.596688263959518*^9}, {3.596688364225678*^9, 3.59668836828122*^9}, {
   3.5966885070676603`*^9, 3.596688547931097*^9}, 3.596688589116377*^9, 
   3.596688632498066*^9, {3.5966886837394657`*^9, 3.596688707943336*^9}, {
   3.596688739618092*^9, 3.59668875395683*^9}, {3.5966888479775057`*^9, 
   3.596688970184699*^9}, {3.596689021692885*^9, 3.596689091058939*^9}, {
   3.5966891217745323`*^9, 3.59668912687437*^9}, {3.59668915948785*^9, 
   3.596689312248473*^9}, {3.5966893630636673`*^9, 3.596689410639771*^9}, {
   3.596689456381551*^9, 3.596689457488207*^9}, {3.596689491184565*^9, 
   3.596689537514765*^9}, {3.5966896003631372`*^9, 3.596689616066062*^9}, {
   3.5966900565631847`*^9, 3.596690150113892*^9}, {3.596690180217394*^9, 
   3.5966901944442253`*^9}, {3.5966902447819643`*^9, 3.59669034374632*^9}, 
   3.596690429836401*^9, {3.596690821348176*^9, 3.5966908862066174`*^9}, {
   3.596694634215109*^9, 3.596694634629201*^9}, 3.596695043285383*^9, {
   3.596695081922166*^9, 3.59669517562283*^9}, {3.5966952949938393`*^9, 
   3.596695393575769*^9}, {3.596695459424672*^9, 3.596695475394918*^9}, {
   3.596695667565906*^9, 3.596695697277083*^9}, {3.596695727595335*^9, 
   3.596695803208939*^9}, {3.5966958406012983`*^9, 3.59669591151788*^9}, {
   3.596695957902067*^9, 3.596696024566777*^9}, {3.596696071529511*^9, 
   3.5966960895399513`*^9}, {3.596696137332027*^9, 3.596696164831805*^9}, {
   3.596720155694108*^9, 3.596720159541391*^9}, {3.596720241039106*^9, 
   3.596720357123055*^9}, {3.596720473414423*^9, 3.5967204772852173`*^9}, {
   3.596720635902556*^9, 3.596720723912613*^9}, {3.596720793174635*^9, 
   3.596720804356063*^9}, {3.596721152614421*^9, 3.596721176978859*^9}, {
   3.5967212906993933`*^9, 3.5967213137765493`*^9}, {3.5967213616358757`*^9, 
   3.596721377383691*^9}, {3.596721414617525*^9, 3.596721563613902*^9}, {
   3.5967216243793163`*^9, 3.596721638859901*^9}, {3.5967217123500137`*^9, 
   3.596721732145176*^9}, {3.596721867974361*^9, 3.596721967697604*^9}, {
   3.5967220343237343`*^9, 3.59672207766295*^9}, {3.59672220155305*^9, 
   3.596722222359494*^9}, {3.596722312820231*^9, 3.59672236691371*^9}, {
   3.5967224929641857`*^9, 3.596722548905347*^9}, {3.5967225836709757`*^9, 
   3.596722586915573*^9}, {3.596722659087377*^9, 3.596722669254158*^9}, {
   3.5968194574862633`*^9, 3.596819465304051*^9}, {3.596850939299505*^9, 
   3.5968510352041883`*^9}, {3.5968510699521923`*^9, 3.596851070018228*^9}, {
   3.604164708191255*^9, 3.604164710657378*^9}, 3.604164763845126*^9, {
   3.618306344022023*^9, 3.6183063462577477`*^9}, {3.618306391631472*^9, 
   3.618306391679367*^9}, {3.6183184127226667`*^9, 3.618318413701767*^9}, {
   3.6183184808495293`*^9, 3.6183185116407557`*^9}, {3.6183186254300823`*^9, 
   3.6183186303781023`*^9}, {3.6183186730659*^9, 3.618318675852598*^9}, {
   3.618370049288844*^9, 3.6183701494263077`*^9}, {3.618370213734681*^9, 
   3.618370220050096*^9}, {3.6183704299498787`*^9, 3.618370430678244*^9}, 
   3.618370475855055*^9, {3.618370588231757*^9, 3.6183705885990477`*^9}, {
   3.618370629738409*^9, 3.618370630444396*^9}, {3.618370662883222*^9, 
   3.618370755766568*^9}, {3.618370845718506*^9, 3.618370845867684*^9}, {
   3.6183709834714193`*^9, 3.618370997781499*^9}, {3.6183712167097063`*^9, 
   3.618371219321151*^9}, {3.618557038194853*^9, 3.61855705714478*^9}, 
   3.61855733838803*^9, {3.618557371836298*^9, 3.618557374614193*^9}, {
   3.618557426827944*^9, 3.618557435978595*^9}, {3.618557521709749*^9, 
   3.618557522454603*^9}, {3.618558852513815*^9, 3.618558870309869*^9}, {
   3.618558981210454*^9, 3.6185590041066437`*^9}, {3.61855904827256*^9, 
   3.6185591454824753`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeExpression", "[", 
   RowBox[{
    RowBox[{"TagBox", "[", 
     RowBox[{
      RowBox[{"GridBox", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<\[PartialD]\>\"", ",", " ", 
           RowBox[{"StyleBox", "[", 
            RowBox[{
             RowBox[{"GridBox", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"n__", ",", "x__"}], "}"}], ",", "___"}], "]"}], ",", 
             "___"}], "]"}], ",", " ", 
           RowBox[{"GridBox", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", "f_", "}"}], "}"}], ",", "___"}], "]"}]}], "}"}], 
         "}"}], ",", " ", "___"}], "]"}], ",", "\"\<GRED\>\"", ",", " ", 
      "___"}], "]"}], ",", " ", "StandardForm"}], "]"}], ":=", " ", "\n", 
  "\t", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"h", "=", 
       RowBox[{"ToExpression", "@", "f"}]}], ",", 
      RowBox[{"ids", "=", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"Transpose", "@", 
         RowBox[{"Map", "[", 
          RowBox[{"ToExpression", ",", 
           RowBox[{"{", 
            RowBox[{"x", ",", 
             RowBox[{"n", "/.", 
              RowBox[{
               TagBox[
                StyleBox["\"\<\>\"",
                 ShowSpecialCharacters->False,
                 ShowStringCharacters->True,
                 NumberMarks->True],
                FullForm], "\[Rule]", "\"\<1\>\""}]}]}], "}"}], ",", 
           RowBox[{"{", "2", "}"}]}], "]"}]}]}]}]}], "}"}], ",", 
    RowBox[{"HoldComplete", "[", 
     RowBox[{"D", "[", 
      RowBox[{"h", ",", "ids"}], "]"}], "]"}]}], "]"}]}]], "Code",
 CellChangeTimes->{{3.5966866392294617`*^9, 3.596686717861463*^9}, {
   3.59668678654882*^9, 3.59668694292207*^9}, 3.596687023099049*^9, {
   3.596687060167426*^9, 3.596687081293727*^9}, {3.596687148599813*^9, 
   3.59668723575243*^9}, {3.5966872684083776`*^9, 3.5966872684827013`*^9}, {
   3.596687376196228*^9, 3.5966874336033697`*^9}, {3.5966876176102257`*^9, 
   3.596687659898636*^9}, {3.596687746562353*^9, 3.596687747861045*^9}, 
   3.596687879022101*^9, {3.596687928110132*^9, 3.5966880076053658`*^9}, {
   3.5966880872365923`*^9, 3.5966880963997602`*^9}, {3.596688184069468*^9, 
   3.596688263959518*^9}, {3.596688364225678*^9, 3.59668836828122*^9}, {
   3.5966885070676603`*^9, 3.596688547931097*^9}, 3.596688589116377*^9, 
   3.596688632498066*^9, {3.5966886837394657`*^9, 3.596688707943336*^9}, {
   3.596688739618092*^9, 3.59668875395683*^9}, {3.5966888479775057`*^9, 
   3.596688970184699*^9}, {3.596689021692885*^9, 3.596689091058939*^9}, {
   3.5966891217745323`*^9, 3.59668912687437*^9}, {3.59668915948785*^9, 
   3.596689312248473*^9}, {3.5966893630636673`*^9, 3.596689410639771*^9}, {
   3.596689456381551*^9, 3.596689457488207*^9}, {3.596689491184565*^9, 
   3.596689537514765*^9}, {3.5966896003631372`*^9, 3.596689616066062*^9}, {
   3.5966900565631847`*^9, 3.596690150113892*^9}, {3.596690180217394*^9, 
   3.5966901944442253`*^9}, {3.5966902447819643`*^9, 3.59669034374632*^9}, 
   3.596690429836401*^9, {3.596690821348176*^9, 3.5966908862066174`*^9}, {
   3.596694634215109*^9, 3.596694634629201*^9}, 3.596695043285383*^9, {
   3.596695081922166*^9, 3.59669517562283*^9}, {3.5966952949938393`*^9, 
   3.596695393575769*^9}, {3.596695459424672*^9, 3.596695475394918*^9}, {
   3.596695667565906*^9, 3.596695697277083*^9}, {3.596695727595335*^9, 
   3.596695803208939*^9}, {3.5966958406012983`*^9, 3.59669591151788*^9}, {
   3.596695957902067*^9, 3.596696024566777*^9}, {3.596696071529511*^9, 
   3.5966960895399513`*^9}, {3.596696137332027*^9, 3.596696164831805*^9}, {
   3.596720155694108*^9, 3.596720159541391*^9}, {3.596720241039106*^9, 
   3.596720357123055*^9}, {3.596720473414423*^9, 3.5967204772852173`*^9}, {
   3.596720635902556*^9, 3.596720723912613*^9}, {3.596720793174635*^9, 
   3.596720804356063*^9}, {3.596721152614421*^9, 3.596721176978859*^9}, {
   3.5967212906993933`*^9, 3.5967213137765493`*^9}, {3.5967213616358757`*^9, 
   3.596721377383691*^9}, {3.596721414617525*^9, 3.596721563613902*^9}, {
   3.5967216243793163`*^9, 3.596721638859901*^9}, {3.5967217123500137`*^9, 
   3.596721732145176*^9}, {3.596721867974361*^9, 3.596721967697604*^9}, {
   3.5967220343237343`*^9, 3.59672207766295*^9}, {3.59672220155305*^9, 
   3.596722222359494*^9}, {3.596722312820231*^9, 3.59672236691371*^9}, {
   3.5967224929641857`*^9, 3.596722548905347*^9}, {3.5967225836709757`*^9, 
   3.596722586915573*^9}, {3.596722659087377*^9, 3.596722669254158*^9}, {
   3.596722700247836*^9, 3.596722722946913*^9}, {3.596956369960688*^9, 
   3.59695644596817*^9}, {3.596957218920904*^9, 3.596957243718308*^9}, {
   3.596957356539736*^9, 3.596957366821927*^9}, {3.596957424905604*^9, 
   3.596957432918088*^9}, {3.596957863651801*^9, 3.596957874936798*^9}, {
   3.596957926362159*^9, 3.596957931091741*^9}, 3.6041647871464167`*^9, {
   3.618306371079043*^9, 3.6183063717181997`*^9}, {3.618318422563921*^9, 
   3.618318422949298*^9}, {3.618318516256722*^9, 3.61831851844982*^9}, 
   3.6183186386522408`*^9, {3.618318682185121*^9, 3.618318692013398*^9}, {
   3.6183701579668407`*^9, 3.618370194500647*^9}, {3.618370494071291*^9, 
   3.6183704967420187`*^9}, 3.618370856717101*^9, {3.6183710537667828`*^9, 
   3.618371054638957*^9}, {3.618371134651286*^9, 3.618371136295134*^9}, {
   3.618557073350627*^9, 3.618557094409265*^9}, {3.618557233253602*^9, 
   3.618557234525202*^9}, {3.618557379068684*^9, 3.618557407926024*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Upper and lower indices", "Subsection",
 CellChangeTimes->{{3.6183021939150877`*^9, 3.618302199403061*^9}}],

Cell[TextData[{
 "A tensor in GRE.nb is expressed as GRETsr[t, {{upper1, upper2, \
...},{lower1, lower2, ...}}].\nUpper and lower indices must come in pairs, \
such that if upper1 is not Null, lower1 must be Null. \nFor example, \
GRETsr[t, {{a,,d},{,e,}}] represents ",
 Cell[BoxData[
  TemplateBox[{"t","\" e \"","\"a d\""},
   "Subsuperscript"]], "Output",
  CellChangeTimes->{{3.6183023783727627`*^9, 3.618302404294763*^9}}],
 "."
}], "Text",
 CellChangeTimes->{{3.618302204997745*^9, 3.6183023550752697`*^9}, {
  3.618302409703508*^9, 3.618302411168116*^9}}],

Cell["Defining the boxes and expressions", "Text",
 CellChangeTimes->{{3.6183025377797832`*^9, 3.618302546868641*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeBoxes", "[", 
     RowBox[{
      RowBox[{"GRETsr", "[", 
       RowBox[{"t_", ",", "i_List"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", "\n", "\t\t", 
       RowBox[{
        RowBox[{"tBox", "=", 
         RowBox[{"GridBox", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"ToBoxes", "@", "t"}], "}"}], "}"}], ",", 
           RowBox[{"Selectable", "\[Rule]", "True"}]}], "]"}]}], ",", "\n", 
        "\t\t", 
        RowBox[{"iBox", "=", 
         RowBox[{"StyleBox", "[", 
          RowBox[{
           RowBox[{"GridBox", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Map", "[", 
               RowBox[{"ToBoxes", ",", "i", ",", 
                RowBox[{"{", "2", "}"}]}], "]"}], "/.", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<\[Placeholder]\>\"", "\[Rule]", "\"\<\>\""}], 
                ",", 
                RowBox[{"\"\<Null\>\"", "\[Rule]", "\"\<\>\""}]}], "}"}]}], 
             ",", " ", 
             RowBox[{"ColumnSpacings", "\[Rule]", "0"}], ",", " ", 
             RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", " ", 
             RowBox[{"Selectable", "\[Rule]", "True"}]}], "]"}], ",", 
           RowBox[{"FontSize", "\[Rule]", "10"}]}], "]"}]}]}], "}"}], ",", 
      "\n", "\t", 
      RowBox[{"TagBox", "[", 
       RowBox[{
        RowBox[{"GridBox", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"tBox", ",", "iBox"}], "}"}], "}"}], ",", " ", 
          RowBox[{"ColumnSpacings", "\[Rule]", "0"}], ",", " ", 
          RowBox[{"RowSpacings", "\[Rule]", "0"}]}], "]"}], ",", 
        "\"\<GRETsr\>\"", ",", " ", 
        RowBox[{"Selectable", "\[Rule]", "False"}]}], "]"}]}], "]"}]}], ";"}],
   "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeExpression", "[", 
    RowBox[{
     RowBox[{"TagBox", "[", 
      RowBox[{
       RowBox[{"GridBox", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"GridBox", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"{", "f_", "}"}], "}"}], ",", "___"}], "]"}], ",", 
            RowBox[{"StyleBox", "[", 
             RowBox[{
              RowBox[{"GridBox", "[", 
               RowBox[{"i_List", ",", "___"}], "]"}], ",", "___"}], "]"}]}], 
           "}"}], "}"}], ",", "___"}], "]"}], ",", "\"\<GRETsr\>\"", ",", 
       "___"}], "]"}], ",", "StandardForm"}], "]"}], ":=", "\n", "\t", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"fExpr", "=", 
        RowBox[{"ToExpression", "@", "f"}]}], ",", 
       RowBox[{"iExpr", "=", 
        RowBox[{"Map", "[", 
         RowBox[{"ToExpression", ",", 
          RowBox[{"i", "/.", 
           RowBox[{"\"\<\[Placeholder]\>\"", "\[Rule]", "\"\<\>\""}]}], ",", 
          RowBox[{"{", "2", "}"}]}], "]"}]}]}], "}"}], ",", " ", 
     RowBox[{"HoldComplete", "@", 
      RowBox[{"GRETsr", "[", 
       RowBox[{"fExpr", ",", "iExpr"}], "]"}]}]}], "]"}]}], ";"}]}], "Code",
 CellChangeTimes->{{3.618302441232853*^9, 3.6183025282104893`*^9}, {
   3.618305340348969*^9, 3.6183053621006117`*^9}, 3.618307696490067*^9, {
   3.618307840075409*^9, 3.618307840168943*^9}, {3.618308039373457*^9, 
   3.6183080397545347`*^9}, 3.61830877906747*^9, {3.618309809160289*^9, 
   3.6183098812100782`*^9}, {3.6183100520407143`*^9, 3.618310056658136*^9}, {
   3.61831195974797*^9, 3.6183119600808372`*^9}, {3.6183123648089542`*^9, 
   3.618312382735087*^9}, {3.618336707433165*^9, 3.618336721800208*^9}, {
   3.618336944773006*^9, 3.618336955083177*^9}, {3.61833698598825*^9, 
   3.618336997002533*^9}, {3.618368897809656*^9, 3.6183689250018253`*^9}, 
   3.618369197787942*^9, {3.618369247396873*^9, 3.6183692488191633`*^9}, {
   3.618371873137294*^9, 3.618371877582423*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Scalar functions", "Subsection",
 CellChangeTimes->{{3.6183060883439837`*^9, 3.618306090702066*^9}}],

Cell["\<\
We use red color to denote spacetime functions, i.e. function of \
\[DoubleStruckX].
We use purple color to denote functions of \[DoubleStruckX]\
\[LeftDoubleBracket]1\[RightDoubleBracket].\
\>", "Text",
 CellChangeTimes->{{3.61830609934204*^9, 3.618306145952546*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"fx", "=", 
      RowBox[{"f_", "@@", "\[DoubleStruckX]"}]}], "}"}], ",", " ", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{"fx", ",", " ", "StandardForm"}], "]"}], ":=", " ", 
     RowBox[{"TagBox", "[", 
      RowBox[{
       RowBox[{"StyleBox", "[", 
        RowBox[{
         RowBox[{"ToBoxes", "[", "f", "]"}], ",", "Red"}], "]"}], ",", 
       "\"\<GREFX\>\"", ",", 
       RowBox[{"Selectable", "\[Rule]", "False"}]}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeExpression", "[", 
    RowBox[{
     RowBox[{"TagBox", "[", 
      RowBox[{"f_", ",", "\"\<GREFX\>\"", ",", "___"}], "]"}], ",", 
     "StandardForm"}], "]"}], ":=", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"fx", "=", 
       RowBox[{
        RowBox[{"ToExpression", "[", "f", "]"}], "@@", "\[DoubleStruckX]"}]}],
       "}"}], ",", 
     RowBox[{"HoldComplete", "@", "fx"}]}], "]"}]}], ";"}]}], "Code",
 CellChangeTimes->{{3.618305243339406*^9, 3.61830532119669*^9}, {
  3.61830536559153*^9, 3.6183053998158503`*^9}, {3.6183054630370197`*^9, 
  3.6183054714272537`*^9}, {3.618305527726241*^9, 3.618305585225298*^9}, {
  3.618305622517457*^9, 3.618305638984992*^9}, {3.618305727741514*^9, 
  3.618305839353763*^9}, {3.6183060390117407`*^9, 3.618306040614747*^9}, {
  3.618306165440967*^9, 3.618306166012268*^9}, {3.61857288458365*^9, 
  3.618572890186783*^9}, {3.618573015951345*^9, 3.618573082404079*^9}, {
  3.618573203255933*^9, 3.618573203914966*^9}, {3.618573311089671*^9, 
  3.618573329690096*^9}, {3.618573408171764*^9, 3.618573423943501*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"fx", "=", 
      RowBox[{"f_", "[", 
       RowBox[{
       "\[DoubleStruckX]", "\[LeftDoubleBracket]", "1", 
        "\[RightDoubleBracket]"}], "]"}]}], "}"}], ",", " ", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{"fx", ",", " ", "StandardForm"}], "]"}], ":=", " ", 
     RowBox[{"TagBox", "[", 
      RowBox[{
       RowBox[{"StyleBox", "[", 
        RowBox[{
         RowBox[{"ToBoxes", "[", "f", "]"}], ",", "Purple"}], "]"}], ",", 
       "\"\<GREFX0\>\"", ",", 
       RowBox[{"Selectable", "\[Rule]", "False"}]}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeExpression", "[", 
    RowBox[{
     RowBox[{"TagBox", "[", 
      RowBox[{"f_", ",", "\"\<GREFX0\>\"", ",", "___"}], "]"}], ",", 
     "StandardForm"}], "]"}], ":=", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"fx", "=", 
       RowBox[{
        RowBox[{"ToExpression", "[", "f", "]"}], "[", 
        RowBox[{
        "\[DoubleStruckX]", "\[LeftDoubleBracket]", "1", 
         "\[RightDoubleBracket]"}], "]"}]}], "}"}], ",", 
     RowBox[{"HoldComplete", "@", "fx"}]}], "]"}]}], ";"}]}], "Code",
 CellChangeTimes->{{3.618305243339406*^9, 3.61830532119669*^9}, {
  3.61830536559153*^9, 3.6183053998158503`*^9}, {3.6183054630370197`*^9, 
  3.6183054714272537`*^9}, {3.618305527726241*^9, 3.618305585225298*^9}, {
  3.618305622517457*^9, 3.618305693343948*^9}, {3.618305855532452*^9, 
  3.6183058769646387`*^9}, {3.618306016042585*^9, 3.61830601795903*^9}, {
  3.618306162349041*^9, 3.6183061678187017`*^9}, {3.618572897097506*^9, 
  3.618572900729258*^9}, {3.618573498065714*^9, 3.618573498833715*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Input aliases", "Subsection",
 CellChangeTimes->{{3.618306557117194*^9, 3.6183065611294317`*^9}}],

Cell["Defining input aliases", "Text",
 CellChangeTimes->{{3.618302552513261*^9, 3.618302602650217*^9}, {
  3.6971961563295445`*^9, 3.6971961566609287`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", " ", 
      RowBox[{"InputAliases", "\[Rule]", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"InputAliases", "/.", 
          RowBox[{"Options", "[", 
           RowBox[{"#", ",", "InputAliases"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"FreeQ", "[", 
           RowBox[{"#", ",", 
            RowBox[{
            "\"\<eu\>\"", "|", "\"\<ed\>\"", "|", "\"\<eud\>\"", "|", 
             "\"\<edu\>\"", "|", "\"\<eudd\>\"", "|", "\"\<euddd\>\"", "|", 
             "\"\<edddd\>\"", "|", "\"\<et\>\"", "|", "\"\<ex\>\"", "|", 
             "\"\<e0\>\"", "|", "\"\<ep\>\""}]}], "]"}], "&"}]}], "]"}]}]}], 
     "]"}], "&"}], " ", "/@", " ", 
   RowBox[{"Append", "[", 
    RowBox[{
     RowBox[{"Notebooks", "[", "]"}], ",", "$FrontEnd"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", " ", 
      RowBox[{"InputAliases", "\[Rule]", 
       RowBox[{"Union", "[", 
        RowBox[{
         RowBox[{"InputAliases", "/.", 
          RowBox[{"Options", "[", 
           RowBox[{"#", ",", "InputAliases"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", "\n", "\t", 
           RowBox[{
            RowBox[{"\"\<eu\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"GRETsr", "[", 
               RowBox[{"\[SelectionPlaceholder]", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", "0", "}"}], ",", 
                  RowBox[{"{", "Null", "}"}]}], "}"}]}], "]"}], "]"}]}], ",", 
            "\n", "\t", 
            RowBox[{"\"\<ed\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"GRETsr", "[", 
               RowBox[{"\[SelectionPlaceholder]", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", "Null", "}"}], ",", 
                  RowBox[{"{", "0", "}"}]}], "}"}]}], "]"}], "]"}]}], ",", 
            "\n", "\t", 
            RowBox[{"\"\<euu\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"GRETsr", "[", 
               RowBox[{"\[SelectionPlaceholder]", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"Null", ",", "Null"}], "}"}]}], "}"}]}], "]"}], 
              "]"}]}], ",", "\n", "\t", 
            RowBox[{"\"\<eud\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"GRETsr", "[", 
               RowBox[{"\[SelectionPlaceholder]", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"0", ",", "Null"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"Null", ",", "0"}], "}"}]}], "}"}]}], "]"}], 
              "]"}]}], ",", "\n", "\t", 
            RowBox[{"\"\<edu\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"GRETsr", "[", 
               RowBox[{"\[SelectionPlaceholder]", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"Null", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "Null"}], "}"}]}], "}"}]}], "]"}], 
              "]"}]}], ",", "\n", "\t", 
            RowBox[{"\"\<edd\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"GRETsr", "[", 
               RowBox[{"\[SelectionPlaceholder]", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"Null", ",", "Null"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], "]"}], "]"}]}], 
            ",", "\n", "\t", 
            RowBox[{"\"\<eudd\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"GRETsr", "[", 
               RowBox[{"\[SelectionPlaceholder]", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"0", ",", "Null", ",", "Null"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"Null", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
               "]"}], "]"}]}], ",", "\n", "\t", 
            RowBox[{"\"\<euddd\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"GRETsr", "[", 
               RowBox[{"\[SelectionPlaceholder]", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"0", ",", "Null", ",", "Null", ",", "Null"}], 
                   "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"Null", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
                 "}"}]}], "]"}], "]"}]}], ",", "\n", "\t", 
            RowBox[{"\"\<edddd\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"GRETsr", "[", 
               RowBox[{"\[SelectionPlaceholder]", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"Null", ",", "Null", ",", "Null", ",", "Null"}], 
                   "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
                 "}"}]}], "]"}], "]"}]}], ",", "\n", "\t", 
            RowBox[{"\"\<et\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"GRETsr", "[", 
               RowBox[{"\[SelectionPlaceholder]", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", "0", "}"}], ",", 
                  RowBox[{"{", "0", "}"}]}], "}"}]}], "]"}], "]"}]}], ",", 
            "\n", "\t", 
            RowBox[{"\"\<ex\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"\[SelectionPlaceholder]", "@@", "\[DoubleStruckX]"}], 
              "]"}]}], ",", "\n", "\t", 
            RowBox[{"\"\<e0\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"\[SelectionPlaceholder]", "[", 
               RowBox[{
               "\[DoubleStruckX]", "\[LeftDoubleBracket]", "1", 
                "\[RightDoubleBracket]"}], "]"}], "]"}]}], ",", "\n", "\t", 
            RowBox[{"\"\<ep\>\"", "\[Rule]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"Unevaluated", "@", 
               RowBox[{"D", "[", 
                RowBox[{"\[Placeholder]", ",", "\[SelectionPlaceholder]"}], 
                "]"}]}], "]"}]}]}], "\n", "}"}], "/.", 
          RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<\[Placeholder]\>\""}]}]}], " ", 
        RowBox[{"(*", 
         RowBox[{
         "otherwise", " ", "\[Placeholder]", " ", "is", " ", "converted", " ",
           "to", " ", "Null"}], "*)"}], "]"}]}]}], "]"}], "&"}], " ", "/@", 
   " ", 
   RowBox[{"Append", "[", 
    RowBox[{
     RowBox[{"Notebooks", "[", "]"}], ",", "$FrontEnd"}], "]"}]}], 
  ";"}]}], "Code",
 CellChangeTimes->{{3.618302614681962*^9, 3.618302705214864*^9}, {
  3.618306604758643*^9, 3.618306657196187*^9}, {3.618306710019546*^9, 
  3.6183067310162277`*^9}, {3.618369650413905*^9, 3.618369784022764*^9}, {
  3.6183714344970818`*^9, 3.618371448713976*^9}, {3.618372055117416*^9, 
  3.618372133203678*^9}, {3.6183721649207783`*^9, 3.6183722973279333`*^9}, {
  3.618372360170373*^9, 3.618372371463105*^9}, {3.618372471791008*^9, 
  3.6183724918334846`*^9}, {3.618372538362843*^9, 3.618372555264423*^9}, {
  3.61837282246799*^9, 3.61837283817949*^9}, {3.618411167631175*^9, 
  3.618411211782855*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Definitions", "Section",
 CellChangeTimes->{{3.5968160022715273`*^9, 3.59681600370494*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Evaluate", "@", 
    RowBox[{"Table", "[", 
     RowBox[{
      TagBox[GridBox[{
         {GridBox[{
            {"\[DoubleStruckG]"}
           },
           Selectable->True], 
          StyleBox[GridBox[{
             {"", ""},
             {"\[Mu]", "\[Nu]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRETsr",
       Selectable->False], ",", 
      RowBox[{"{", 
       RowBox[{"\[Mu]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Nu]", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}], " ", "=",
    " ", "\[DoubleStruckG]Mat"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"\[DoubleStruckG]uuMat", " ", "=", " ", 
   RowBox[{
    RowBox[{"Inverse", "@", "\[DoubleStruckG]Mat"}], "//", "Simp"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Evaluate", "@", 
    RowBox[{"Table", "[", 
     RowBox[{
      TagBox[GridBox[{
         {GridBox[{
            {"\[DoubleStruckG]"}
           },
           Selectable->True], 
          StyleBox[GridBox[{
             {"\[Mu]", "\[Nu]"},
             {"", ""}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRETsr",
       Selectable->False], ",", 
      RowBox[{"{", 
       RowBox[{"\[Mu]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Nu]", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}], " ", "=",
    " ", "\[DoubleStruckG]uuMat"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"\[DoubleStruckG]", "[", "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"Det", "[", "\[DoubleStruckG]Mat", "]"}], "//", "Simp"}]}], 
  ";"}]}], "Code",
 CellChangeTimes->{{3.618311593936286*^9, 3.618311610903558*^9}, {
   3.618311672300123*^9, 3.618311869096156*^9}, {3.618311982008803*^9, 
   3.618312001217124*^9}, {3.618312538450492*^9, 3.618312544905871*^9}, {
   3.6183128804438467`*^9, 3.61831289920168*^9}, {3.618313119920021*^9, 
   3.6183131433547173`*^9}, {3.618313960328596*^9, 3.618313961559203*^9}, 
   3.618313993293768*^9, {3.6183145727495623`*^9, 3.6183145775367327`*^9}, {
   3.618369832838915*^9, 3.6183698622267647`*^9}, {3.618371985362698*^9, 
   3.6183720009070063`*^9}}],

Cell[BoxData[
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Sigma]", ",", "\[Eta]", ",", "\[Lambda]", ",", "\[Mu]"}], 
    "}"}], ",", " ", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Protect", " ", "those", " ", "variables", " ", "in", " ", "case", " ", 
     "the", " ", "users", " ", "give", " ", "meaning", " ", "to", " ", 
     RowBox[{"them", "."}]}], " ", "*)"}], "\n", "\t", 
   RowBox[{
    RowBox[{
     TagBox[GridBox[{
        {GridBox[{
           {"\[CapitalGamma]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"\[Lambda]_", "", ""},
            {"", "\[Mu]_", "\[Nu]_"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False], " ", ":=", " ", 
     RowBox[{
      TagBox[GridBox[{
         {GridBox[{
            {"\[CapitalGamma]"}
           },
           Selectable->True], 
          StyleBox[GridBox[{
             {"\[Lambda]", "", ""},
             {"", "\[Mu]", "\[Nu]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRETsr",
       Selectable->False], " ", "=", 
      RowBox[{
       TagBox[GridBox[{
          {GridBox[{
             {
              RowBox[{" ", "\[CapitalGamma]"}]}
            },
            Selectable->True], 
           StyleBox[GridBox[{
              {"\[Lambda]", "", ""},
              {"", "\[Nu]", "\[Mu]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRETsr",
        Selectable->False], " ", "=", " ", 
       RowBox[{"Simp", "[", 
        RowBox[{
         UnderoverscriptBox["\[Sum]", "\[Sigma]", "\[DoubleStruckX]"], " ", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          TagBox[GridBox[{
             {GridBox[{
                {"\[DoubleStruckG]"}
               },
               Selectable->True], 
              StyleBox[GridBox[{
                 {"\[Lambda]", "\[Sigma]"},
                 {"", ""}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                Selectable->True],
               FontSize->10]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           "GRETsr",
           Selectable->False], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             SubscriptBox["\[PartialD]", "\[Mu]"], 
             TagBox[GridBox[{
                {GridBox[{
                   {"\[DoubleStruckG]"}
                  },
                  Selectable->True], 
                 StyleBox[GridBox[{
                    {"", ""},
                    {"\[Sigma]", "\[Nu]"}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                   Selectable->True],
                  FontSize->10]}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              "GRETsr",
              Selectable->False]}], " ", "+", " ", 
            RowBox[{
             SubscriptBox["\[PartialD]", "\[Nu]"], 
             TagBox[GridBox[{
                {GridBox[{
                   {"\[DoubleStruckG]"}
                  },
                  Selectable->True], 
                 StyleBox[GridBox[{
                    {"", ""},
                    {"\[Sigma]", "\[Mu]"}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                   Selectable->True],
                  FontSize->10]}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              "GRETsr",
              Selectable->False]}], " ", "-", " ", 
            RowBox[{
             SubscriptBox["\[PartialD]", "\[Sigma]"], 
             TagBox[GridBox[{
                {GridBox[{
                   {"\[DoubleStruckG]"}
                  },
                  Selectable->True], 
                 StyleBox[GridBox[{
                    {"", ""},
                    {"\[Mu]", "\[Nu]"}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                   Selectable->True],
                  FontSize->10]}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              "GRETsr",
              Selectable->False]}]}], ")"}]}]}], "]"}]}]}]}], ";", "\n", "\t", 
    RowBox[{
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalR]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"\[Lambda]_", "", "", ""},
            {"", "\[Mu]_", "\[Sigma]_", "\[Nu]_"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False], ":=", " ", 
     RowBox[{
      TagBox[GridBox[{
         {GridBox[{
            {"\[DoubleStruckCapitalR]"}
           },
           Selectable->True], 
          StyleBox[GridBox[{
             {"\[Lambda]", "", "", ""},
             {"", "\[Mu]", "\[Sigma]", "\[Nu]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRETsr",
       Selectable->False], " ", "=", " ", 
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckCapitalR]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"\[Lambda]", "", "", ""},
                {"", "\[Mu]", "\[Sigma]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False], " ", "=", " ", 
         RowBox[{"Simp", "[", 
          RowBox[{
           RowBox[{
            SubscriptBox["\[PartialD]", "\[Nu]"], 
            TagBox[GridBox[{
               {GridBox[{
                  {"\[CapitalGamma]"}
                 },
                 Selectable->True], 
                StyleBox[GridBox[{
                   {"\[Lambda]", "", ""},
                   {"", "\[Mu]", "\[Sigma]"}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                  Selectable->True],
                 FontSize->10]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             "GRETsr",
             Selectable->False]}], " ", "-", " ", 
           RowBox[{
            SubscriptBox["\[PartialD]", "\[Sigma]"], 
            TagBox[GridBox[{
               {GridBox[{
                  {"\[CapitalGamma]"}
                 },
                 Selectable->True], 
                StyleBox[GridBox[{
                   {"\[Lambda]", "", ""},
                   {"", "\[Mu]", "\[Nu]"}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                  Selectable->True],
                 FontSize->10]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             "GRETsr",
             Selectable->False]}], " ", "+", " ", 
           RowBox[{
            UnderoverscriptBox["\[Sum]", "\[Eta]", "\[DoubleStruckX]"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               TagBox[GridBox[{
                  {GridBox[{
                    {"\[CapitalGamma]"}
                    },
                    Selectable->True], 
                   StyleBox[GridBox[{
                    {"\[Eta]", "", ""},
                    {"", "\[Mu]", "\[Sigma]"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                    Selectable->True],
                    FontSize->10]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                "GRETsr",
                Selectable->False], 
               TagBox[GridBox[{
                  {GridBox[{
                    {"\[CapitalGamma]"}
                    },
                    Selectable->True], 
                   StyleBox[GridBox[{
                    {"\[Lambda]", "", ""},
                    {"", "\[Eta]", "\[Nu]"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                    Selectable->True],
                    FontSize->10]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                "GRETsr",
                Selectable->False]}], " ", "-", " ", 
              RowBox[{
               TagBox[GridBox[{
                  {GridBox[{
                    {"\[CapitalGamma]"}
                    },
                    Selectable->True], 
                   StyleBox[GridBox[{
                    {"\[Eta]", "", ""},
                    {"", "\[Mu]", "\[Nu]"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                    Selectable->True],
                    FontSize->10]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                "GRETsr",
                Selectable->False], 
               TagBox[GridBox[{
                  {GridBox[{
                    {"\[CapitalGamma]"}
                    },
                    Selectable->True], 
                   StyleBox[GridBox[{
                    {"\[Lambda]", "", ""},
                    {"", "\[Eta]", "\[Sigma]"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                    Selectable->True],
                    FontSize->10]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                "GRETsr",
                Selectable->False]}]}], ")"}]}]}], "]"}]}], ")"}]}]}]}], ";", 
    "\n", "\t", 
    RowBox[{
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalR]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"", "", "", ""},
            {"\[Rho]_", "\[Mu]_", "\[Sigma]_", "\[Nu]_"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False], ":=", " ", 
     RowBox[{
      TagBox[GridBox[{
         {GridBox[{
            {"\[DoubleStruckCapitalR]"}
           },
           Selectable->True], 
          StyleBox[GridBox[{
             {"", "", "", ""},
             {"\[Rho]", "\[Mu]", "\[Sigma]", "\[Nu]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRETsr",
       Selectable->False], " ", "=", " ", 
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckCapitalR]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"", "", "", ""},
                {"\[Rho]", "\[Mu]", "\[Nu]", "\[Sigma]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False], " ", "=", " ", 
         RowBox[{"Simp", "[", 
          RowBox[{
           UnderoverscriptBox["\[Sum]", "\[Lambda]", "\[DoubleStruckX]"], " ", 
           RowBox[{
            TagBox[GridBox[{
               {GridBox[{
                  {"\[DoubleStruckG]"}
                 },
                 Selectable->True], 
                StyleBox[GridBox[{
                   {"", ""},
                   {"\[Rho]", "\[Lambda]"}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                  Selectable->True],
                 FontSize->10]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             "GRETsr",
             Selectable->False], 
            TagBox[GridBox[{
               {GridBox[{
                  {"\[DoubleStruckCapitalR]"}
                 },
                 Selectable->True], 
                StyleBox[GridBox[{
                   {"\[Lambda]", "", "", ""},
                   {"", "\[Mu]", "\[Nu]", "\[Sigma]"}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                  Selectable->True],
                 FontSize->10]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             "GRETsr",
             Selectable->False]}]}], "]"}]}], ")"}]}]}]}], ";", "\n", "\t", 
    RowBox[{
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalR]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"", ""},
            {"\[Mu]_", "\[Nu]_"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False], ":=", " ", 
     RowBox[{
      TagBox[GridBox[{
         {GridBox[{
            {"\[DoubleStruckCapitalR]"}
           },
           Selectable->True], 
          StyleBox[GridBox[{
             {"", ""},
             {"\[Mu]", "\[Nu]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRETsr",
       Selectable->False], " ", "=", " ", 
      RowBox[{
       TagBox[GridBox[{
          {GridBox[{
             {"\[DoubleStruckCapitalR]"}
            },
            Selectable->True], 
           StyleBox[GridBox[{
              {"", ""},
              {"\[Nu]", "\[Mu]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRETsr",
        Selectable->False], " ", "=", " ", 
       RowBox[{"Simp", "[", 
        RowBox[{
         UnderoverscriptBox["\[Sum]", "\[Lambda]", "\[DoubleStruckX]"], 
         TagBox[GridBox[{
            {GridBox[{
               {
                RowBox[{" ", "\[DoubleStruckCapitalR]"}]}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"\[Lambda]", "", "", ""},
                {"", "\[Mu]", "\[Lambda]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False]}], "]"}]}]}]}], ";", "\n", "\t", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalR]", "[", "]"}], ":=", " ", 
     RowBox[{"Simp", " ", "@", " ", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckG]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"\[Mu]", "\[Nu]"},
                {"", ""}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False], " ", 
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckCapitalR]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"", ""},
                {"\[Mu]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"\[Mu]", ",", "\[DoubleStruckX]"}], "}"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"\[Nu]", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}]}], ";", 
    "\n", "\t", 
    RowBox[{
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"", ""},
            {"\[Mu]_", "\[Nu]_"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False], ":=", " ", 
     RowBox[{
      TagBox[GridBox[{
         {GridBox[{
            {"\[DoubleStruckCapitalG]"}
           },
           Selectable->True], 
          StyleBox[GridBox[{
             {"", ""},
             {"\[Mu]", "\[Nu]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRETsr",
       Selectable->False], " ", "=", " ", 
      RowBox[{
       RowBox[{
        TagBox[GridBox[{
           {GridBox[{
              {"\[DoubleStruckCapitalR]"}
             },
             Selectable->True], 
            StyleBox[GridBox[{
               {"", ""},
               {"\[Mu]", "\[Nu]"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}},
              Selectable->True],
             FontSize->10]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         "GRETsr",
         Selectable->False], " ", "-", " ", 
        RowBox[{
         FractionBox["1", "2"], 
         TagBox[GridBox[{
            {GridBox[{
               {
                RowBox[{" ", "\[DoubleStruckG]"}]}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"", ""},
                {"\[Mu]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False], " ", 
         RowBox[{"\[DoubleStruckCapitalR]", "[", "]"}]}]}], " ", "//", " ", 
       "Simp"}]}]}], ";", "\n", "\t", 
    RowBox[{
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"\[Lambda]_", ""},
            {"", "\[Nu]_"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False], ":=", " ", 
     RowBox[{
      TagBox[GridBox[{
         {GridBox[{
            {"\[DoubleStruckCapitalG]"}
           },
           Selectable->True], 
          StyleBox[GridBox[{
             {"\[Lambda]", ""},
             {"", "\[Nu]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRETsr",
       Selectable->False], " ", "=", " ", 
      RowBox[{"Simp", "[", 
       RowBox[{
        UnderoverscriptBox["\[Sum]", "\[Mu]", "\[DoubleStruckX]"], " ", 
        RowBox[{
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckG]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"\[Lambda]", "\[Mu]"},
                {"", ""}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False], " ", 
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckCapitalG]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"", ""},
                {"\[Mu]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False]}]}], "]"}]}]}], ";", "\n", "\t", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalX]", "[", "\[Phi]_", "]"}], ":=", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Col", "=", 
        RowBox[{"Col", "~", "Union", "~", 
         RowBox[{"{", 
          RowBox[{"\[Phi]", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"Derivative", "[", "__", "]"}], "[", 
             RowBox[{
             "\[Phi]", "\[LeftDoubleBracket]", "0", "\[RightDoubleBracket]"}],
              "]"}], "[", 
            RowBox[{"Sequence", "@@", "\[Phi]"}], "]"}]}], "}"}]}]}], ";", 
       " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{
             TagBox[GridBox[{
                {GridBox[{
                   {"\[DoubleStruckG]"}
                  },
                  Selectable->True], 
                 StyleBox[GridBox[{
                    {"\[Mu]", "\[Nu]"},
                    {"", ""}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                   Selectable->True],
                  FontSize->10]}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              "GRETsr",
              Selectable->False], " ", 
             RowBox[{
              SubscriptBox["\[PartialD]", "\[Mu]"], "\[Phi]"}], " ", 
             RowBox[{
              SubscriptBox["\[PartialD]", "\[Nu]"], "\[Phi]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Mu]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Nu]", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}], 
         "/", "2"}], "//", "Simp"}]}], ")"}]}], ";", "\n", "\t", 
    RowBox[{"(*", " ", 
     RowBox[{
     "Box", " ", "operator", " ", "actting", " ", "on", " ", "scalar", " ", 
      RowBox[{"only", ".", " ", 
       RowBox[{"(", 
        RowBox[{"Note", " ", "GRE", " ", 
         RowBox[{"doesn", "'"}], "t", " ", "know", " ", "if", " ", "a", " ", 
         "quantity", " ", "is", " ", "a", " ", 
         RowBox[{"scalar", "."}]}], ")"}]}]}], " ", "*)"}], "\n", "\t", 
    RowBox[{
     RowBox[{"SBox", "[", "\[Phi]_", "]"}], ":=", " ", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        TagBox[GridBox[{
           {GridBox[{
              {"\[DoubleStruckG]"}
             },
             Selectable->True], 
            StyleBox[GridBox[{
               {"\[Mu]", "\[Nu]"},
               {"", ""}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}},
              Selectable->True],
             FontSize->10]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         "GRETsr",
         Selectable->False], " ", 
        RowBox[{"(", 
         RowBox[{
          TagBox[GridBox[{
             {"\[PartialD]", 
              StyleBox[GridBox[{
                 {"", ""},
                 {"\[Mu]", "\[Nu]"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                Selectable->True],
               FontSize->10], GridBox[{
                {"\[Phi]"}
               },
               Selectable->True]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           "GRED",
           Selectable->False], " ", "-", " ", 
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{
             TagBox[GridBox[{
                {GridBox[{
                   {"\[CapitalGamma]"}
                  },
                  Selectable->True], 
                 StyleBox[GridBox[{
                    {"\[Lambda]", "", ""},
                    {"", "\[Mu]", "\[Nu]"}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                   Selectable->True],
                  FontSize->10]}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              "GRETsr",
              Selectable->False], " ", 
             RowBox[{
              SubscriptBox["\[PartialD]", "\[Lambda]"], "\[Phi]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Lambda]", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}],
          ")"}]}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"\[Mu]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Nu]", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}], ";"}]}],
   "]"}]], "Code",
 CellChangeTimes->{{3.618313236984089*^9, 3.6183134160802317`*^9}, {
   3.6183134495670443`*^9, 3.618313464379878*^9}, {3.6183135249903603`*^9, 
   3.618313583724022*^9}, {3.618313627030137*^9, 3.6183137301302547`*^9}, {
   3.618313853818022*^9, 3.6183138659293423`*^9}, 3.6183139048875217`*^9, {
   3.618314045927137*^9, 3.61831405069643*^9}, 3.618314094323328*^9, {
   3.6183141297077436`*^9, 3.618314178864382*^9}, {3.618314234918128*^9, 
   3.618314297670576*^9}, {3.6183144136837797`*^9, 3.618314471945118*^9}, {
   3.618314590972781*^9, 3.618314788657434*^9}, {3.618314834414669*^9, 
   3.618314957773066*^9}, {3.6183150534529963`*^9, 3.618315155305622*^9}, 
   3.6183153520652943`*^9, {3.618315395807168*^9, 3.6183153992275467`*^9}, {
   3.618315447271369*^9, 3.6183156187835484`*^9}, {3.618369873885579*^9, 
   3.618369995719673*^9}, {3.618371506933069*^9, 3.6183715295658197`*^9}, {
   3.618371565791396*^9, 3.6183716398539*^9}, {3.6183716766958714`*^9, 
   3.618371735689987*^9}, {3.61837190999683*^9, 3.618371953584238*^9}, {
   3.618372569109784*^9, 3.6183726329323378`*^9}, {3.618372677183824*^9, 
   3.618372810273958*^9}, {3.618372845811915*^9, 3.6183733520435867`*^9}, {
   3.618373975516975*^9, 3.618373986701692*^9}, {3.618374020314473*^9, 
   3.61837415987393*^9}, {3.6972404070734415`*^9, 3.6972405068973584`*^9}, {
   3.69724055375616*^9, 3.697240578271304*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Printing", "Section",
 CellChangeTimes->{{3.618315378770698*^9, 3.6183153796217403`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Print\[CapitalGamma]", "[", "]"}], ":=", " ", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Order", "[", 
          RowBox[{"\[Mu]", ",", "\[Nu]"}], "]"}], "\[GreaterEqual]", "0"}], 
        " ", "&&", " ", 
        RowBox[{
         TagBox[GridBox[{
            {GridBox[{
               {"\[CapitalGamma]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"\[Lambda]", "", ""},
                {"", "\[Mu]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False], "=!=", "0"}]}], ",", " ", 
       RowBox[{"Print", "[", 
        RowBox[{
         RowBox[{"HoldForm", "[", 
          TagBox[GridBox[{
             {GridBox[{
                {"\[CapitalGamma]"}
               },
               Selectable->True], 
              StyleBox[GridBox[{
                 {"\[Lambda]", "", ""},
                 {"", "\[Mu]", "\[Nu]"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                Selectable->True],
               FontSize->10]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           "GRETsr",
           Selectable->False], "]"}], ",", "\"\< = \>\"", ",", " ", 
         TagBox[GridBox[{
            {GridBox[{
               {"\[CapitalGamma]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"\[Lambda]", "", ""},
                {"", "\[Mu]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False]}], "]"}]}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"\[Lambda]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Mu]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Nu]", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Print\[DoubleStruckCapitalR]4", "[", "]"}], ":=", " ", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Order", "[", 
          RowBox[{"\[Lambda]", ",", "\[Mu]"}], "]"}], ">", "0"}], " ", "&&", 
        " ", 
        RowBox[{
         RowBox[{"Order", "[", 
          RowBox[{"\[Nu]", ",", "\[Rho]"}], "]"}], ">", "0"}], " ", "&&", " ", 
        RowBox[{
         RowBox[{"Order", "[", 
          RowBox[{"\[Lambda]", ",", "\[Nu]"}], "]"}], "\[GreaterEqual]", 
         "0"}], " ", "&&", " ", 
        RowBox[{
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckCapitalR]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"", "", "", ""},
                {"\[Lambda]", "\[Mu]", "\[Nu]", "\[Rho]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False], "=!=", "0"}]}], ",", " ", 
       RowBox[{"Print", "[", 
        RowBox[{
         RowBox[{"HoldForm", "[", 
          TagBox[GridBox[{
             {GridBox[{
                {"\[DoubleStruckCapitalR]"}
               },
               Selectable->True], 
              StyleBox[GridBox[{
                 {"", "", "", ""},
                 {"\[Lambda]", "\[Mu]", "\[Nu]", "\[Rho]"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                Selectable->True],
               FontSize->10]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           "GRETsr",
           Selectable->False], "]"}], ",", " ", "\"\< = \>\"", ",", " ", 
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckCapitalR]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"", "", "", ""},
                {"\[Lambda]", "\[Mu]", "\[Nu]", "\[Rho]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False]}], "]"}]}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"\[Lambda]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Mu]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Nu]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Print\[DoubleStruckCapitalR]2", "[", "]"}], ":=", " ", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Order", "[", 
          RowBox[{"\[Mu]", ",", "\[Nu]"}], "]"}], "\[GreaterEqual]", "0"}], 
        " ", "&&", " ", 
        RowBox[{
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckCapitalR]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"", ""},
                {"\[Mu]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False], "=!=", "0"}]}], ",", " ", 
       RowBox[{"Print", "[", 
        RowBox[{
         RowBox[{"HoldForm", "[", 
          TagBox[GridBox[{
             {GridBox[{
                {"\[DoubleStruckCapitalR]"}
               },
               Selectable->True], 
              StyleBox[GridBox[{
                 {"", ""},
                 {"\[Mu]", "\[Nu]"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                Selectable->True],
               FontSize->10]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           "GRETsr",
           Selectable->False], "]"}], ",", " ", "\"\< = \>\"", ",", " ", 
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckCapitalR]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"", ""},
                {"\[Mu]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False]}], "]"}]}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"\[Mu]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Nu]", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Print\[DoubleStruckCapitalG]", "[", "]"}], ":=", " ", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Order", "[", 
          RowBox[{"\[Mu]", ",", "\[Nu]"}], "]"}], "\[GreaterEqual]", "0"}], 
        " ", "&&", 
        RowBox[{
         TagBox[GridBox[{
            {GridBox[{
               {
                RowBox[{" ", "\[DoubleStruckCapitalG]"}]}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"", ""},
                {"\[Mu]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False], "=!=", "0"}]}], ",", " ", 
       RowBox[{"Print", "[", 
        RowBox[{
         RowBox[{"HoldForm", "[", 
          TagBox[GridBox[{
             {GridBox[{
                {"\[DoubleStruckCapitalG]"}
               },
               Selectable->True], 
              StyleBox[GridBox[{
                 {"", ""},
                 {"\[Mu]", "\[Nu]"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                Selectable->True],
               FontSize->10]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           "GRETsr",
           Selectable->False], "]"}], ",", " ", "\"\< = \>\"", ",", " ", 
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckCapitalG]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"", ""},
                {"\[Mu]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False]}], "]"}]}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"\[Mu]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Nu]", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Print\[DoubleStruckCapitalG]ud", "[", "]"}], ":=", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        TagBox[GridBox[{
           {GridBox[{
              {"\[DoubleStruckCapitalG]"}
             },
             Selectable->True], 
            StyleBox[GridBox[{
               {"\[Lambda]", ""},
               {"", "\[Nu]"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}},
              Selectable->True],
             FontSize->10]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         "GRETsr",
         Selectable->False], "=!=", "0"}], ",", " ", 
       RowBox[{"Print", "[", 
        RowBox[{
         RowBox[{"HoldForm", "[", 
          TagBox[GridBox[{
             {GridBox[{
                {"\[DoubleStruckCapitalG]"}
               },
               Selectable->True], 
              StyleBox[GridBox[{
                 {"\[Lambda]", ""},
                 {"", "\[Nu]"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                Selectable->True],
               FontSize->10]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           "GRETsr",
           Selectable->False], "]"}], ",", " ", "\"\< = \>\"", ",", " ", 
         TagBox[GridBox[{
            {GridBox[{
               {"\[DoubleStruckCapitalG]"}
              },
              Selectable->True], 
             StyleBox[GridBox[{
                {"\[Lambda]", ""},
                {"", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRETsr",
          Selectable->False]}], "]"}]}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"\[Lambda]", ",", "\[DoubleStruckX]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Nu]", ",", "\[DoubleStruckX]"}], "}"}]}], "]"}]}], 
  ";"}]}], "Code",
 CellChangeTimes->{{3.618317031854919*^9, 3.618317050862632*^9}, {
   3.6183170872453423`*^9, 3.6183173470561457`*^9}, 3.618317550458213*^9, {
   3.6183176723942738`*^9, 3.618317798555935*^9}, {3.618318043057897*^9, 
   3.618318122075499*^9}, {3.618373505219132*^9, 3.618373678085907*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tools", "Section",
 CellChangeTimes->{{3.596825908431141*^9, 3.596825909334065*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CalcEom", "::", "usage"}], ":=", 
  "\"\<calcEom[lag,v] calcualtes the variatioin principle for Lagrangian lag, \
wrt variable v.\>\""}], "\n", 
 RowBox[{
  RowBox[{"CalcEom", "[", 
   RowBox[{"lag_", ",", "v_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"d", ",", "ep", ",", "l1", ",", "l1ibp"}], "}"}], ",", 
    "\[IndentingNewLine]", "\t", 
    RowBox[{
     RowBox[{"l1", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"Expand", "@", 
         RowBox[{"Coefficient", "[", 
          RowBox[{"#", ",", "ep", ",", "1"}], "]"}]}], "&"}], "@", 
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{"lag", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Derivative", "[", "n__", "]"}], "[", "v", "]"}], "[", 
              "x__", "]"}], "\[RuleDelayed]", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"Derivative", "[", "n", "]"}], "[", "v", "]"}], "[", 
               "x", "]"}], "+", 
              RowBox[{"ep", "*", 
               RowBox[{
                RowBox[{
                 RowBox[{"Derivative", "[", "n", "]"}], "[", "d", "]"}], "[", 
                "x", "]"}]}]}]}], ",", 
            RowBox[{
             RowBox[{"v", "[", "x__", "]"}], "\[RuleDelayed]", 
             RowBox[{
              RowBox[{"v", "[", "x", "]"}], "+", 
              RowBox[{"ep", "*", 
               RowBox[{"d", "[", "x", "]"}]}]}]}], ",", 
            RowBox[{"v", "\[RuleDelayed]", 
             RowBox[{"v", "+", 
              RowBox[{"ep", "*", "d"}]}]}]}], "}"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"ep", ",", "0", ",", "1"}], "}"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", "\t", 
     RowBox[{"l1ibp", "=", 
      RowBox[{"l1", " ", "/.", " ", 
       RowBox[{"{", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"f_", "*", 
           RowBox[{
            RowBox[{
             RowBox[{"Derivative", "[", "n__", "]"}], "[", "g_", "]"}], "[", 
            "x__", "]"}]}], "/;", 
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"f", ",", "d"}], "]"}], "&&", 
           RowBox[{"!", 
            RowBox[{"FreeQ", "[", 
             RowBox[{"g", ",", "d"}], "]"}]}]}]}], " ", "\[RuleDelayed]", " ", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"Total", "@", 
            RowBox[{"{", "n", "}"}]}]], "*", 
          RowBox[{"D", "[", 
           RowBox[{"f", ",", " ", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"Transpose", "@", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", "x", "}"}], ",", 
                RowBox[{"{", "n", "}"}]}], "}"}]}]}]}], "]"}], "*", 
          RowBox[{"g", "[", "x", "]"}]}]}], " ", "}"}]}]}], ";", 
     "\[IndentingNewLine]", "\t", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "l1ibp"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"d", "[", "x__", "]"}], "\[Rule]", "1"}], ",", 
         RowBox[{"d", "\[Rule]", "1"}]}], "}"}]}], "//", "Simp"}]}]}], 
   "]"}]}]}], "Code",
 CellChangeTimes->{{3.581049090494461*^9, 3.581049196226832*^9}, {
   3.58104928831408*^9, 3.5810494484561033`*^9}, {3.5810494814634438`*^9, 
   3.5810494958395576`*^9}, {3.581049530159754*^9, 3.581049547108643*^9}, {
   3.581049600304757*^9, 3.581049713111333*^9}, {3.5810497594081593`*^9, 
   3.581049815439609*^9}, 3.581049881855859*^9, {3.5810499742612333`*^9, 
   3.581050031021865*^9}, {3.581050063333228*^9, 3.581050096438066*^9}, {
   3.5810503245799026`*^9, 3.58105042632964*^9}, {3.581050464207501*^9, 
   3.5810505684762278`*^9}, {3.58105071582347*^9, 3.581050761993168*^9}, {
   3.5810509716564283`*^9, 3.581050985003119*^9}, {3.581051023301396*^9, 
   3.581051037541285*^9}, 3.5810512965260553`*^9, {3.581051395853797*^9, 
   3.581051410368412*^9}, {3.58105161540977*^9, 3.581051618033208*^9}, {
   3.5810516653298388`*^9, 3.581051676059207*^9}, {3.581051710137732*^9, 
   3.5810517626284103`*^9}, {3.5810519778275146`*^9, 3.581051996259972*^9}, {
   3.5810610657863703`*^9, 3.5810611185287333`*^9}, {3.5810611538526497`*^9, 
   3.581061161474931*^9}, {3.596826501832893*^9, 3.5968265241673717`*^9}, {
   3.596845707178609*^9, 3.5968457083325567`*^9}, {3.596847459837471*^9, 
   3.596847571044083*^9}, {3.596847652691854*^9, 3.596847656414328*^9}, {
   3.596847707663848*^9, 3.5968477424568443`*^9}, 3.596847875615497*^9, 
   3.596848147413177*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CollectD", "::", "usage"}], ":=", 
  "\"\<CollectD[expr] collects derivatives using the rules defined in cond.\>\
\""}], "\n", 
 RowBox[{
  RowBox[{"CollectD", "[", "expr_", "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"f", ",", " ", "cond", ",", " ", "vars", ",", " ", "ass"}], 
     "}"}], ",", " ", "\n", "\t", 
    RowBox[{
     RowBox[{"cond", " ", "=", " ", 
      RowBox[{"{", "\n", "\t\t", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Derivative", "[", 
            RowBox[{"0", ",", "2", ",", "0", ",", "0"}], "]"}], "[", "f", 
           "]"}], "@@", "\[DoubleStruckX]"}], " ", "+", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"Derivative", "[", 
            RowBox[{"0", ",", "0", ",", "2", ",", "0"}], "]"}], "[", "f", 
           "]"}], "@@", "\[DoubleStruckX]"}], " ", "+", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"Derivative", "[", 
            RowBox[{"0", ",", "0", ",", "0", ",", "2"}], "]"}], "[", "f", 
           "]"}], "@@", " ", "\[DoubleStruckX]"}]}], " ", "==", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalSampi]", "[", "\"\<ii\>\"", "]"}], "[", "f", 
          "]"}], "@@", "\[DoubleStruckX]"}]}], "}"}]}], ";", "\n", "\t", 
     RowBox[{"vars", " ", "=", " ", 
      RowBox[{"Union", "@", 
       RowBox[{"Cases", "[", 
        RowBox[{"expr", ",", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Derivative", "[", "__", "]"}], "[", "e_", "]"}], "[", 
           "__", "]"}], " ", ":>", " ", "e"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"0", ",", "Infinity"}], "}"}]}], "]"}]}]}], ";", "\n", "\t", 
     RowBox[{"ass", " ", "=", " ", 
      RowBox[{"And", " ", "@@", " ", 
       RowBox[{"Flatten", "[", 
        RowBox[{"cond", " ", "/.", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"f", " ", "->", " ", "#"}], " ", "&"}], " ", "/@", " ", 
           "vars"}], ")"}]}], "]"}]}]}], ";", "\n", "\t", 
     RowBox[{"Simplify", "[", 
      RowBox[{"expr", ",", " ", "ass"}], "]"}]}]}], "]"}]}]}], "Code",
 CellChangeTimes->{{3.601745749883206*^9, 3.601745860819318*^9}, {
  3.601745910321591*^9, 3.601745941447542*^9}, {3.6017463898869247`*^9, 
  3.601746390418285*^9}, {3.6017466459804993`*^9, 3.6017466977402678`*^9}, {
  3.601746737200158*^9, 3.6017467376624393`*^9}}]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{2592, 1740},
WindowMargins->{{-13, Automatic}, {Automatic, -13}},
ShowSelection->True,
InputAliases->{"addia" -> RowBox[{"AddInputAlias", "[", 
     RowBox[{"\"\[SelectionPlaceholder]\"", "\[Rule]", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], "bra" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "Bra"], "braket" -> 
  TemplateBox[{"\[SelectionPlaceholder]", "\[Placeholder]"}, "BraKet"], 
  "cbrt" -> RadicalBox[
   "\[SelectionPlaceholder]", "3", SurdForm -> True, MultilineFunction -> 
    None], "del." -> RowBox[{
     SubscriptBox["\[Del]", "\[SelectionPlaceholder]"], ".", 
     "\[Placeholder]"}], "del2" -> RowBox[{
     SubsuperscriptBox["\[Del]", "\[SelectionPlaceholder]", 2], 
     "\[Placeholder]"}], "delay" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "SystemsModelDelay"], "delx" -> 
  RowBox[{
     SubscriptBox["\[Del]", "\[SelectionPlaceholder]"], "\[Cross]", 
     "\[Placeholder]"}], "dintt" -> RowBox[{
     SubsuperscriptBox[
     "\[Integral]", "\[SelectionPlaceholder]", "\[Placeholder]"], 
     RowBox[{"\[Placeholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "dt" -> RowBox[{
     SubscriptBox["\[PartialD]", "\[Placeholder]"], " ", 
     "\[SelectionPlaceholder]"}], "e0" -> TagBox[
    StyleBox["\[SelectionPlaceholder]", 
     RGBColor[0.5, 0, 0.5]], "GREFX0", Selectable -> False], "ed" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{""}, {"\[Placeholder]"}}, ColumnSpacings -> 0, RowSpacings -> 
         0, Selectable -> True], FontSize -> 10]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0], "GRETsr", Selectable -> False], "edd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"", ""}, {"\[Placeholder]", "\[Placeholder]"}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "edddd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"", "", "", ""}, {
          "\[Placeholder]", "\[Placeholder]", "\[Placeholder]", 
           "\[Placeholder]"}}, ColumnSpacings -> 0, RowSpacings -> 0, 
         Selectable -> True], FontSize -> 10]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0], "GRETsr", Selectable -> False], "edu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"", "\[Placeholder]"}, {"\[Placeholder]", ""}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "ep" -> RowBox[{
     SubscriptBox["\[PartialD]", 
      RowBox[{"\[SelectionPlaceholder]"}]], "\[Placeholder]"}], "et" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]"}, {"\[Placeholder]"}}, ColumnSpacings -> 0,
          RowSpacings -> 0, Selectable -> True], FontSize -> 10]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> False], 
  "eu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]"}, {""}}, ColumnSpacings -> 0, RowSpacings -> 
         0, Selectable -> True], FontSize -> 10]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0], "GRETsr", Selectable -> False], "eud" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", ""}, {"", "\[Placeholder]"}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "eudd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", "", ""}, {
          "", "\[Placeholder]", "\[Placeholder]"}}, ColumnSpacings -> 0, 
         RowSpacings -> 0, Selectable -> True], FontSize -> 10]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> False], 
  "euddd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", "", "", ""}, {
          "", "\[Placeholder]", "\[Placeholder]", "\[Placeholder]"}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "euu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", "\[Placeholder]"}, {"", ""}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "ex" -> TagBox[
    StyleBox["\[SelectionPlaceholder]", 
     RGBColor[1, 0, 0]], "GREFX", Selectable -> False], "f0" -> TagBox[
    StyleBox["\[SelectionPlaceholder]", 
     RGBColor[0.5, 0, 0.5]], "GREFX0"], "fx" -> TagBox[
    StyleBox["\[SelectionPlaceholder]", 
     RGBColor[1, 0, 0]], "GREFX"], "grad" -> RowBox[{
     SubscriptBox["\[Del]", "\[SelectionPlaceholder]"], "\[Placeholder]"}], 
  "ia" -> TemplateBox[{"\[SelectionPlaceholder]"}, "Inactive"], 
  "infixnotation" -> RowBox[{"InfixNotation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], ",", 
       "\[Placeholder]"}], "]"}], "intt" -> RowBox[{"\[Integral]", 
     RowBox[{"\[SelectionPlaceholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "ket" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "Ket"], "madeboxeswraper" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "NotationMadeBoxesTag"], 
  "notation" -> RowBox[{"Notation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], " ", 
       "\[DoubleLongLeftRightArrow]", " ", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], 
  "notation<" -> RowBox[{"Notation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], " ", 
       "\[DoubleLongLeftArrow]", " ", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], 
  "notation>" -> RowBox[{"Notation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], " ", 
       "\[DoubleLongRightArrow]", " ", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], 
  "pattwraper" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "NotationPatternTag"], "pp" -> 
  RowBox[{
     SubscriptBox["\[PartialD]", 
      RowBox[{"\[SelectionPlaceholder]"}]], "\[Placeholder]"}], "prodt" -> 
  RowBox[{
     UnderoverscriptBox["\[Product]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "sumt" -> RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "surd" -> 
  RadicalBox[
   "\[SelectionPlaceholder]", "\[Placeholder]", SurdForm -> True, 
    MultilineFunction -> None], "symb" -> RowBox[{"Symbolize", "[", 
     TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], "]"}], 
  "td" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{""}, {"\[Placeholder]"}}, ColumnSpacings -> 0, RowSpacings -> 
         0, Selectable -> True], FontSize -> 10]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0], "GRETsr", Selectable -> False], "tdd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"", ""}, {"\[Placeholder]", "\[Placeholder]"}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "tdddd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"", "", "", ""}, {
          "\[Placeholder]", "\[Placeholder]", "\[Placeholder]", 
           "\[Placeholder]"}}, ColumnSpacings -> 0, RowSpacings -> 0, 
         Selectable -> True], FontSize -> 10]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0], "GRETsr", Selectable -> False], "tdu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"", "\[Placeholder]"}, {"\[Placeholder]", ""}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "tt" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]"}, {"\[Placeholder]"}}, ColumnSpacings -> 0,
          RowSpacings -> 0, Selectable -> True], FontSize -> 10]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> False], 
  "tu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]"}, {""}}, ColumnSpacings -> 0, RowSpacings -> 
         0, Selectable -> True], FontSize -> 10]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0], "GRETsr", Selectable -> False], "tud" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", ""}, {"", "\[Placeholder]"}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "tudd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", "", ""}, {
          "", "\[Placeholder]", "\[Placeholder]"}}, ColumnSpacings -> 0, 
         RowSpacings -> 0, Selectable -> True], FontSize -> 10]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> False], 
  "tuddd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", "", "", ""}, {
          "", "\[Placeholder]", "\[Placeholder]", "\[Placeholder]"}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "tuu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", "\[Placeholder]"}, {"", ""}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False]},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (July 28, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 873, 19, 88, "Input"],
Cell[1433, 41, 358, 9, 47, "Input"],
Cell[CellGroupData[{
Cell[1816, 54, 101, 1, 111, "Section"],
Cell[1920, 57, 363, 7, 65, "Code"],
Cell[2286, 66, 964, 23, 103, "Code"],
Cell[3253, 91, 1139, 26, 103, "Code"],
Cell[4395, 119, 3587, 84, 177, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8019, 208, 96, 1, 111, "Section"],
Cell[CellGroupData[{
Cell[8140, 213, 119, 1, 80, "Subsection"],
Cell[8262, 216, 7861, 158, 214, "Code"],
Cell[16126, 376, 5551, 101, 103, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21714, 482, 113, 1, 80, "Subsection"],
Cell[21830, 485, 563, 12, 122, "Text"],
Cell[22396, 499, 118, 1, 47, "Text"],
Cell[22517, 502, 3988, 98, 288, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26542, 605, 106, 1, 80, "Subsection"],
Cell[26651, 608, 278, 6, 83, "Text"],
Cell[26932, 616, 1708, 41, 103, "Code"],
Cell[28643, 659, 1753, 44, 103, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30433, 708, 103, 1, 80, "Subsection"],
Cell[30539, 711, 157, 2, 47, "Text"],
Cell[30699, 715, 7744, 179, 622, "Code"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[38492, 900, 97, 1, 111, "Section"],
Cell[38592, 903, 3474, 97, 194, "Code"],
Cell[42069, 1002, 48437, 1305, 781, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90543, 2312, 95, 1, 111, "Section"],
Cell[90641, 2315, 20337, 553, 253, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[111015, 2873, 90, 1, 111, "Section"],
Cell[111108, 2876, 4641, 111, 228, "Code"],
Cell[115752, 2989, 2479, 61, 288, "Code"]
}, Open  ]]
}
]
*)

