(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    460818,      13258]
NotebookOptionsPosition[    420718,      12367]
NotebookOutlinePosition[    454904,      13081]
CellTagsIndexPosition[    454861,      13078]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"SetDirectory", "@", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6971964379756*^9, 3.69719645244051*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[DoubleStruckX]", "=", 
   RowBox[{"{", 
    RowBox[{"t", ",", "x", ",", "y", ",", "z"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"\[DoubleStruckD]s2", "=", 
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox[
      RowBox[{"\[DoubleStruckD]", "[", "t", "]"}], "2"]}], "+", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"a", "[", "t", "]"}], "2"], 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"\[DoubleStruckD]", "[", "x", "]"}], "2"], "+", 
       SuperscriptBox[
        RowBox[{"\[DoubleStruckD]", "[", "y", "]"}], "2"], "+", 
       SuperscriptBox[
        RowBox[{"\[DoubleStruckD]", "[", "z", "]"}], "2"]}], ")"}]}]}]}], 
  ";"}], "\n", 
 RowBox[{"<<", "GRE.m"}]}], "Input",
 CellChangeTimes->{3.6971979860634866`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"t", ",", "x", ",", "y", ",", "z"}], "]"}], ",", "t"}], 
  "]"}]], "Input"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[PartialD]", 
     StyleBox[GridBox[{
        {""},
        {"t"}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}},
       Selectable->True],
      FontSize->10], GridBox[{
       {
        TagBox[
         StyleBox["f",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False]}
      },
      Selectable->True]}
   },
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  "GRED",
  Selectable->False]], "Output",
 CellChangeTimes->{
  3.6971964805351295`*^9, 3.697197762155507*^9, {3.69719796789827*^9, 
   3.6971979964348083`*^9}, 3.6972406099275303`*^9, 3.6972411958225718`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"\[DoubleStruckCapitalR]", "[", "]"}], "//", 
  "AbsoluteTiming"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.04558812126692154`", ",", 
   FractionBox[
    RowBox[{"6", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        TagBox[
         StyleBox[
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None],
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"], "+", 
       RowBox[{
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], " ", 
        TagBox[
         StyleBox[
          SuperscriptBox["a", "\[Prime]\[Prime]",
           MultilineFunction->None],
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False]}]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}], "}"}]], "Output",
 CellChangeTimes->{
  3.697196486416119*^9, 3.6971977621928186`*^9, {3.6971979679451685`*^9, 
   3.6971979964776907`*^9}, 3.69724060997441*^9, 3.697241195886626*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Print\[CapitalGamma]", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"t", "", ""},
           {"", "x", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], " ", 
    TagBox[
     StyleBox[
      SuperscriptBox["a", "\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`a[$CellContext`t] 
   Derivative[1][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196494200879*^9, 3.6971977622240744`*^9, {3.6971979679824553`*^9, 
   3.6971979965102873`*^9}, 3.6972406099900446`*^9, 3.6972411959186263`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"t", "", ""},
           {"", "y", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], " ", 
    TagBox[
     StyleBox[
      SuperscriptBox["a", "\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`a[$CellContext`t] 
   Derivative[1][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196494200879*^9, 3.6971977622240744`*^9, {3.6971979679824553`*^9, 
   3.6971979965102873`*^9}, 3.6972406099900446`*^9, 3.697241195922627*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"t", "", ""},
           {"", "z", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], " ", 
    TagBox[
     StyleBox[
      SuperscriptBox["a", "\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`a[$CellContext`t] 
   Derivative[1][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196494200879*^9, 3.6971977622240744`*^9, {3.6971979679824553`*^9, 
   3.6971979965102873`*^9}, 3.6972406099900446`*^9, 3.69724119593463*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"x", "", ""},
           {"", "t", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    TagBox[
     StyleBox[
      SuperscriptBox["a", "\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], 
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`a[$CellContext`t]^(-1) 
   Derivative[1][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196494200879*^9, 3.6971977622240744`*^9, {3.6971979679824553`*^9, 
   3.6971979965102873`*^9}, 3.6972406099900446`*^9, 3.697241195941142*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"y", "", ""},
           {"", "t", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    TagBox[
     StyleBox[
      SuperscriptBox["a", "\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], 
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`a[$CellContext`t]^(-1) 
   Derivative[1][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196494200879*^9, 3.6971977622240744`*^9, {3.6971979679824553`*^9, 
   3.6971979965102873`*^9}, 3.6972406099900446`*^9, 3.6972411959496613`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"z", "", ""},
           {"", "t", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    TagBox[
     StyleBox[
      SuperscriptBox["a", "\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], 
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`a[$CellContext`t]^(-1) 
   Derivative[1][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196494200879*^9, 3.6971977622240744`*^9, {3.6971979679824553`*^9, 
   3.6971979965102873`*^9}, 3.6972406099900446`*^9, 3.6972411959541736`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Print\[DoubleStruckCapitalR]4", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalR]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", "", "", ""},
           {"t", "x", "t", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", 
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False]}], " ", 
    TagBox[
     StyleBox[
      SuperscriptBox["a", "\[Prime]\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalR], {{
      Null, Null, Null, 
       Null}, {$CellContext`\[Lambda], $CellContext`\[Mu], \
$CellContext`\[Nu], $CellContext`\[Rho]}}]], 
   " = ", -$CellContext`a[$CellContext`t] 
   Derivative[2][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196504671489*^9, 3.6971977622926435`*^9, {3.697197968029862*^9, 
   3.6971979965572753`*^9}, 3.6972406100590754`*^9, 3.6972411959783745`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalR]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", "", "", ""},
           {"t", "y", "t", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", 
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False]}], " ", 
    TagBox[
     StyleBox[
      SuperscriptBox["a", "\[Prime]\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalR], {{
      Null, Null, Null, 
       Null}, {$CellContext`\[Lambda], $CellContext`\[Mu], \
$CellContext`\[Nu], $CellContext`\[Rho]}}]], 
   " = ", -$CellContext`a[$CellContext`t] 
   Derivative[2][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196504671489*^9, 3.6971977622926435`*^9, {3.697197968029862*^9, 
   3.6971979965572753`*^9}, 3.6972406100590754`*^9, 3.697241195982374*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalR]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", "", "", ""},
           {"t", "z", "t", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", 
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False]}], " ", 
    TagBox[
     StyleBox[
      SuperscriptBox["a", "\[Prime]\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalR], {{
      Null, Null, Null, 
       Null}, {$CellContext`\[Lambda], $CellContext`\[Mu], \
$CellContext`\[Nu], $CellContext`\[Rho]}}]], 
   " = ", -$CellContext`a[$CellContext`t] 
   Derivative[2][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196504671489*^9, 3.6971977622926435`*^9, {3.697197968029862*^9, 
   3.6971979965572753`*^9}, 3.6972406100590754`*^9, 3.6972411959903736`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalR]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", "", "", ""},
           {"x", "y", "x", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"], " ", 
    SuperscriptBox[
     TagBox[
      StyleBox[
       SuperscriptBox["a", "\[Prime]",
        MultilineFunction->None],
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalR], {{
      Null, Null, Null, 
       Null}, {$CellContext`\[Lambda], $CellContext`\[Mu], \
$CellContext`\[Nu], $CellContext`\[Rho]}}]], 
   " = ", $CellContext`a[$CellContext`t]^2 
   Derivative[1][$CellContext`a][$CellContext`t]^2],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196504671489*^9, 3.6971977622926435`*^9, {3.697197968029862*^9, 
   3.6971979965572753`*^9}, 3.6972406100590754`*^9, 3.697241195998375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalR]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", "", "", ""},
           {"x", "z", "x", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"], " ", 
    SuperscriptBox[
     TagBox[
      StyleBox[
       SuperscriptBox["a", "\[Prime]",
        MultilineFunction->None],
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalR], {{
      Null, Null, Null, 
       Null}, {$CellContext`\[Lambda], $CellContext`\[Mu], \
$CellContext`\[Nu], $CellContext`\[Rho]}}]], 
   " = ", $CellContext`a[$CellContext`t]^2 
   Derivative[1][$CellContext`a][$CellContext`t]^2],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196504671489*^9, 3.6971977622926435`*^9, {3.697197968029862*^9, 
   3.6971979965572753`*^9}, 3.6972406100590754`*^9, 3.697241196006375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalR]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", "", "", ""},
           {"y", "z", "y", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"], " ", 
    SuperscriptBox[
     TagBox[
      StyleBox[
       SuperscriptBox["a", "\[Prime]",
        MultilineFunction->None],
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalR], {{
      Null, Null, Null, 
       Null}, {$CellContext`\[Lambda], $CellContext`\[Mu], \
$CellContext`\[Nu], $CellContext`\[Rho]}}]], 
   " = ", $CellContext`a[$CellContext`t]^2 
   Derivative[1][$CellContext`a][$CellContext`t]^2],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196504671489*^9, 3.6971977622926435`*^9, {3.697197968029862*^9, 
   3.6971979965572753`*^9}, 3.6972406100590754`*^9, 3.697241196010374*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Print\[DoubleStruckCapitalR]2", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6183182172970963`*^9, 3.618318218739101*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalR]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"t", "t"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", 
      TagBox[
       StyleBox[
        SuperscriptBox["a", "\[Prime]\[Prime]",
         MultilineFunction->None],
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False]}], 
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False]]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalR], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", (-3) $CellContext`a[$CellContext`t]^(-1) 
   Derivative[2][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6971965068333664`*^9, 3.6971977623552985`*^9, {3.697197968083304*^9, 
   3.697197996610174*^9}, 3.697240610128104*^9, 3.697241196026374*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalR]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"x", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"2", " ", 
     SuperscriptBox[
      TagBox[
       StyleBox[
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None],
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}], "+", 
    RowBox[{
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], " ", 
     TagBox[
      StyleBox[
       SuperscriptBox["a", "\[Prime]\[Prime]",
        MultilineFunction->None],
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False]}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalR], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], " = ", 
   2 Derivative[
      1][$CellContext`a][$CellContext`t]^2 + $CellContext`a[$CellContext`t] 
    Derivative[2][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6971965068333664`*^9, 3.6971977623552985`*^9, {3.697197968083304*^9, 
   3.697197996610174*^9}, 3.697240610128104*^9, 3.697241196034376*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalR]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"y", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"2", " ", 
     SuperscriptBox[
      TagBox[
       StyleBox[
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None],
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}], "+", 
    RowBox[{
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], " ", 
     TagBox[
      StyleBox[
       SuperscriptBox["a", "\[Prime]\[Prime]",
        MultilineFunction->None],
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False]}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalR], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], " = ", 
   2 Derivative[
      1][$CellContext`a][$CellContext`t]^2 + $CellContext`a[$CellContext`t] 
    Derivative[2][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6971965068333664`*^9, 3.6971977623552985`*^9, {3.697197968083304*^9, 
   3.697197996610174*^9}, 3.697240610128104*^9, 3.6972411960413957`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalR]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"z", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"2", " ", 
     SuperscriptBox[
      TagBox[
       StyleBox[
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None],
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}], "+", 
    RowBox[{
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], " ", 
     TagBox[
      StyleBox[
       SuperscriptBox["a", "\[Prime]\[Prime]",
        MultilineFunction->None],
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False]}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalR], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], " = ", 
   2 Derivative[
      1][$CellContext`a][$CellContext`t]^2 + $CellContext`a[$CellContext`t] 
    Derivative[2][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6971965068333664`*^9, 3.6971977623552985`*^9, {3.697197968083304*^9, 
   3.697197996610174*^9}, 3.697240610128104*^9, 3.6972411960504093`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Print\[DoubleStruckCapitalG]", "[", "]"}]], "Input",
 CellChangeTimes->{{3.618318213630291*^9, 3.6183182138042097`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"t", "t"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox[
      TagBox[
       StyleBox[
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None],
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], " = ", 
   3 $CellContext`a[$CellContext`t]^(-2) 
   Derivative[1][$CellContext`a][$CellContext`t]^2],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.69719650923346*^9, 3.697197762414077*^9, {3.697197968130184*^9, 
   3.6971979966415224`*^9}, 3.6972406101749916`*^9, 3.69724119610245*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"x", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox[
      TagBox[
       StyleBox[
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None],
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}], "-", 
    RowBox[{"2", " ", 
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], " ", 
     TagBox[
      StyleBox[
       SuperscriptBox["a", "\[Prime]\[Prime]",
        MultilineFunction->None],
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False]}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -Derivative[1][$CellContext`a][$CellContext`t]^2 - 
   2 $CellContext`a[$CellContext`t] 
   Derivative[2][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.69719650923346*^9, 3.697197762414077*^9, {3.697197968130184*^9, 
   3.6971979966415224`*^9}, 3.6972406101749916`*^9, 3.6972411961064463`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"y", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox[
      TagBox[
       StyleBox[
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None],
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}], "-", 
    RowBox[{"2", " ", 
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], " ", 
     TagBox[
      StyleBox[
       SuperscriptBox["a", "\[Prime]\[Prime]",
        MultilineFunction->None],
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False]}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -Derivative[1][$CellContext`a][$CellContext`t]^2 - 
   2 $CellContext`a[$CellContext`t] 
   Derivative[2][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.69719650923346*^9, 3.697197762414077*^9, {3.697197968130184*^9, 
   3.6971979966415224`*^9}, 3.6972406101749916`*^9, 3.6972411961144524`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"z", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox[
      TagBox[
       StyleBox[
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None],
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}], "-", 
    RowBox[{"2", " ", 
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], " ", 
     TagBox[
      StyleBox[
       SuperscriptBox["a", "\[Prime]\[Prime]",
        MultilineFunction->None],
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False]}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -Derivative[1][$CellContext`a][$CellContext`t]^2 - 
   2 $CellContext`a[$CellContext`t] 
   Derivative[2][$CellContext`a][$CellContext`t]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.69719650923346*^9, 3.697197762414077*^9, {3.697197968130184*^9, 
   3.6971979966415224`*^9}, 3.6972406101749916`*^9, 3.6972411961224465`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Print\[DoubleStruckCapitalG]ud", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"t", ""},
           {"", "t"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox[
       TagBox[
        StyleBox[
         SuperscriptBox["a", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], "2"]}], 
     SuperscriptBox[
      TagBox[
       StyleBox["a",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", (-3) $CellContext`a[$CellContext`t]^(-2) 
   Derivative[1][$CellContext`a][$CellContext`t]^2],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6971965111167984`*^9, 3.697197762456666*^9, {3.697197968161439*^9, 
   3.697197996688409*^9}, 3.69724061021276*^9, 3.697241196138447*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"x", ""},
           {"", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       TagBox[
        StyleBox[
         SuperscriptBox["a", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], "2"], "+", 
      RowBox[{"2", " ", 
       TagBox[
        StyleBox["a",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["a", "\[Prime]\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}]}], 
     SuperscriptBox[
      TagBox[
       StyleBox["a",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`a[$CellContext`t]^(-2) (
    Derivative[1][$CellContext`a][$CellContext`t]^2 + 
    2 $CellContext`a[$CellContext`t] 
     Derivative[2][$CellContext`a][$CellContext`t])],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6971965111167984`*^9, 3.697197762456666*^9, {3.697197968161439*^9, 
   3.697197996688409*^9}, 3.69724061021276*^9, 3.697241196154984*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"y", ""},
           {"", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       TagBox[
        StyleBox[
         SuperscriptBox["a", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], "2"], "+", 
      RowBox[{"2", " ", 
       TagBox[
        StyleBox["a",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["a", "\[Prime]\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}]}], 
     SuperscriptBox[
      TagBox[
       StyleBox["a",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`a[$CellContext`t]^(-2) (
    Derivative[1][$CellContext`a][$CellContext`t]^2 + 
    2 $CellContext`a[$CellContext`t] 
     Derivative[2][$CellContext`a][$CellContext`t])],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6971965111167984`*^9, 3.697197762456666*^9, {3.697197968161439*^9, 
   3.697197996688409*^9}, 3.69724061021276*^9, 3.6972411961669865`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"z", ""},
           {"", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       TagBox[
        StyleBox[
         SuperscriptBox["a", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], "2"], "+", 
      RowBox[{"2", " ", 
       TagBox[
        StyleBox["a",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["a", "\[Prime]\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}]}], 
     SuperscriptBox[
      TagBox[
       StyleBox["a",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`a[$CellContext`t]^(-2) (
    Derivative[1][$CellContext`a][$CellContext`t]^2 + 
    2 $CellContext`a[$CellContext`t] 
     Derivative[2][$CellContext`a][$CellContext`t])],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6971965111167984`*^9, 3.697197762456666*^9, {3.697197968161439*^9, 
   3.697197996688409*^9}, 3.69724061021276*^9, 3.697241196170987*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[DoubleStruckCapitalX]", "[", 
  RowBox[{"\[Phi]", "[", 
   RowBox[{"t", ",", "x", ",", "y", ",", "z"}], "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {""},
             {"z"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Phi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], ")"}], "2"], 
    RowBox[{"2", " ", 
     SuperscriptBox[
      TagBox[
       StyleBox["a",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}]]}], "-", 
  FractionBox[
   SuperscriptBox[
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"y"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Phi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}], "2"], 
   RowBox[{"2", " ", 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]}]], "-", 
  FractionBox[
   SuperscriptBox[
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"x"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Phi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}], "2"], 
   RowBox[{"2", " ", 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]}]], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"t"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Phi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}], "2"]}]}]], "Output",
 CellChangeTimes->{
  3.6971965153378005`*^9, 3.6971977625080967`*^9, {3.697197968214826*^9, 
   3.69719799672597*^9}, 3.6972406103277936`*^9, 3.697241196194989*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"$Assumptions", "=", 
   RowBox[{
    RowBox[{"a", "[", "t", "]"}], ">", "0"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"lag", "=", 
  RowBox[{
   RowBox[{
    SqrtBox[
     RowBox[{"-", 
      RowBox[{"\[DoubleStruckG]", "[", "]"}]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[DoubleStruckCapitalX]", "[", 
       RowBox[{"\[Sigma]", "[", 
        RowBox[{"t", ",", "x", ",", "y", ",", "z"}], "]"}], "]"}], "-", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       SuperscriptBox["m", "2"], " ", 
       SuperscriptBox[
        RowBox[{"\[Sigma]", "[", 
         RowBox[{"t", ",", "x", ",", "y", ",", "z"}], "]"}], "2"]}]}], 
     ")"}]}], "//", "Simp"}]}]}], "Input",
 CellChangeTimes->{{3.618319162253415*^9, 3.618319185731463*^9}, {
  3.6183192371253443`*^9, 3.618319266118606*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "2"]}], " ", 
   SuperscriptBox["m", "2"], " ", 
   SuperscriptBox[
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], "3"], " ", 
   SuperscriptBox[
    TagBox[
     StyleBox["\[Sigma]",
      LineColor->RGBColor[1, 0, 0],
      FrontFaceColor->RGBColor[1, 0, 0],
      BackFaceColor->RGBColor[1, 0, 0],
      GraphicsColor->RGBColor[1, 0, 0],
      FontColor->RGBColor[1, 0, 0]],
     "GREFX",
     Selectable->False], "2"]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   TagBox[
    StyleBox["a",
     LineColor->RGBColor[0.5, 0, 0.5],
     FrontFaceColor->RGBColor[0.5, 0, 0.5],
     BackFaceColor->RGBColor[0.5, 0, 0.5],
     GraphicsColor->RGBColor[0.5, 0, 0.5],
     FontColor->RGBColor[0.5, 0, 0.5]],
    "GREFX0",
    Selectable->False], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"z"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Sigma]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}], "2"]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   TagBox[
    StyleBox["a",
     LineColor->RGBColor[0.5, 0, 0.5],
     FrontFaceColor->RGBColor[0.5, 0, 0.5],
     BackFaceColor->RGBColor[0.5, 0, 0.5],
     GraphicsColor->RGBColor[0.5, 0, 0.5],
     FontColor->RGBColor[0.5, 0, 0.5]],
    "GREFX0",
    Selectable->False], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"y"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Sigma]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}], "2"]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   TagBox[
    StyleBox["a",
     LineColor->RGBColor[0.5, 0, 0.5],
     FrontFaceColor->RGBColor[0.5, 0, 0.5],
     BackFaceColor->RGBColor[0.5, 0, 0.5],
     GraphicsColor->RGBColor[0.5, 0, 0.5],
     FontColor->RGBColor[0.5, 0, 0.5]],
    "GREFX0",
    Selectable->False], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"x"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Sigma]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}], "2"]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox[
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], "3"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"t"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Sigma]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}], "2"]}]}]], "Output",
 CellChangeTimes->{
  3.6971965173014345`*^9, 3.697197762539349*^9, {3.6971979682617064`*^9, 
   3.6971979967572603`*^9}, 3.697240610443366*^9, 3.697241196323039*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"CalcEom", "[", 
     RowBox[{"lag", ",", "\[Sigma]"}], "]"}], "/", 
    SqrtBox[
     RowBox[{"-", 
      RowBox[{"\[DoubleStruckG]", "[", "]"}]}]]}], "//", "Simp"}]}]], "Input",
 CellChangeTimes->{{3.6183191945496407`*^9, 3.6183191945502996`*^9}, {
  3.618319224656337*^9, 3.618319225026842*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["m", "2"], " ", 
   TagBox[
    StyleBox["\[Sigma]",
     LineColor->RGBColor[1, 0, 0],
     FrontFaceColor->RGBColor[1, 0, 0],
     BackFaceColor->RGBColor[1, 0, 0],
     GraphicsColor->RGBColor[1, 0, 0],
     FontColor->RGBColor[1, 0, 0]],
    "GREFX",
    Selectable->False]}], "-", 
  FractionBox[
   TagBox[GridBox[{
      {"\[PartialD]", 
       StyleBox[GridBox[{
          {"2"},
          {"z"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}},
         Selectable->True],
        FontSize->10], GridBox[{
         {
          TagBox[
           StyleBox["\[Sigma]",
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontColor->RGBColor[1, 0, 0]],
           "GREFX",
           Selectable->False]}
        },
        Selectable->True]}
     },
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "GRED",
    Selectable->False], 
   SuperscriptBox[
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], "2"]], "-", 
  FractionBox[
   TagBox[GridBox[{
      {"\[PartialD]", 
       StyleBox[GridBox[{
          {"2"},
          {"y"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}},
         Selectable->True],
        FontSize->10], GridBox[{
         {
          TagBox[
           StyleBox["\[Sigma]",
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontColor->RGBColor[1, 0, 0]],
           "GREFX",
           Selectable->False]}
        },
        Selectable->True]}
     },
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "GRED",
    Selectable->False], 
   SuperscriptBox[
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], "2"]], "-", 
  FractionBox[
   TagBox[GridBox[{
      {"\[PartialD]", 
       StyleBox[GridBox[{
          {"2"},
          {"x"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}},
         Selectable->True],
        FontSize->10], GridBox[{
         {
          TagBox[
           StyleBox["\[Sigma]",
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontColor->RGBColor[1, 0, 0]],
           "GREFX",
           Selectable->False]}
        },
        Selectable->True]}
     },
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "GRED",
    Selectable->False], 
   SuperscriptBox[
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], "2"]], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    TagBox[
     StyleBox[
      SuperscriptBox["a", "\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], " ", 
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"t"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Sigma]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}]}], 
   TagBox[
    StyleBox["a",
     LineColor->RGBColor[0.5, 0, 0.5],
     FrontFaceColor->RGBColor[0.5, 0, 0.5],
     BackFaceColor->RGBColor[0.5, 0, 0.5],
     GraphicsColor->RGBColor[0.5, 0, 0.5],
     FontColor->RGBColor[0.5, 0, 0.5]],
    "GREFX0",
    Selectable->False]], "+", 
  TagBox[GridBox[{
     {"\[PartialD]", 
      StyleBox[GridBox[{
         {"2"},
         {"t"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True],
       FontSize->10], GridBox[{
        {
         TagBox[
          StyleBox["\[Sigma]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False]}
       },
       Selectable->True]}
    },
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   "GRED",
   Selectable->False]}]], "Output",
 CellChangeTimes->{
  3.697196519504263*^9, 3.6971977625882487`*^9, {3.6971979683302517`*^9, 
   3.697197996836097*^9}, 3.697240610575406*^9, 3.6972411963951025`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example static dS", "Subsection",
 CellChangeTimes->{{3.618319293277926*^9, 3.618319299178459*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[DoubleStruckX]", "=", 
   RowBox[{"{", 
    RowBox[{"t", ",", "r", ",", "\[Theta]", ",", "\[Phi]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$Assumptions", "=", 
   RowBox[{
    RowBox[{"r", ">", "0"}], "&&", 
    RowBox[{"0", "\[LessEqual]", "\[Theta]", "<", "\[Pi]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[DoubleStruckD]s2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         SuperscriptBox["H", "2"], 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"\[DoubleStruckD]", "[", "t", "]"}], "2"]}], "+", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"\[DoubleStruckD]", "[", "r", "]"}], "2"], 
     RowBox[{"1", "-", 
      RowBox[{
       SuperscriptBox["H", "2"], 
       SuperscriptBox["r", "2"]}]}]], "+", 
    RowBox[{
     SuperscriptBox["r", "2"], 
     SuperscriptBox[
      RowBox[{"\[DoubleStruckD]", "[", "\[Theta]", "]"}], "2"]}], "+", 
    RowBox[{
     SuperscriptBox["r", "2"], 
     SuperscriptBox[
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
     SuperscriptBox[
      RowBox[{"\[DoubleStruckD]", "[", "\[Phi]", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "GRE.m"}]}], "Input",
 CellChangeTimes->{{3.6183193340965347`*^9, 3.618319344132473*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lag", "=", 
  RowBox[{
   RowBox[{
    SqrtBox[
     RowBox[{"-", 
      RowBox[{"\[DoubleStruckG]", "[", "]"}]}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[DoubleStruckCapitalX]", "[", 
       RowBox[{"\[Sigma]", "[", 
        RowBox[{"t", ",", "r", ",", "\[Theta]", ",", "\[Phi]"}], "]"}], "]"}],
       "-", 
      RowBox[{
       FractionBox["1", "2"], 
       SuperscriptBox["m", "2"], 
       SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], "//", 
   "Simp"}]}]], "Input",
 CellChangeTimes->{{3.618319441920446*^9, 3.618319446101193*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "2"]}], " ", 
   SuperscriptBox["m", "2"], " ", 
   SuperscriptBox["r", "2"], " ", 
   SuperscriptBox["\[Sigma]", "2"], " ", 
   RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"Csc", "[", "\[Theta]", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"\[Phi]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Sigma]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}], "2"]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"\[Theta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Sigma]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}], "2"]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox["r", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{
      SuperscriptBox["H", "2"], " ", 
      SuperscriptBox["r", "2"]}]}], ")"}], " ", 
   RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"r"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Sigma]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}], "2"]}], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["r", "2"], " ", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {""},
             {"t"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Sigma]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], ")"}], "2"]}], 
   RowBox[{"2", "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["H", "2"], " ", 
     SuperscriptBox["r", "2"]}]}]]}]], "Output",
 CellChangeTimes->{
  3.6971965334032545`*^9, 3.6971977637716556`*^9, {3.697197968899884*^9, 
   3.697197997373965*^9}, 3.6972406121789904`*^9, 3.6972411970075502`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"CalcEom", "[", 
     RowBox[{"lag", ",", "\[Sigma]"}], "]"}], "/", 
    SqrtBox[
     RowBox[{"-", 
      RowBox[{"\[DoubleStruckG]", "[", "]"}]}]]}], "//", "Simp"}]}]], "Input",
 CellChangeTimes->{{3.618319449397285*^9, 3.618319453379795*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["m", "2"], " ", "\[Sigma]"}], "-", 
  FractionBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{"Csc", "[", "\[Theta]", "]"}], "2"], " ", 
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {"2"},
            {"\[Phi]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Sigma]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}]}], 
   SuperscriptBox["r", "2"]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{"Cot", "[", "\[Theta]", "]"}], " ", 
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"\[Theta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Sigma]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}]}], 
   SuperscriptBox["r", "2"]], "-", 
  FractionBox[
   TagBox[GridBox[{
      {"\[PartialD]", 
       StyleBox[GridBox[{
          {"2"},
          {"\[Theta]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}},
         Selectable->True],
        FontSize->10], GridBox[{
         {
          TagBox[
           StyleBox["\[Sigma]",
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontColor->RGBColor[1, 0, 0]],
           "GREFX",
           Selectable->False]}
        },
        Selectable->True]}
     },
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "GRED",
    Selectable->False], 
   SuperscriptBox["r", "2"]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["2", "r"]}], "+", 
     RowBox[{"4", " ", 
      SuperscriptBox["H", "2"], " ", "r"}]}], ")"}], " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"r"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Sigma]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{
      SuperscriptBox["H", "2"], " ", 
      SuperscriptBox["r", "2"]}]}], ")"}], " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {"2"},
           {"r"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Sigma]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}], "+", 
  FractionBox[
   TagBox[GridBox[{
      {"\[PartialD]", 
       StyleBox[GridBox[{
          {"2"},
          {"t"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}},
         Selectable->True],
        FontSize->10], GridBox[{
         {
          TagBox[
           StyleBox["\[Sigma]",
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontColor->RGBColor[1, 0, 0]],
           "GREFX",
           Selectable->False]}
        },
        Selectable->True]}
     },
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "GRED",
    Selectable->False], 
   RowBox[{"1", "-", 
    RowBox[{
     SuperscriptBox["H", "2"], " ", 
     SuperscriptBox["r", "2"]}]}]]}]], "Output",
 CellChangeTimes->{
  3.6971965355904503`*^9, 3.697197764036785*^9, {3.6971979691160994`*^9, 
   3.6971979975585804`*^9}, 3.6972406142777553`*^9, 3.697241197287876*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example shock wave", "Subsection",
 CellChangeTimes->{{3.618319512034959*^9, 3.61831951671593*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[DoubleStruckX]", "=", 
   RowBox[{"{", 
    RowBox[{"u", ",", "v", ",", "x", ",", "y"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[DoubleStruckD]s2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"\[DoubleStruckD]", "[", "u", "]"}]}], 
     RowBox[{"\[DoubleStruckD]", "[", "v", "]"}]}], "+", 
    RowBox[{
     RowBox[{"h", "[", 
      RowBox[{"u", ",", "x", ",", "y"}], "]"}], 
     SuperscriptBox[
      RowBox[{"\[DoubleStruckD]", "[", "u", "]"}], "2"]}], "+", 
    SuperscriptBox[
     RowBox[{"\[DoubleStruckD]", "[", "x", "]"}], "2"], "+", 
    SuperscriptBox[
     RowBox[{"\[DoubleStruckD]", "[", "y", "]"}], "2"]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "GRE.m"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Print\[DoubleStruckCapitalG]", "[", "]"}]], "Input",
 CellChangeTimes->{{3.618319538003531*^9, 3.618319546125744*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"u", "u"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox["1", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              RowBox[{"h", "[", 
               RowBox[{"u", ",", "x", ",", "y"}], "]"}]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], ")"}]}], "-", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {"2"},
            {"x"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            RowBox[{"h", "[", 
             RowBox[{"u", ",", "x", ",", "y"}], "]"}]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False]}], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], " = ", 
   Rational[1, 2] (-
     Derivative[
      0, 0, 2][$CellContext`h][$CellContext`u, $CellContext`x, \
$CellContext`y] - Derivative[
    0, 2, 0][$CellContext`h][$CellContext`u, $CellContext`x, $CellContext`y])],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697196549284542*^9, 3.697197326959325*^9, 3.6971977651106467`*^9, {
   3.697197824274598*^9, 3.697197851481985*^9}, {3.697197969763017*^9, 
   3.6971979980599594`*^9}, 3.6972406148421*^9, 3.6972411977999353`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Print\[DoubleStruckCapitalG]ud", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6183195516375523`*^9, 3.6183195516527*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"v", ""},
            {"", "u"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {"2"},
           {"y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           RowBox[{"h", "[", 
            RowBox[{"u", ",", "x", ",", "y"}], "]"}]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False]}], "+", 
   TagBox[GridBox[{
      {"\[PartialD]", 
       StyleBox[GridBox[{
          {"2"},
          {"x"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}},
         Selectable->True],
        FontSize->10], GridBox[{
         {
          RowBox[{"h", "[", 
           RowBox[{"u", ",", "x", ",", "y"}], "]"}]}
        },
        Selectable->True]}
     },
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "GRED",
    Selectable->False]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], " = ", 
   Derivative[
    0, 0, 2][$CellContext`h][$CellContext`u, $CellContext`x, $CellContext`y] + 
   Derivative[
    0, 2, 0][$CellContext`h][$CellContext`u, $CellContext`x, $CellContext`y]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.697197328791149*^9, 3.697197765141863*^9, {3.6971978242902584`*^9, 
   3.697197853030342*^9}, {3.697197969763017*^9, 3.6971979981123576`*^9}, 
   3.6972406148577256`*^9, 3.6972411978239374`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example Mukhanov-Fieldman-Brandenberger convention", "Subsection",
 CellChangeTimes->{{3.697239326240591*^9, 3.6972393501096706`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[DoubleStruckX]", "=", 
   RowBox[{"{", 
    RowBox[{"\[Eta]", ",", "x", ",", "y", ",", "z"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"\[DoubleStruckD]s2", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"2", " ", "eps", " ", 
          RowBox[{"\[Phi]", "[", 
           RowBox[{"\[Eta]", ",", "x", ",", "y", ",", "z"}], "]"}]}]}], ")"}], 
       SuperscriptBox[
        RowBox[{"\[DoubleStruckD]", "[", "\[Eta]", "]"}], "2"]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"2", " ", "eps", " ", 
           RowBox[{"\[Psi]", "[", 
            RowBox[{"\[Eta]", ",", "x", ",", "y", ",", "z"}], "]"}]}]}], 
         ")"}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"\[DoubleStruckD]", "[", "x", "]"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"\[DoubleStruckD]", "[", "y", "]"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"\[DoubleStruckD]", "[", "z", "]"}], "2"]}], ")"}]}]}], 
     ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"rules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"a", "'"}], "[", "\[Eta]", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"\[ScriptCapitalH]", "[", "\[Eta]", "]"}], 
       RowBox[{"a", "[", "\[Eta]", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "''"}], "[", "\[Eta]", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"\[ScriptCapitalH]", "[", "\[Eta]", "]"}], 
         RowBox[{"a", "[", "\[Eta]", "]"}]}], ",", "\[Eta]"}], "]"}]}]}], " ",
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Simp", "=", 
   RowBox[{"Function", "[", 
    RowBox[{"f", ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{"f", ",", 
          RowBox[{"{", 
           RowBox[{"eps", ",", "0", ",", " ", "1"}], "}"}]}], "]"}], "//.", 
        "rules"}], "//", "Normal"}], "//", 
      RowBox[{
       RowBox[{"Collect", "[", 
        RowBox[{"#", ",", " ", "eps", ",", "Simplify"}], "]"}], "&"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "GRE.m"}]}], "Input",
 CellChangeTimes->{{3.69723935674329*^9, 3.69723949462117*^9}, {
  3.6972396208511047`*^9, 3.697239711228327*^9}, {3.697239750387327*^9, 
  3.6972397539066815`*^9}, {3.697240328376579*^9, 3.697240346575184*^9}, {
  3.697240627893832*^9, 3.697240643681507*^9}, {3.6972407596520834`*^9, 
  3.6972407861134577`*^9}, {3.697240898721575*^9, 3.697240971525665*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[DoubleStruckG]", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6972399621260524`*^9, 3.697239962226376*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   SuperscriptBox[
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], "8"]}], "-", 
  RowBox[{"2", " ", "eps", " ", 
   SuperscriptBox[
    TagBox[
     StyleBox["a",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False], "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     TagBox[
      StyleBox["\[Phi]",
       LineColor->RGBColor[1, 0, 0],
       FrontFaceColor->RGBColor[1, 0, 0],
       BackFaceColor->RGBColor[1, 0, 0],
       GraphicsColor->RGBColor[1, 0, 0],
       FontColor->RGBColor[1, 0, 0]],
      "GREFX",
      Selectable->False], "-", 
     RowBox[{"3", " ", 
      TagBox[
       StyleBox["\[Psi]",
        LineColor->RGBColor[1, 0, 0],
        FrontFaceColor->RGBColor[1, 0, 0],
        BackFaceColor->RGBColor[1, 0, 0],
        GraphicsColor->RGBColor[1, 0, 0],
        FontColor->RGBColor[1, 0, 0]],
       "GREFX",
       Selectable->False]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.697239959594452*^9, 3.697239962695018*^9}, 
   3.697240350712363*^9, 3.697240543463276*^9, 3.6972406154797835`*^9, 
   3.6972406487839994`*^9, 3.6972409837837257`*^9, 3.6972411984773045`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["\[DoubleStruckG]Mat"], "Input",
 CellChangeTimes->{{3.6972399954032464`*^9, 3.697240002140775*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       TagBox[
        StyleBox["a",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], "2"], "+", 
      RowBox[{"2", " ", "eps", " ", 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"], " ", 
       TagBox[
        StyleBox["\[Phi]",
         LineColor->RGBColor[1, 0, 0],
         FrontFaceColor->RGBColor[1, 0, 0],
         BackFaceColor->RGBColor[1, 0, 0],
         GraphicsColor->RGBColor[1, 0, 0],
         FontColor->RGBColor[1, 0, 0]],
        "GREFX",
        Selectable->False]}]}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"]}], "+", 
      RowBox[{"2", " ", "eps", " ", 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"], " ", 
       TagBox[
        StyleBox["\[Psi]",
         LineColor->RGBColor[1, 0, 0],
         FrontFaceColor->RGBColor[1, 0, 0],
         BackFaceColor->RGBColor[1, 0, 0],
         GraphicsColor->RGBColor[1, 0, 0],
         FontColor->RGBColor[1, 0, 0]],
        "GREFX",
        Selectable->False]}]}], ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"]}], "+", 
      RowBox[{"2", " ", "eps", " ", 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"], " ", 
       TagBox[
        StyleBox["\[Psi]",
         LineColor->RGBColor[1, 0, 0],
         FrontFaceColor->RGBColor[1, 0, 0],
         BackFaceColor->RGBColor[1, 0, 0],
         GraphicsColor->RGBColor[1, 0, 0],
         FontColor->RGBColor[1, 0, 0]],
        "GREFX",
        Selectable->False]}]}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"]}], "+", 
      RowBox[{"2", " ", "eps", " ", 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"], " ", 
       TagBox[
        StyleBox["\[Psi]",
         LineColor->RGBColor[1, 0, 0],
         FrontFaceColor->RGBColor[1, 0, 0],
         BackFaceColor->RGBColor[1, 0, 0],
         GraphicsColor->RGBColor[1, 0, 0],
         FontColor->RGBColor[1, 0, 0]],
        "GREFX",
        Selectable->False]}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.6972399920623446`*^9, 3.697240002640705*^9}, 
   3.6972403525480547`*^9, 3.6972405449483404`*^9, 3.697240615495414*^9, 
   3.6972406488061514`*^9, 3.697240983803712*^9, 3.6972411985013027`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["\[DoubleStruckG]uuMat"], "Input",
 CellChangeTimes->{{3.6972400102201214`*^9, 3.6972400246163206`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"]], "-", 
      FractionBox[
       RowBox[{"2", " ", "eps", " ", 
        TagBox[
         StyleBox["\[Phi]",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False]}], 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"]]}], ",", "0", ",", "0", ",", "0"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", 
        SuperscriptBox[
         TagBox[
          StyleBox["a",
           LineColor->RGBColor[0.5, 0, 0.5],
           FrontFaceColor->RGBColor[0.5, 0, 0.5],
           BackFaceColor->RGBColor[0.5, 0, 0.5],
           GraphicsColor->RGBColor[0.5, 0, 0.5],
           FontColor->RGBColor[0.5, 0, 0.5]],
          "GREFX0",
          Selectable->False], "2"]]}], "-", 
      FractionBox[
       RowBox[{"2", " ", "eps", " ", 
        TagBox[
         StyleBox["\[Psi]",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False]}], 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"]]}], ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", 
        SuperscriptBox[
         TagBox[
          StyleBox["a",
           LineColor->RGBColor[0.5, 0, 0.5],
           FrontFaceColor->RGBColor[0.5, 0, 0.5],
           BackFaceColor->RGBColor[0.5, 0, 0.5],
           GraphicsColor->RGBColor[0.5, 0, 0.5],
           FontColor->RGBColor[0.5, 0, 0.5]],
          "GREFX0",
          Selectable->False], "2"]]}], "-", 
      FractionBox[
       RowBox[{"2", " ", "eps", " ", 
        TagBox[
         StyleBox["\[Psi]",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False]}], 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"]]}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", 
        SuperscriptBox[
         TagBox[
          StyleBox["a",
           LineColor->RGBColor[0.5, 0, 0.5],
           FrontFaceColor->RGBColor[0.5, 0, 0.5],
           BackFaceColor->RGBColor[0.5, 0, 0.5],
           GraphicsColor->RGBColor[0.5, 0, 0.5],
           FontColor->RGBColor[0.5, 0, 0.5]],
          "GREFX0",
          Selectable->False], "2"]]}], "-", 
      FractionBox[
       RowBox[{"2", " ", "eps", " ", 
        TagBox[
         StyleBox["\[Psi]",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False]}], 
       SuperscriptBox[
        TagBox[
         StyleBox["a",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"]]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.6972400108829885`*^9, 3.6972400250323133`*^9}, 
   3.6972403541813297`*^9, 3.6972405467673397`*^9, 3.6972406155266676`*^9, 
   3.697240648837406*^9, 3.6972409838307557`*^9, 3.697241198521305*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Print\[CapitalGamma]", "[", "]"}]], "Input",
 CellChangeTimes->{{3.697240111375249*^9, 3.697240126714141*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[CapitalGamma]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"\[Eta]", "", ""},
            {"", "\[Eta]", "\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    TagBox[
     StyleBox["\[ScriptCapitalH]",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}], "+", 
   RowBox[{"eps", " ", 
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Phi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] + \
$CellContext`eps 
    Derivative[
     1, 0, 0, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411986094184`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"\[Eta]", "", ""},
           {"", "x", "\[Eta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Phi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 1, 0, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198617425*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[CapitalGamma]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"\[Eta]", "", ""},
            {"", "x", "x"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    TagBox[
     StyleBox["\[ScriptCapitalH]",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}], "+", 
   RowBox[{"eps", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       TagBox[
        StyleBox["\[ScriptCapitalH]",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         TagBox[
          StyleBox["\[Phi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False], "+", 
         TagBox[
          StyleBox["\[Psi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False]}], ")"}]}], "-", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {""},
             {"\[Eta]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False]}], ")"}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] + \
$CellContext`eps ((-2) $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] \
($CellContext`\[Phi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, \
$CellContext`z] + $CellContext`\[Psi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]) - Derivative[
     1, 0, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198629422*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"\[Eta]", "", ""},
           {"", "y", "\[Eta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Phi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 0, 1, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198637417*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[CapitalGamma]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"\[Eta]", "", ""},
            {"", "y", "y"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    TagBox[
     StyleBox["\[ScriptCapitalH]",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}], "+", 
   RowBox[{"eps", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       TagBox[
        StyleBox["\[ScriptCapitalH]",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         TagBox[
          StyleBox["\[Phi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False], "+", 
         TagBox[
          StyleBox["\[Psi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False]}], ")"}]}], "-", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {""},
             {"\[Eta]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False]}], ")"}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] + \
$CellContext`eps ((-2) $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] \
($CellContext`\[Phi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, \
$CellContext`z] + $CellContext`\[Psi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]) - Derivative[
     1, 0, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198647441*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"\[Eta]", "", ""},
           {"", "z", "\[Eta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Phi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 0, 0, 1][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198655513*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[CapitalGamma]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"\[Eta]", "", ""},
            {"", "z", "z"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    TagBox[
     StyleBox["\[ScriptCapitalH]",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}], "+", 
   RowBox[{"eps", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       TagBox[
        StyleBox["\[ScriptCapitalH]",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         TagBox[
          StyleBox["\[Phi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False], "+", 
         TagBox[
          StyleBox["\[Psi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False]}], ")"}]}], "-", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {""},
             {"\[Eta]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False]}], ")"}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] + \
$CellContext`eps ((-2) $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] \
($CellContext`\[Phi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, \
$CellContext`z] + $CellContext`\[Psi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]) - Derivative[
     1, 0, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198665535*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"x", "", ""},
           {"", "\[Eta]", "\[Eta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Phi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 1, 0, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198673549*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[CapitalGamma]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"x", "", ""},
            {"", "x", "\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    TagBox[
     StyleBox["\[ScriptCapitalH]",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}], "-", 
   RowBox[{"eps", " ", 
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Psi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] - \
$CellContext`eps 
   Derivative[
    1, 0, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198681535*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"x", "", ""},
           {"", "x", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "eps"}], " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`eps 
   Derivative[
    0, 1, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411986895404`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"x", "", ""},
           {"", "x", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "eps"}], " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`eps 
   Derivative[
    0, 0, 1, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411986975336`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"x", "", ""},
           {"", "x", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "eps"}], " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`eps 
   Derivative[
    0, 0, 0, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411987055335`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"x", "", ""},
           {"", "y", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 1, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411987135353`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"x", "", ""},
           {"", "z", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 1, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411987215395`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"y", "", ""},
           {"", "\[Eta]", "\[Eta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Phi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 0, 1, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411987335353`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"y", "", ""},
           {"", "x", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 0, 1, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411987425823`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"y", "", ""},
           {"", "x", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "eps"}], " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`eps 
   Derivative[
    0, 1, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411987516513`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[CapitalGamma]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"y", "", ""},
            {"", "y", "\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    TagBox[
     StyleBox["\[ScriptCapitalH]",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}], "-", 
   RowBox[{"eps", " ", 
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Psi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] - \
$CellContext`eps 
   Derivative[
    1, 0, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411987576246`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"y", "", ""},
           {"", "y", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "eps"}], " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`eps 
   Derivative[
    0, 0, 1, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411987656693`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"y", "", ""},
           {"", "y", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "eps"}], " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`eps 
   Derivative[
    0, 0, 0, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411987736607`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"y", "", ""},
           {"", "z", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 0, 1, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198785657*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"z", "", ""},
           {"", "\[Eta]", "\[Eta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Phi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 0, 0, 1][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.69724119879366*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"z", "", ""},
           {"", "x", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 0, 0, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198801656*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"z", "", ""},
           {"", "x", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "eps"}], " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`eps 
   Derivative[
    0, 1, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198809677*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"z", "", ""},
           {"", "y", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps 
   Derivative[
    0, 0, 0, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.697241198817661*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"z", "", ""},
           {"", "y", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "eps"}], " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`eps 
   Derivative[
    0, 0, 1, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411988256583`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[CapitalGamma]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"z", "", ""},
            {"", "z", "\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    TagBox[
     StyleBox["\[ScriptCapitalH]",
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}], "-", 
   RowBox[{"eps", " ", 
    RowBox[{"(", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {""},
            {"\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Psi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False], ")"}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] - \
$CellContext`eps 
   Derivative[
    1, 0, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411988336616`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[CapitalGamma]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"z", "", ""},
           {"", "z", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "eps"}], " ", 
   RowBox[{"(", 
    TagBox[GridBox[{
       {"\[PartialD]", 
        StyleBox[GridBox[{
           {""},
           {"z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10], GridBox[{
          {
           TagBox[
            StyleBox["\[Psi]",
             LineColor->RGBColor[1, 0, 0],
             FrontFaceColor->RGBColor[1, 0, 0],
             BackFaceColor->RGBColor[1, 0, 0],
             GraphicsColor->RGBColor[1, 0, 0],
             FontColor->RGBColor[1, 0, 0]],
            "GREFX",
            Selectable->False]}
         },
         Selectable->True]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRED",
     Selectable->False], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[CapitalGamma], \
{{$CellContext`\[Lambda], Null, Null}, {
      Null, $CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`eps 
   Derivative[
    0, 0, 0, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]],
  Editable->False]], "Print",
 CellChangeTimes->{3.6972401270986624`*^9, 3.69724035565255*^9, 
  3.6972405485532465`*^9, 3.6972406155579205`*^9, 3.6972406488530407`*^9, 
  3.697240983855399*^9, 3.6972411988447123`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Print\[DoubleStruckCapitalG]", "[", "]"}]], "Input",
 CellChangeTimes->{{3.697239909068654*^9, 3.6972399178638277`*^9}, 
   3.6972401465882454`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"", ""},
            {"\[Eta]", "\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    RowBox[{"3", " ", 
     SuperscriptBox[
      TagBox[
       StyleBox["\[ScriptCapitalH]",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}]}], "+", 
   RowBox[{"2", " ", "eps", " ", 
    RowBox[{"(", 
     RowBox[{
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"z"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "+", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"y"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "+", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"x"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "-", 
      RowBox[{"3", " ", 
       TagBox[
        StyleBox["\[ScriptCapitalH]",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], " ", 
       RowBox[{"(", 
        TagBox[GridBox[{
           {"\[PartialD]", 
            StyleBox[GridBox[{
               {""},
               {"\[Eta]"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}},
              Selectable->True],
             FontSize->10], GridBox[{
              {
               TagBox[
                StyleBox["\[Psi]",
                 LineColor->RGBColor[1, 0, 0],
                 FrontFaceColor->RGBColor[1, 0, 0],
                 BackFaceColor->RGBColor[1, 0, 0],
                 GraphicsColor->RGBColor[1, 0, 0],
                 FontColor->RGBColor[1, 0, 0]],
                "GREFX",
                Selectable->False]}
             },
             Selectable->True]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         "GRED",
         Selectable->False], ")"}]}]}], ")"}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], " = ", 
   3 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 + 
   2 $CellContext`eps (
     Derivative[
      0, 0, 0, 2][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
     Derivative[
      0, 0, 2, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
     Derivative[
      0, 2, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - 
     3 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] 
     Derivative[
      1, 0, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697240147404647*^9, 3.6972403601643004`*^9, 
  3.6972406165974054`*^9, 3.6972406496064*^9, 3.697240984311889*^9, 
  3.697241199153057*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"x", "\[Eta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "2", 
   " ", "eps", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      TagBox[
       StyleBox["\[ScriptCapitalH]",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], " ", 
      RowBox[{"(", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {""},
              {"x"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], ")"}]}], "+", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {"", ""},
            {"\[Eta]", "x"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Psi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False]}], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], " = ", 
   2 $CellContext`eps ($CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] 
     Derivative[
      0, 1, 0, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     1, 1, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697240147404647*^9, 3.6972403601643004`*^9, 
  3.6972406165974054`*^9, 3.6972406496064*^9, 3.697240984311889*^9, 
  3.69724119915757*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"", ""},
            {"x", "x"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    RowBox[{"-", 
     SuperscriptBox[
      TagBox[
       StyleBox["\[ScriptCapitalH]",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}]}], "-", 
   RowBox[{"2", " ", 
    TagBox[
     StyleBox[
      SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}], "+", 
   RowBox[{"eps", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       SuperscriptBox[
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         TagBox[
          StyleBox["\[Phi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False], "+", 
         TagBox[
          StyleBox["\[Psi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False]}], ")"}]}], "+", 
      RowBox[{"4", " ", 
       TagBox[
        StyleBox["\[Phi]",
         LineColor->RGBColor[1, 0, 0],
         FrontFaceColor->RGBColor[1, 0, 0],
         BackFaceColor->RGBColor[1, 0, 0],
         GraphicsColor->RGBColor[1, 0, 0],
         FontColor->RGBColor[1, 0, 0]],
        "GREFX",
        Selectable->False], " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}], "+", 
      RowBox[{"4", " ", 
       TagBox[
        StyleBox["\[Psi]",
         LineColor->RGBColor[1, 0, 0],
         FrontFaceColor->RGBColor[1, 0, 0],
         BackFaceColor->RGBColor[1, 0, 0],
         GraphicsColor->RGBColor[1, 0, 0],
         FontColor->RGBColor[1, 0, 0]],
        "GREFX",
        Selectable->False], " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}], "+", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"z"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Phi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "-", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"z"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "+", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"y"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Phi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "-", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"y"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "+", 
      RowBox[{"2", " ", 
       TagBox[
        StyleBox["\[ScriptCapitalH]",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {""},
                {"\[Eta]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Phi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], "+", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           TagBox[GridBox[{
              {"\[PartialD]", 
               StyleBox[GridBox[{
                  {""},
                  {"\[Eta]"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                 Selectable->True],
                FontSize->10], GridBox[{
                 {
                  TagBox[
                   StyleBox["\[Psi]",
                    LineColor->RGBColor[1, 0, 0],
                    FrontFaceColor->RGBColor[1, 0, 0],
                    BackFaceColor->RGBColor[1, 0, 0],
                    GraphicsColor->RGBColor[1, 0, 0],
                    FontColor->RGBColor[1, 0, 0]],
                   "GREFX",
                   Selectable->False]}
                },
                Selectable->True]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            "GRED",
            Selectable->False], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        TagBox[GridBox[{
           {"\[PartialD]", 
            StyleBox[GridBox[{
               {"2"},
               {"\[Eta]"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}},
              Selectable->True],
             FontSize->10], GridBox[{
              {
               TagBox[
                StyleBox["\[Psi]",
                 LineColor->RGBColor[1, 0, 0],
                 FrontFaceColor->RGBColor[1, 0, 0],
                 BackFaceColor->RGBColor[1, 0, 0],
                 GraphicsColor->RGBColor[1, 0, 0],
                 FontColor->RGBColor[1, 0, 0]],
                "GREFX",
                Selectable->False]}
             },
             Selectable->True]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         "GRED",
         Selectable->False], ")"}]}]}], ")"}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 - 2 
   Derivative[
    1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + \
$CellContext`eps (
     2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 ($CellContext`\
\[Phi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, $CellContext`z] + \
$CellContext`\[Psi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, \
$CellContext`z]) + 
     4 $CellContext`\[Phi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] 
      Derivative[1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + 
     4 $CellContext`\[Psi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] 
      Derivative[1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + 
     Derivative[
      0, 0, 0, 2][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
     0, 0, 0, 2][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
     Derivative[
      0, 0, 2, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
     0, 0, 2, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
     2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] (
       Derivative[
        1, 0, 0, 
         0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
       2 Derivative[
         1, 0, 0, 
          0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]) + 
     2 Derivative[
       2, 0, 0, 
        0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697240147404647*^9, 3.6972403601643004`*^9, 
  3.6972406165974054`*^9, 3.6972406496064*^9, 3.697240984311889*^9, 
  3.6972411991658115`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"x", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"x", "y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], ")"}]}], "+", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {"", ""},
            {"x", "y"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Psi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False]}], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps (-
     Derivative[
      0, 1, 1, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     0, 1, 1, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697240147404647*^9, 3.6972403601643004`*^9, 
  3.6972406165974054`*^9, 3.6972406496064*^9, 3.697240984311889*^9, 
  3.697241199177844*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"x", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"x", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], ")"}]}], "+", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {"", ""},
            {"x", "z"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Psi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False]}], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps (-
     Derivative[
      0, 1, 0, 1][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     0, 1, 0, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697240147404647*^9, 3.6972403601643004`*^9, 
  3.6972406165974054`*^9, 3.6972406496064*^9, 3.697240984311889*^9, 
  3.697241199189845*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"y", "\[Eta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "2", 
   " ", "eps", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      TagBox[
       StyleBox["\[ScriptCapitalH]",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], " ", 
      RowBox[{"(", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {""},
              {"y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], ")"}]}], "+", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {"", ""},
            {"\[Eta]", "y"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Psi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False]}], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], " = ", 
   2 $CellContext`eps ($CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] 
     Derivative[
      0, 0, 1, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     1, 0, 1, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697240147404647*^9, 3.6972403601643004`*^9, 
  3.6972406165974054`*^9, 3.6972406496064*^9, 3.697240984311889*^9, 
  3.6972411991978436`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"", ""},
            {"y", "y"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    RowBox[{"-", 
     SuperscriptBox[
      TagBox[
       StyleBox["\[ScriptCapitalH]",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}]}], "-", 
   RowBox[{"2", " ", 
    TagBox[
     StyleBox[
      SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}], "+", 
   RowBox[{"eps", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       SuperscriptBox[
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         TagBox[
          StyleBox["\[Phi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False], "+", 
         TagBox[
          StyleBox["\[Psi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False]}], ")"}]}], "+", 
      RowBox[{"4", " ", 
       TagBox[
        StyleBox["\[Phi]",
         LineColor->RGBColor[1, 0, 0],
         FrontFaceColor->RGBColor[1, 0, 0],
         BackFaceColor->RGBColor[1, 0, 0],
         GraphicsColor->RGBColor[1, 0, 0],
         FontColor->RGBColor[1, 0, 0]],
        "GREFX",
        Selectable->False], " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}], "+", 
      RowBox[{"4", " ", 
       TagBox[
        StyleBox["\[Psi]",
         LineColor->RGBColor[1, 0, 0],
         FrontFaceColor->RGBColor[1, 0, 0],
         BackFaceColor->RGBColor[1, 0, 0],
         GraphicsColor->RGBColor[1, 0, 0],
         FontColor->RGBColor[1, 0, 0]],
        "GREFX",
        Selectable->False], " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}], "+", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"z"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Phi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "-", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"z"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "+", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"x"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Phi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "-", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"x"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "+", 
      RowBox[{"2", " ", 
       TagBox[
        StyleBox["\[ScriptCapitalH]",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {""},
                {"\[Eta]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Phi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], "+", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           TagBox[GridBox[{
              {"\[PartialD]", 
               StyleBox[GridBox[{
                  {""},
                  {"\[Eta]"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                 Selectable->True],
                FontSize->10], GridBox[{
                 {
                  TagBox[
                   StyleBox["\[Psi]",
                    LineColor->RGBColor[1, 0, 0],
                    FrontFaceColor->RGBColor[1, 0, 0],
                    BackFaceColor->RGBColor[1, 0, 0],
                    GraphicsColor->RGBColor[1, 0, 0],
                    FontColor->RGBColor[1, 0, 0]],
                   "GREFX",
                   Selectable->False]}
                },
                Selectable->True]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            "GRED",
            Selectable->False], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        TagBox[GridBox[{
           {"\[PartialD]", 
            StyleBox[GridBox[{
               {"2"},
               {"\[Eta]"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}},
              Selectable->True],
             FontSize->10], GridBox[{
              {
               TagBox[
                StyleBox["\[Psi]",
                 LineColor->RGBColor[1, 0, 0],
                 FrontFaceColor->RGBColor[1, 0, 0],
                 BackFaceColor->RGBColor[1, 0, 0],
                 GraphicsColor->RGBColor[1, 0, 0],
                 FontColor->RGBColor[1, 0, 0]],
                "GREFX",
                Selectable->False]}
             },
             Selectable->True]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         "GRED",
         Selectable->False], ")"}]}]}], ")"}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 - 2 
   Derivative[
    1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + \
$CellContext`eps (
     2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 ($CellContext`\
\[Phi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, $CellContext`z] + \
$CellContext`\[Psi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, \
$CellContext`z]) + 
     4 $CellContext`\[Phi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] 
      Derivative[1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + 
     4 $CellContext`\[Psi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] 
      Derivative[1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + 
     Derivative[
      0, 0, 0, 2][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
     0, 0, 0, 2][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
     Derivative[
      0, 2, 0, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
     0, 2, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
     2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] (
       Derivative[
        1, 0, 0, 
         0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
       2 Derivative[
         1, 0, 0, 
          0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]) + 
     2 Derivative[
       2, 0, 0, 
        0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697240147404647*^9, 3.6972403601643004`*^9, 
  3.6972406165974054`*^9, 3.6972406496064*^9, 3.697240984311889*^9, 
  3.6972411992138453`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"y", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "eps",
    " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"y", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], ")"}]}], "+", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {"", ""},
            {"y", "z"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Psi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False]}], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps (-
     Derivative[
      0, 0, 1, 1][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     0, 0, 1, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697240147404647*^9, 3.6972403601643004`*^9, 
  3.6972406165974054`*^9, 3.6972406496064*^9, 3.697240984311889*^9, 
  3.6972411992218437`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"", ""},
           {"z", "\[Eta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "2", 
   " ", "eps", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      TagBox[
       StyleBox["\[ScriptCapitalH]",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], " ", 
      RowBox[{"(", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {""},
              {"z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], ")"}]}], "+", 
     TagBox[GridBox[{
        {"\[PartialD]", 
         StyleBox[GridBox[{
            {"", ""},
            {"\[Eta]", "z"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10], GridBox[{
           {
            TagBox[
             StyleBox["\[Psi]",
              LineColor->RGBColor[1, 0, 0],
              FrontFaceColor->RGBColor[1, 0, 0],
              BackFaceColor->RGBColor[1, 0, 0],
              GraphicsColor->RGBColor[1, 0, 0],
              FontColor->RGBColor[1, 0, 0]],
             "GREFX",
             Selectable->False]}
          },
          Selectable->True]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRED",
      Selectable->False]}], ")"}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], " = ", 
   2 $CellContext`eps ($CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] 
     Derivative[
      0, 0, 0, 1][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     1, 0, 0, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697240147404647*^9, 3.6972403601643004`*^9, 
  3.6972406165974054`*^9, 3.6972406496064*^9, 3.697240984311889*^9, 
  3.69724119923381*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"", ""},
            {"z", "z"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    RowBox[{"-", 
     SuperscriptBox[
      TagBox[
       StyleBox["\[ScriptCapitalH]",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]}]}], "-", 
   RowBox[{"2", " ", 
    TagBox[
     StyleBox[
      SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
       MultilineFunction->None],
      LineColor->RGBColor[0.5, 0, 0.5],
      FrontFaceColor->RGBColor[0.5, 0, 0.5],
      BackFaceColor->RGBColor[0.5, 0, 0.5],
      GraphicsColor->RGBColor[0.5, 0, 0.5],
      FontColor->RGBColor[0.5, 0, 0.5]],
     "GREFX0",
     Selectable->False]}], "+", 
   RowBox[{"eps", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       SuperscriptBox[
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         TagBox[
          StyleBox["\[Phi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False], "+", 
         TagBox[
          StyleBox["\[Psi]",
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontColor->RGBColor[1, 0, 0]],
          "GREFX",
          Selectable->False]}], ")"}]}], "+", 
      RowBox[{"4", " ", 
       TagBox[
        StyleBox["\[Phi]",
         LineColor->RGBColor[1, 0, 0],
         FrontFaceColor->RGBColor[1, 0, 0],
         BackFaceColor->RGBColor[1, 0, 0],
         GraphicsColor->RGBColor[1, 0, 0],
         FontColor->RGBColor[1, 0, 0]],
        "GREFX",
        Selectable->False], " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}], "+", 
      RowBox[{"4", " ", 
       TagBox[
        StyleBox["\[Psi]",
         LineColor->RGBColor[1, 0, 0],
         FrontFaceColor->RGBColor[1, 0, 0],
         BackFaceColor->RGBColor[1, 0, 0],
         GraphicsColor->RGBColor[1, 0, 0],
         FontColor->RGBColor[1, 0, 0]],
        "GREFX",
        Selectable->False], " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}], "+", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"y"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Phi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "-", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"y"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "+", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"x"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Phi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "-", 
      TagBox[GridBox[{
         {"\[PartialD]", 
          StyleBox[GridBox[{
             {"2"},
             {"x"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}},
            Selectable->True],
           FontSize->10], GridBox[{
            {
             TagBox[
              StyleBox["\[Psi]",
               LineColor->RGBColor[1, 0, 0],
               FrontFaceColor->RGBColor[1, 0, 0],
               BackFaceColor->RGBColor[1, 0, 0],
               GraphicsColor->RGBColor[1, 0, 0],
               FontColor->RGBColor[1, 0, 0]],
              "GREFX",
              Selectable->False]}
           },
           Selectable->True]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "GRED",
       Selectable->False], "+", 
      RowBox[{"2", " ", 
       TagBox[
        StyleBox["\[ScriptCapitalH]",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {""},
                {"\[Eta]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Phi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], "+", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           TagBox[GridBox[{
              {"\[PartialD]", 
               StyleBox[GridBox[{
                  {""},
                  {"\[Eta]"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                 Selectable->True],
                FontSize->10], GridBox[{
                 {
                  TagBox[
                   StyleBox["\[Psi]",
                    LineColor->RGBColor[1, 0, 0],
                    FrontFaceColor->RGBColor[1, 0, 0],
                    BackFaceColor->RGBColor[1, 0, 0],
                    GraphicsColor->RGBColor[1, 0, 0],
                    FontColor->RGBColor[1, 0, 0]],
                   "GREFX",
                   Selectable->False]}
                },
                Selectable->True]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            "GRED",
            Selectable->False], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        TagBox[GridBox[{
           {"\[PartialD]", 
            StyleBox[GridBox[{
               {"2"},
               {"\[Eta]"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}},
              Selectable->True],
             FontSize->10], GridBox[{
              {
               TagBox[
                StyleBox["\[Psi]",
                 LineColor->RGBColor[1, 0, 0],
                 FrontFaceColor->RGBColor[1, 0, 0],
                 BackFaceColor->RGBColor[1, 0, 0],
                 GraphicsColor->RGBColor[1, 0, 0],
                 FontColor->RGBColor[1, 0, 0]],
                "GREFX",
                Selectable->False]}
             },
             Selectable->True]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         "GRED",
         Selectable->False], ")"}]}]}], ")"}]}]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{
      Null, Null}, {$CellContext`\[Mu], $CellContext`\[Nu]}}]], 
   " = ", -$CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 - 2 
   Derivative[
    1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + \
$CellContext`eps (
     2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 ($CellContext`\
\[Phi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, $CellContext`z] + \
$CellContext`\[Psi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, \
$CellContext`z]) + 
     4 $CellContext`\[Phi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] 
      Derivative[1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + 
     4 $CellContext`\[Psi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] 
      Derivative[1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + 
     Derivative[
      0, 0, 2, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
     0, 0, 2, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
     Derivative[
      0, 2, 0, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
     0, 2, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
     2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] (
       Derivative[
        1, 0, 0, 
         0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
       2 Derivative[
         1, 0, 0, 
          0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]) + 
     2 Derivative[
       2, 0, 0, 
        0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697240147404647*^9, 3.6972403601643004`*^9, 
  3.6972406165974054`*^9, 3.6972406496064*^9, 3.697240984311889*^9, 
  3.6972411992463512`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Print\[DoubleStruckCapitalG]ud", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"\[Eta]", ""},
            {"", "\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox[
       TagBox[
        StyleBox["\[ScriptCapitalH]",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], "2"]}], 
     SuperscriptBox[
      TagBox[
       StyleBox["a",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]]}], "+", 
   FractionBox[
    RowBox[{"2", " ", "eps", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], " ", 
        SuperscriptBox[
         TagBox[
          StyleBox["\[ScriptCapitalH]",
           LineColor->RGBColor[0.5, 0, 0.5],
           FrontFaceColor->RGBColor[0.5, 0, 0.5],
           BackFaceColor->RGBColor[0.5, 0, 0.5],
           GraphicsColor->RGBColor[0.5, 0, 0.5],
           FontColor->RGBColor[0.5, 0, 0.5]],
          "GREFX0",
          Selectable->False], "2"], " ", 
        TagBox[
         StyleBox["\[Phi]",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False]}], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"x"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       RowBox[{"3", " ", 
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], " ", 
        RowBox[{"(", 
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {""},
                {"\[Eta]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Psi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], ")"}]}]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], " = ", 
   3 $CellContext`a[$CellContext`\[Eta]]^(-2) \
$CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 + 
   2 $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) ((-3) \
$CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 \
$CellContext`\[Phi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, \
$CellContext`z] + 
     Derivative[
      0, 0, 0, 2][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
     Derivative[
      0, 0, 2, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
     Derivative[
      0, 2, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - 
     3 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] 
     Derivative[
      1, 0, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.697241199390439*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"\[Eta]", ""},
           {"", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{"2", " ", "eps", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], " ", 
        RowBox[{"(", 
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {""},
                {"x"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Phi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], ")"}]}], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"\[Eta]", "x"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], " = ", 
   2 $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) ($CellContext`\
\[ScriptCapitalH][$CellContext`\[Eta]] 
     Derivative[
      0, 1, 0, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     1, 1, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.6972411993984394`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"\[Eta]", ""},
           {"", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{"2", " ", "eps", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], " ", 
        RowBox[{"(", 
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {""},
                {"y"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Phi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], ")"}]}], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"\[Eta]", "y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], " = ", 
   2 $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) ($CellContext`\
\[ScriptCapitalH][$CellContext`\[Eta]] 
     Derivative[
      0, 0, 1, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     1, 0, 1, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.697241199406441*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"\[Eta]", ""},
           {"", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{"2", " ", "eps", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], " ", 
        RowBox[{"(", 
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {""},
                {"z"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Phi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], ")"}]}], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"\[Eta]", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], " = ", 
   2 $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) ($CellContext`\
\[ScriptCapitalH][$CellContext`\[Eta]] 
     Derivative[
      0, 0, 0, 1][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     1, 0, 0, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.6972411994104395`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"x", ""},
            {"", "\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>"}], "\[InvisibleSpace]", 
   "-", 
   FractionBox[
    RowBox[{"2", " ", "eps", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], " ", 
        RowBox[{"(", 
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {""},
                {"x"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Phi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], ")"}]}], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"\[Eta]", "x"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", (-2) $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) \
($CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] 
     Derivative[
      0, 1, 0, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     1, 1, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.6972411994144435`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"x", ""},
            {"", "x"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       TagBox[
        StyleBox["\[ScriptCapitalH]",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], "2"], "+", 
      RowBox[{"2", " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}]}], 
     SuperscriptBox[
      TagBox[
       StyleBox["a",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]]}], "-", 
   FractionBox[
    RowBox[{"eps", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", 
        SuperscriptBox[
         TagBox[
          StyleBox["\[ScriptCapitalH]",
           LineColor->RGBColor[0.5, 0, 0.5],
           FrontFaceColor->RGBColor[0.5, 0, 0.5],
           BackFaceColor->RGBColor[0.5, 0, 0.5],
           GraphicsColor->RGBColor[0.5, 0, 0.5],
           FontColor->RGBColor[0.5, 0, 0.5]],
          "GREFX0",
          Selectable->False], "2"], " ", 
        TagBox[
         StyleBox["\[Phi]",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False]}], "+", 
       RowBox[{"4", " ", 
        TagBox[
         StyleBox["\[Phi]",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False], " ", 
        TagBox[
         StyleBox[
          SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
           MultilineFunction->None],
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False]}], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "+", 
       RowBox[{"2", " ", 
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], " ", 
        RowBox[{"(", 
         RowBox[{
          TagBox[GridBox[{
             {"\[PartialD]", 
              StyleBox[GridBox[{
                 {""},
                 {"\[Eta]"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                Selectable->True],
               FontSize->10], GridBox[{
                {
                 TagBox[
                  StyleBox["\[Phi]",
                   LineColor->RGBColor[1, 0, 0],
                   FrontFaceColor->RGBColor[1, 0, 0],
                   BackFaceColor->RGBColor[1, 0, 0],
                   GraphicsColor->RGBColor[1, 0, 0],
                   FontColor->RGBColor[1, 0, 0]],
                  "GREFX",
                  Selectable->False]}
               },
               Selectable->True]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           "GRED",
           Selectable->False], "+", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            TagBox[GridBox[{
               {"\[PartialD]", 
                StyleBox[GridBox[{
                   {""},
                   {"\[Eta]"}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                  Selectable->True],
                 FontSize->10], GridBox[{
                  {
                   TagBox[
                    StyleBox["\[Psi]",
                    LineColor->RGBColor[1, 0, 0],
                    FrontFaceColor->RGBColor[1, 0, 0],
                    BackFaceColor->RGBColor[1, 0, 0],
                    GraphicsColor->RGBColor[1, 0, 0],
                    FontColor->RGBColor[1, 0, 0]],
                    "GREFX",
                    Selectable->False]}
                 },
                 Selectable->True]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             "GRED",
             Selectable->False], ")"}]}]}], ")"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {"2"},
                {"\[Eta]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Psi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], ")"}]}]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", $CellContext`a[$CellContext`\[Eta]]^(-2) ($CellContext`\
\[ScriptCapitalH][$CellContext`\[Eta]]^2 + 
     2 Derivative[
       1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]]) - \
$CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) (
    2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 $CellContext`\
\[Phi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, $CellContext`z] + 
    4 $CellContext`\[Phi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] 
     Derivative[1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + 
    Derivative[
     0, 0, 0, 2][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 0, 0, 2][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     0, 0, 2, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 0, 2, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] (
      Derivative[
       1, 0, 0, 
        0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
      2 Derivative[
        1, 0, 0, 
         0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]) + 
    2 Derivative[
      2, 0, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.6972411994224405`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"x", ""},
           {"", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{"eps", " ", 
     RowBox[{"(", 
      RowBox[{
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"x", "y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"x", "y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) (
    Derivative[
     0, 1, 1, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 1, 1, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.6972411994304414`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"x", ""},
           {"", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{"eps", " ", 
     RowBox[{"(", 
      RowBox[{
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"x", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"x", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) (
    Derivative[
     0, 1, 0, 1][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 1, 0, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.6972411994344435`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"y", ""},
            {"", "\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>"}], "\[InvisibleSpace]", 
   "-", 
   FractionBox[
    RowBox[{"2", " ", "eps", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], " ", 
        RowBox[{"(", 
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {""},
                {"y"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Phi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], ")"}]}], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"\[Eta]", "y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", (-2) $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) \
($CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] 
     Derivative[
      0, 0, 1, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     1, 0, 1, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.697241199438439*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"y", ""},
           {"", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{"eps", " ", 
     RowBox[{"(", 
      RowBox[{
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"x", "y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"x", "y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) (
    Derivative[
     0, 1, 1, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 1, 1, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.6972411994470215`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"y", ""},
            {"", "y"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       TagBox[
        StyleBox["\[ScriptCapitalH]",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], "2"], "+", 
      RowBox[{"2", " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}]}], 
     SuperscriptBox[
      TagBox[
       StyleBox["a",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]]}], "-", 
   FractionBox[
    RowBox[{"eps", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", 
        SuperscriptBox[
         TagBox[
          StyleBox["\[ScriptCapitalH]",
           LineColor->RGBColor[0.5, 0, 0.5],
           FrontFaceColor->RGBColor[0.5, 0, 0.5],
           BackFaceColor->RGBColor[0.5, 0, 0.5],
           GraphicsColor->RGBColor[0.5, 0, 0.5],
           FontColor->RGBColor[0.5, 0, 0.5]],
          "GREFX0",
          Selectable->False], "2"], " ", 
        TagBox[
         StyleBox["\[Phi]",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False]}], "+", 
       RowBox[{"4", " ", 
        TagBox[
         StyleBox["\[Phi]",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False], " ", 
        TagBox[
         StyleBox[
          SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
           MultilineFunction->None],
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False]}], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"x"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"x"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "+", 
       RowBox[{"2", " ", 
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], " ", 
        RowBox[{"(", 
         RowBox[{
          TagBox[GridBox[{
             {"\[PartialD]", 
              StyleBox[GridBox[{
                 {""},
                 {"\[Eta]"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                Selectable->True],
               FontSize->10], GridBox[{
                {
                 TagBox[
                  StyleBox["\[Phi]",
                   LineColor->RGBColor[1, 0, 0],
                   FrontFaceColor->RGBColor[1, 0, 0],
                   BackFaceColor->RGBColor[1, 0, 0],
                   GraphicsColor->RGBColor[1, 0, 0],
                   FontColor->RGBColor[1, 0, 0]],
                  "GREFX",
                  Selectable->False]}
               },
               Selectable->True]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           "GRED",
           Selectable->False], "+", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            TagBox[GridBox[{
               {"\[PartialD]", 
                StyleBox[GridBox[{
                   {""},
                   {"\[Eta]"}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                  Selectable->True],
                 FontSize->10], GridBox[{
                  {
                   TagBox[
                    StyleBox["\[Psi]",
                    LineColor->RGBColor[1, 0, 0],
                    FrontFaceColor->RGBColor[1, 0, 0],
                    BackFaceColor->RGBColor[1, 0, 0],
                    GraphicsColor->RGBColor[1, 0, 0],
                    FontColor->RGBColor[1, 0, 0]],
                    "GREFX",
                    Selectable->False]}
                 },
                 Selectable->True]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             "GRED",
             Selectable->False], ")"}]}]}], ")"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {"2"},
                {"\[Eta]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Psi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], ")"}]}]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", $CellContext`a[$CellContext`\[Eta]]^(-2) ($CellContext`\
\[ScriptCapitalH][$CellContext`\[Eta]]^2 + 
     2 Derivative[
       1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]]) - \
$CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) (
    2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 $CellContext`\
\[Phi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, $CellContext`z] + 
    4 $CellContext`\[Phi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] 
     Derivative[1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + 
    Derivative[
     0, 0, 0, 2][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 0, 0, 2][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     0, 2, 0, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 2, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] (
      Derivative[
       1, 0, 0, 
        0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
      2 Derivative[
        1, 0, 0, 
         0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]) + 
    2 Derivative[
      2, 0, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.697241199454039*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"y", ""},
           {"", "z"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{"eps", " ", 
     RowBox[{"(", 
      RowBox[{
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"y", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"y", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) (
    Derivative[
     0, 0, 1, 1][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 0, 1, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.697241199458555*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"z", ""},
            {"", "\[Eta]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>"}], "\[InvisibleSpace]", 
   "-", 
   FractionBox[
    RowBox[{"2", " ", "eps", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], " ", 
        RowBox[{"(", 
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {""},
                {"z"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Phi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], ")"}]}], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"\[Eta]", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", (-2) $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) \
($CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] 
     Derivative[
      0, 0, 0, 1][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     1, 0, 0, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.697241199462591*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"z", ""},
           {"", "x"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{"eps", " ", 
     RowBox[{"(", 
      RowBox[{
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"x", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"x", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) (
    Derivative[
     0, 1, 0, 1][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 1, 0, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.697241199466589*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TagBox[GridBox[{
       {GridBox[{
          {"\[DoubleStruckCapitalG]"}
         },
         Selectable->True], 
        StyleBox[GridBox[{
           {"z", ""},
           {"", "y"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True],
         FontSize->10]}
      },
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "GRETsr",
     Selectable->False],
    HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{"eps", " ", 
     RowBox[{"(", 
      RowBox[{
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"y", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"", ""},
              {"y", "z"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", $CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) (
    Derivative[
     0, 0, 1, 1][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 0, 1, 1][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.6972411994705915`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    TagBox[
     TagBox[GridBox[{
        {GridBox[{
           {"\[DoubleStruckCapitalG]"}
          },
          Selectable->True], 
         StyleBox[GridBox[{
            {"z", ""},
            {"", "z"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True],
          FontSize->10]}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "GRETsr",
      Selectable->False],
     HoldForm], "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       TagBox[
        StyleBox["\[ScriptCapitalH]",
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False], "2"], "+", 
      RowBox[{"2", " ", 
       TagBox[
        StyleBox[
         SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
          MultilineFunction->None],
         LineColor->RGBColor[0.5, 0, 0.5],
         FrontFaceColor->RGBColor[0.5, 0, 0.5],
         BackFaceColor->RGBColor[0.5, 0, 0.5],
         GraphicsColor->RGBColor[0.5, 0, 0.5],
         FontColor->RGBColor[0.5, 0, 0.5]],
        "GREFX0",
        Selectable->False]}]}], 
     SuperscriptBox[
      TagBox[
       StyleBox["a",
        LineColor->RGBColor[0.5, 0, 0.5],
        FrontFaceColor->RGBColor[0.5, 0, 0.5],
        BackFaceColor->RGBColor[0.5, 0, 0.5],
        GraphicsColor->RGBColor[0.5, 0, 0.5],
        FontColor->RGBColor[0.5, 0, 0.5]],
       "GREFX0",
       Selectable->False], "2"]]}], "-", 
   FractionBox[
    RowBox[{"eps", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", 
        SuperscriptBox[
         TagBox[
          StyleBox["\[ScriptCapitalH]",
           LineColor->RGBColor[0.5, 0, 0.5],
           FrontFaceColor->RGBColor[0.5, 0, 0.5],
           BackFaceColor->RGBColor[0.5, 0, 0.5],
           GraphicsColor->RGBColor[0.5, 0, 0.5],
           FontColor->RGBColor[0.5, 0, 0.5]],
          "GREFX0",
          Selectable->False], "2"], " ", 
        TagBox[
         StyleBox["\[Phi]",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False]}], "+", 
       RowBox[{"4", " ", 
        TagBox[
         StyleBox["\[Phi]",
          LineColor->RGBColor[1, 0, 0],
          FrontFaceColor->RGBColor[1, 0, 0],
          BackFaceColor->RGBColor[1, 0, 0],
          GraphicsColor->RGBColor[1, 0, 0],
          FontColor->RGBColor[1, 0, 0]],
         "GREFX",
         Selectable->False], " ", 
        TagBox[
         StyleBox[
          SuperscriptBox["\[ScriptCapitalH]", "\[Prime]",
           MultilineFunction->None],
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False]}], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"y"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "+", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"x"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Phi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "-", 
       TagBox[GridBox[{
          {"\[PartialD]", 
           StyleBox[GridBox[{
              {"2"},
              {"x"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}},
             Selectable->True],
            FontSize->10], GridBox[{
             {
              TagBox[
               StyleBox["\[Psi]",
                LineColor->RGBColor[1, 0, 0],
                FrontFaceColor->RGBColor[1, 0, 0],
                BackFaceColor->RGBColor[1, 0, 0],
                GraphicsColor->RGBColor[1, 0, 0],
                FontColor->RGBColor[1, 0, 0]],
               "GREFX",
               Selectable->False]}
            },
            Selectable->True]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        "GRED",
        Selectable->False], "+", 
       RowBox[{"2", " ", 
        TagBox[
         StyleBox["\[ScriptCapitalH]",
          LineColor->RGBColor[0.5, 0, 0.5],
          FrontFaceColor->RGBColor[0.5, 0, 0.5],
          BackFaceColor->RGBColor[0.5, 0, 0.5],
          GraphicsColor->RGBColor[0.5, 0, 0.5],
          FontColor->RGBColor[0.5, 0, 0.5]],
         "GREFX0",
         Selectable->False], " ", 
        RowBox[{"(", 
         RowBox[{
          TagBox[GridBox[{
             {"\[PartialD]", 
              StyleBox[GridBox[{
                 {""},
                 {"\[Eta]"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                Selectable->True],
               FontSize->10], GridBox[{
                {
                 TagBox[
                  StyleBox["\[Phi]",
                   LineColor->RGBColor[1, 0, 0],
                   FrontFaceColor->RGBColor[1, 0, 0],
                   BackFaceColor->RGBColor[1, 0, 0],
                   GraphicsColor->RGBColor[1, 0, 0],
                   FontColor->RGBColor[1, 0, 0]],
                  "GREFX",
                  Selectable->False]}
               },
               Selectable->True]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           "GRED",
           Selectable->False], "+", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            TagBox[GridBox[{
               {"\[PartialD]", 
                StyleBox[GridBox[{
                   {""},
                   {"\[Eta]"}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}},
                  Selectable->True],
                 FontSize->10], GridBox[{
                  {
                   TagBox[
                    StyleBox["\[Psi]",
                    LineColor->RGBColor[1, 0, 0],
                    FrontFaceColor->RGBColor[1, 0, 0],
                    BackFaceColor->RGBColor[1, 0, 0],
                    GraphicsColor->RGBColor[1, 0, 0],
                    FontColor->RGBColor[1, 0, 0]],
                    "GREFX",
                    Selectable->False]}
                 },
                 Selectable->True]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             "GRED",
             Selectable->False], ")"}]}]}], ")"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         TagBox[GridBox[{
            {"\[PartialD]", 
             StyleBox[GridBox[{
                {"2"},
                {"\[Eta]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}},
               Selectable->True],
              FontSize->10], GridBox[{
               {
                TagBox[
                 StyleBox["\[Psi]",
                  LineColor->RGBColor[1, 0, 0],
                  FrontFaceColor->RGBColor[1, 0, 0],
                  BackFaceColor->RGBColor[1, 0, 0],
                  GraphicsColor->RGBColor[1, 0, 0],
                  FontColor->RGBColor[1, 0, 0]],
                 "GREFX",
                 Selectable->False]}
              },
              Selectable->True]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          "GRED",
          Selectable->False], ")"}]}]}], ")"}]}], 
    SuperscriptBox[
     TagBox[
      StyleBox["a",
       LineColor->RGBColor[0.5, 0, 0.5],
       FrontFaceColor->RGBColor[0.5, 0, 0.5],
       BackFaceColor->RGBColor[0.5, 0, 0.5],
       GraphicsColor->RGBColor[0.5, 0, 0.5],
       FontColor->RGBColor[0.5, 0, 0.5]],
      "GREFX0",
      Selectable->False], "2"]]}],
  SequenceForm[
   HoldForm[
    $CellContext`GRETsr[$CellContext`\[DoubleStruckCapitalG], {{$CellContext`\
\[Lambda], Null}, {Null, $CellContext`\[Nu]}}]], 
   " = ", $CellContext`a[$CellContext`\[Eta]]^(-2) ($CellContext`\
\[ScriptCapitalH][$CellContext`\[Eta]]^2 + 
     2 Derivative[
       1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]]) - \
$CellContext`eps $CellContext`a[$CellContext`\[Eta]]^(-2) (
    2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]]^2 $CellContext`\
\[Phi][$CellContext`\[Eta], $CellContext`x, $CellContext`y, $CellContext`z] + 
    4 $CellContext`\[Phi][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] 
     Derivative[1][$CellContext`\[ScriptCapitalH]][$CellContext`\[Eta]] + 
    Derivative[
     0, 0, 2, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 0, 2, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    Derivative[
     0, 2, 0, 0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] - Derivative[
    0, 2, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
    2 $CellContext`\[ScriptCapitalH][$CellContext`\[Eta]] (
      Derivative[
       1, 0, 0, 
        0][$CellContext`\[Phi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z] + 
      2 Derivative[
        1, 0, 0, 
         0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z]) + 
    2 Derivative[
      2, 0, 0, 0][$CellContext`\[Psi]][$CellContext`\[Eta], $CellContext`x, \
$CellContext`y, $CellContext`z])],
  Editable->False]], "Print",
 CellChangeTimes->{3.697239811738802*^9, 3.6972403646991777`*^9, 
  3.69724061699798*^9, 3.697240649954142*^9, 3.697240984523021*^9, 
  3.6972411994785905`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1292, 1714},
WindowMargins->{{-11, Automatic}, {Automatic, 0}},
InputAliases->{"addia" -> RowBox[{"AddInputAlias", "[", 
     RowBox[{"\"\[SelectionPlaceholder]\"", "\[Rule]", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], "bra" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "Bra"], "braket" -> 
  TemplateBox[{"\[SelectionPlaceholder]", "\[Placeholder]"}, "BraKet"], 
  "cbrt" -> RadicalBox[
   "\[SelectionPlaceholder]", "3", SurdForm -> True, MultilineFunction -> 
    None], "del." -> RowBox[{
     SubscriptBox["\[Del]", "\[SelectionPlaceholder]"], ".", 
     "\[Placeholder]"}], "del2" -> RowBox[{
     SubsuperscriptBox["\[Del]", "\[SelectionPlaceholder]", 2], 
     "\[Placeholder]"}], "delay" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "SystemsModelDelay"], "delx" -> 
  RowBox[{
     SubscriptBox["\[Del]", "\[SelectionPlaceholder]"], "\[Cross]", 
     "\[Placeholder]"}], "dintt" -> RowBox[{
     SubsuperscriptBox[
     "\[Integral]", "\[SelectionPlaceholder]", "\[Placeholder]"], 
     RowBox[{"\[Placeholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "dt" -> RowBox[{
     SubscriptBox["\[PartialD]", "\[Placeholder]"], " ", 
     "\[SelectionPlaceholder]"}], "e0" -> TagBox[
    StyleBox["\[SelectionPlaceholder]", 
     RGBColor[0.5, 0, 0.5]], "GREFX0", Selectable -> False], "ed" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{""}, {"\[Placeholder]"}}, ColumnSpacings -> 0, RowSpacings -> 
         0, Selectable -> True], FontSize -> 10]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0], "GRETsr", Selectable -> False], "edd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"", ""}, {"\[Placeholder]", "\[Placeholder]"}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "edddd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"", "", "", ""}, {
          "\[Placeholder]", "\[Placeholder]", "\[Placeholder]", 
           "\[Placeholder]"}}, ColumnSpacings -> 0, RowSpacings -> 0, 
         Selectable -> True], FontSize -> 10]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0], "GRETsr", Selectable -> False], "edu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"", "\[Placeholder]"}, {"\[Placeholder]", ""}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "ep" -> RowBox[{
     SubscriptBox["\[PartialD]", 
      RowBox[{"\[SelectionPlaceholder]"}]], "\[Placeholder]"}], "et" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]"}, {"\[Placeholder]"}}, ColumnSpacings -> 0,
          RowSpacings -> 0, Selectable -> True], FontSize -> 10]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> False], 
  "eu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]"}, {""}}, ColumnSpacings -> 0, RowSpacings -> 
         0, Selectable -> True], FontSize -> 10]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0], "GRETsr", Selectable -> False], "eud" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", ""}, {"", "\[Placeholder]"}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "eudd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", "", ""}, {
          "", "\[Placeholder]", "\[Placeholder]"}}, ColumnSpacings -> 0, 
         RowSpacings -> 0, Selectable -> True], FontSize -> 10]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> False], 
  "euddd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", "", "", ""}, {
          "", "\[Placeholder]", "\[Placeholder]", "\[Placeholder]"}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "euu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       StyleBox[
        GridBox[{{"\[Placeholder]", "\[Placeholder]"}, {"", ""}}, 
         ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> True], FontSize -> 
        10]}}, ColumnSpacings -> 0, RowSpacings -> 0], "GRETsr", Selectable -> 
    False], "ex" -> TagBox[
    StyleBox["\[SelectionPlaceholder]", 
     RGBColor[1, 0, 0]], "GREFX", Selectable -> False], "grad" -> RowBox[{
     SubscriptBox["\[Del]", "\[SelectionPlaceholder]"], "\[Placeholder]"}], 
  "ia" -> TemplateBox[{"\[SelectionPlaceholder]"}, "Inactive"], 
  "infixnotation" -> RowBox[{"InfixNotation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], ",", 
       "\[Placeholder]"}], "]"}], "intt" -> RowBox[{"\[Integral]", 
     RowBox[{"\[SelectionPlaceholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "ket" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "Ket"], "madeboxeswraper" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "NotationMadeBoxesTag"], 
  "notation" -> RowBox[{"Notation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], " ", 
       "\[DoubleLongLeftRightArrow]", " ", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], 
  "notation<" -> RowBox[{"Notation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], " ", 
       "\[DoubleLongLeftArrow]", " ", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], 
  "notation>" -> RowBox[{"Notation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], " ", 
       "\[DoubleLongRightArrow]", " ", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], 
  "pattwraper" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "NotationPatternTag"], "prodt" -> 
  RowBox[{
     UnderoverscriptBox["\[Product]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "sumt" -> RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "surd" -> 
  RadicalBox[
   "\[SelectionPlaceholder]", "\[Placeholder]", SurdForm -> True, 
    MultilineFunction -> None], "symb" -> RowBox[{"Symbolize", "[", 
     TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], "]"}], 
  "td" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{""}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10]}}, 
        ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "td0" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{""}, {
          StyleBox[
           TagBox[
            GridBox[{{"0"}}, Selectable -> True], MathGR`tensor`DE], 
           FontColor -> GrayLevel[0.5], FontSize -> 10]}}, ColumnSpacings -> 
        0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, RowSpacings -> 0, 
     Selectable -> False], "mgrTensor", SyntaxForm -> "symbol", Selectable -> 
    False], "td0d0" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", ""}, {
          StyleBox[
           TagBox[
            GridBox[{{"0"}}, Selectable -> True], MathGR`tensor`DE], 
           FontColor -> GrayLevel[0.5], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"0"}}, Selectable -> True], MathGR`tensor`DE], 
           FontColor -> GrayLevel[0.5], FontSize -> 10]}}, ColumnSpacings -> 
        0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, RowSpacings -> 0, 
     Selectable -> False], "mgrTensor", SyntaxForm -> "symbol", Selectable -> 
    False], "td0u0" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", 
          StyleBox[
           TagBox[
            GridBox[{{"0"}}, Selectable -> True], MathGR`tensor`UE], 
           FontColor -> GrayLevel[0.5], FontSize -> 10]}, {
          StyleBox[
           TagBox[
            GridBox[{{"0"}}, Selectable -> True], MathGR`tensor`DE], 
           FontColor -> GrayLevel[0.5], FontSize -> 10], ""}}, ColumnSpacings -> 
        0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, RowSpacings -> 0, 
     Selectable -> False], "mgrTensor", SyntaxForm -> "symbol", Selectable -> 
    False], "td1" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{""}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`D1], FontColor -> GrayLevel[0], FontSize -> 10]}}, 
        ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "td1d1" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", ""}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`D1], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`D1], FontColor -> GrayLevel[0], FontSize -> 10]}}, 
        ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "td1u1" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`U1], FontColor -> GrayLevel[0], FontSize -> 10]}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`D1], FontColor -> GrayLevel[0], FontSize -> 10], 
          ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 
     0, RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "td2" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{""}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`D2], FontColor -> RGBColor[1, 0, 0], FontSize -> 
           10]}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 
     0, RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "td2d2" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", ""}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`D2], FontColor -> RGBColor[1, 0, 0], FontSize -> 
           10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`D2], FontColor -> RGBColor[1, 0, 0], FontSize -> 
           10]}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 
     0, RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "td2u2" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`U2], FontColor -> RGBColor[1, 0, 0], FontSize -> 
           10]}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`D2], FontColor -> RGBColor[1, 0, 0], FontSize -> 
           10], ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> False], "mgrTensor",
     SyntaxForm -> "symbol", Selectable -> False], "tdd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", ""}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10]}}, 
        ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tddd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", "", ""}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10]}}, 
        ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tdddd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", "", "", ""}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10]}}, 
        ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tdt" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{""}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DTot], FontColor -> RGBColor[0, 0, 1], FontSize -> 
           10]}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 
     0, RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tdtdt" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", ""}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DTot], FontColor -> RGBColor[0, 0, 1], FontSize -> 
           10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DTot], FontColor -> RGBColor[0, 0, 1], FontSize -> 
           10]}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 
     0, RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tdtut" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UTot], FontColor -> RGBColor[0, 0, 1], FontSize -> 
           10]}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DTot], FontColor -> RGBColor[0, 0, 1], FontSize -> 
           10], ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> False], "mgrTensor",
     SyntaxForm -> "symbol", Selectable -> False], "tdu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{"", 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10]}, {
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10], 
          ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 
     0, RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tp" -> TagBox[
    RowBox[{
      GridBox[{{
         TagBox[
          GridBox[{{
             GridBox[{{"\[CapitalSampi]"}}, Selectable -> True], 
             GridBox[{{""}, {
                StyleBox[
                 TagBox[
                  
                  GridBox[{{"\"\[SelectionPlaceholder]\""}}, Selectable -> 
                   True], MathGR`tensor`DN], FontColor -> GrayLevel[0], 
                 FontSize -> 10]}}, ColumnSpacings -> 0, 
              RowSpacings -> -0.5]}}, ColumnSpacings -> 0, RowSpacings -> 0, 
           Selectable -> False], "mgrTensor", SyntaxForm -> "symbol", 
          Selectable -> False], 
         GridBox[{{"\[Placeholder]"}}, Selectable -> True]}}, ColumnSpacings -> 
       0, RowSpacings -> 0], ""}], "mgrPd", Selectable -> False], "tp0" -> 
  OverscriptBox["\[SelectionPlaceholder]", "\[Bullet]"], "tp1" -> TagBox[
    RowBox[{
      GridBox[{{
         TagBox[
          GridBox[{{
             GridBox[{{"\[CapitalSampi]"}}, Selectable -> True], 
             GridBox[{{""}, {
                StyleBox[
                 TagBox[
                  
                  GridBox[{{"\"\[SelectionPlaceholder]\""}}, Selectable -> 
                   True], MathGR`tensor`D1], FontColor -> GrayLevel[0], 
                 FontSize -> 10]}}, ColumnSpacings -> 0, 
              RowSpacings -> -0.5]}}, ColumnSpacings -> 0, RowSpacings -> 0, 
           Selectable -> False], "mgrTensor", SyntaxForm -> "symbol", 
          Selectable -> False], 
         GridBox[{{"\[Placeholder]"}}, Selectable -> True]}}, ColumnSpacings -> 
       0, RowSpacings -> 0], ""}], "mgrPd", Selectable -> False], "tp2" -> 
  TagBox[
    RowBox[{
      GridBox[{{
         TagBox[
          GridBox[{{
             GridBox[{{"\[CapitalSampi]"}}, Selectable -> True], 
             GridBox[{{""}, {
                StyleBox[
                 TagBox[
                  
                  GridBox[{{"\"\[SelectionPlaceholder]\""}}, Selectable -> 
                   True], MathGR`tensor`D2], FontColor -> RGBColor[1, 0, 0], 
                 FontSize -> 10]}}, ColumnSpacings -> 0, 
              RowSpacings -> -0.5]}}, ColumnSpacings -> 0, RowSpacings -> 0, 
           Selectable -> False], "mgrTensor", SyntaxForm -> "symbol", 
          Selectable -> False], 
         GridBox[{{"\[Placeholder]"}}, Selectable -> True]}}, ColumnSpacings -> 
       0, RowSpacings -> 0], ""}], "mgrPd", Selectable -> False], "tpt" -> 
  TagBox[
    RowBox[{
      GridBox[{{
         TagBox[
          GridBox[{{
             GridBox[{{"\[CapitalSampi]"}}, Selectable -> True], 
             GridBox[{{""}, {
                StyleBox[
                 TagBox[
                  
                  GridBox[{{"\"\[SelectionPlaceholder]\""}}, Selectable -> 
                   True], MathGR`tensor`DTot], FontColor -> RGBColor[0, 0, 1],
                  FontSize -> 10]}}, ColumnSpacings -> 0, 
              RowSpacings -> -0.5]}}, ColumnSpacings -> 0, RowSpacings -> 0, 
           Selectable -> False], "mgrTensor", SyntaxForm -> "symbol", 
          Selectable -> False], 
         GridBox[{{"\[Placeholder]"}}, Selectable -> True]}}, ColumnSpacings -> 
       0, RowSpacings -> 0], ""}], "mgrPd", Selectable -> False], "tu" -> 
  TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10]}, {
         ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 
     0, RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tu0" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"0"}}, Selectable -> True], MathGR`tensor`UE], 
           FontColor -> GrayLevel[0.5], FontSize -> 10]}, {""}}, 
        ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tu0d0" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"0"}}, Selectable -> True], MathGR`tensor`UE], 
           FontColor -> GrayLevel[0.5], FontSize -> 10], ""}, {"", 
          StyleBox[
           TagBox[
            GridBox[{{"0"}}, Selectable -> True], MathGR`tensor`DE], 
           FontColor -> GrayLevel[0.5], FontSize -> 10]}}, ColumnSpacings -> 
        0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, RowSpacings -> 0, 
     Selectable -> False], "mgrTensor", SyntaxForm -> "symbol", Selectable -> 
    False], "tu0u0" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"0"}}, Selectable -> True], MathGR`tensor`UE], 
           FontColor -> GrayLevel[0.5], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"0"}}, Selectable -> True], MathGR`tensor`UE], 
           FontColor -> GrayLevel[0.5], FontSize -> 10]}, {"", ""}}, 
        ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tu1" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`U1], FontColor -> GrayLevel[0], FontSize -> 10]}, {
         ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 
     0, RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tu1d1" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`U1], FontColor -> GrayLevel[0], FontSize -> 10], 
          ""}, {"", 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`D1], FontColor -> GrayLevel[0], FontSize -> 10]}}, 
        ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tu1u1" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`U1], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`U1], FontColor -> GrayLevel[0], FontSize -> 10]}, {
         "", ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> False], "mgrTensor",
     SyntaxForm -> "symbol", Selectable -> False], "tu2" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`U2], FontColor -> RGBColor[1, 0, 0], FontSize -> 
           10]}, {""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> False], "mgrTensor",
     SyntaxForm -> "symbol", Selectable -> False], "tu2d2" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`U2], FontColor -> RGBColor[1, 0, 0], FontSize -> 
           10], ""}, {"", 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`D2], FontColor -> RGBColor[1, 0, 0], FontSize -> 
           10]}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 
     0, RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tu2u2" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`U2], FontColor -> RGBColor[1, 0, 0], FontSize -> 
           10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`U2], FontColor -> RGBColor[1, 0, 0], FontSize -> 
           10]}, {"", ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> False], "mgrTensor",
     SyntaxForm -> "symbol", Selectable -> False], "tud" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10], 
          ""}, {"", 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10]}}, 
        ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tudd" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10], "",
           ""}, {"", 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DN], FontColor -> GrayLevel[0], FontSize -> 10]}}, 
        ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 0, 
     RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tut" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UTot], FontColor -> RGBColor[0, 0, 1], FontSize -> 
           10]}, {""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> False], "mgrTensor",
     SyntaxForm -> "symbol", Selectable -> False], "tutdt" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UTot], FontColor -> RGBColor[0, 0, 1], FontSize -> 
           10], ""}, {"", 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`DTot], FontColor -> RGBColor[0, 0, 1], FontSize -> 
           10]}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, ColumnSpacings -> 
     0, RowSpacings -> 0, Selectable -> False], "mgrTensor", SyntaxForm -> 
    "symbol", Selectable -> False], "tutut" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UTot], FontColor -> RGBColor[0, 0, 1], FontSize -> 
           10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UTot], FontColor -> RGBColor[0, 0, 1], FontSize -> 
           10]}, {"", ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> False], "mgrTensor",
     SyntaxForm -> "symbol", Selectable -> False], "tuu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10]}, {
         "", ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> False], "mgrTensor",
     SyntaxForm -> "symbol", Selectable -> False], "tuuu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10]}, {
         "", "", ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> False], "mgrTensor",
     SyntaxForm -> "symbol", Selectable -> False], "tuuuu" -> TagBox[
    GridBox[{{
       GridBox[{{"\[SelectionPlaceholder]"}}, Selectable -> True], 
       GridBox[{{
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10], 
          StyleBox[
           TagBox[
            GridBox[{{"\"\[Placeholder]\""}}, Selectable -> True], 
            MathGR`tensor`UP], FontColor -> GrayLevel[0], FontSize -> 10]}, {
         "", "", "", ""}}, ColumnSpacings -> 0, RowSpacings -> -0.5]}}, 
     ColumnSpacings -> 0, RowSpacings -> 0, Selectable -> False], "mgrTensor",
     SyntaxForm -> "symbol", Selectable -> False]},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (July 28, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 181, 4, 47, "Input"],
Cell[742, 26, 795, 24, 134, "Input"],
Cell[CellGroupData[{
Cell[1562, 54, 154, 5, 47, "Input"],
Cell[1719, 61, 1276, 40, 54, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3032, 106, 111, 3, 47, "Input"],
Cell[3146, 111, 1840, 52, 81, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5023, 168, 68, 1, 47, "Input"],
Cell[CellGroupData[{
Cell[5116, 173, 2155, 64, 47, "Print"],
Cell[7274, 239, 2153, 64, 47, "Print"],
Cell[9430, 305, 2152, 64, 47, "Print"],
Cell[11585, 371, 2156, 64, 60, "Print"],
Cell[13744, 437, 2158, 64, 60, "Print"],
Cell[15905, 503, 2158, 64, 60, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18112, 573, 77, 1, 47, "Input"],
Cell[CellGroupData[{
Cell[18214, 578, 2251, 66, 47, "Print"],
Cell[20468, 646, 2249, 66, 47, "Print"],
Cell[22720, 714, 2251, 66, 47, "Print"],
Cell[24974, 782, 2287, 67, 47, "Print"],
Cell[27264, 851, 2287, 67, 47, "Print"],
Cell[29554, 920, 2287, 67, 47, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31890, 993, 145, 2, 47, "Input"],
Cell[CellGroupData[{
Cell[32060, 999, 2217, 65, 60, "Print"],
Cell[34280, 1066, 2659, 78, 47, "Print"],
Cell[36942, 1146, 2661, 78, 47, "Print"],
Cell[39606, 1226, 2661, 78, 47, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[42316, 1310, 144, 2, 47, "Input"],
Cell[CellGroupData[{
Cell[42485, 1316, 2238, 66, 67, "Print"],
Cell[44726, 1384, 2662, 78, 47, "Print"],
Cell[47391, 1464, 2662, 78, 47, "Print"],
Cell[50056, 1544, 2662, 78, 47, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[52767, 1628, 78, 1, 47, "Input"],
Cell[CellGroupData[{
Cell[52870, 1633, 2282, 67, 67, "Print"],
Cell[55155, 1702, 3107, 90, 67, "Print"],
Cell[58265, 1794, 3109, 90, 67, "Print"],
Cell[61377, 1886, 3107, 90, 67, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[64533, 1982, 153, 3, 47, "Input"],
Cell[64689, 1987, 6565, 199, 109, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[71291, 2191, 843, 24, 117, "Input"],
Cell[72137, 2217, 7437, 229, 92, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79611, 2451, 369, 10, 56, "Input"],
Cell[79983, 2463, 8090, 256, 108, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[88110, 2724, 105, 1, 80, "Subsection"],
Cell[88218, 2727, 1393, 43, 212, "Input"],
Cell[CellGroupData[{
Cell[89636, 2774, 575, 18, 75, "Input"],
Cell[90214, 2794, 6364, 191, 174, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[96615, 2990, 316, 9, 56, "Input"],
Cell[96934, 3001, 8405, 262, 193, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[105388, 3269, 105, 1, 80, "Subsection"],
Cell[105496, 3272, 778, 23, 128, "Input"],
Cell[CellGroupData[{
Cell[106299, 3299, 142, 2, 47, "Input"],
Cell[106444, 3303, 3833, 112, 59, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[110314, 3420, 144, 2, 47, "Input"],
Cell[110461, 3424, 3549, 106, 47, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[114059, 3536, 140, 1, 80, "Subsection"],
Cell[114202, 3539, 2752, 77, 379, "Input"],
Cell[CellGroupData[{
Cell[116979, 3620, 132, 2, 47, "Input"],
Cell[117114, 3624, 1571, 47, 71, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[118722, 3676, 113, 1, 47, "Input"],
Cell[118838, 3679, 4877, 140, 121, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[123752, 3824, 117, 1, 47, "Input"],
Cell[123872, 3827, 5126, 149, 160, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129035, 3981, 134, 2, 47, "Input"],
Cell[CellGroupData[{
Cell[129194, 3987, 3293, 95, 47, "Print"],
Cell[132490, 4084, 2824, 84, 47, "Print"],
Cell[135317, 4170, 4649, 129, 47, "Print"],
Cell[139969, 4301, 2824, 84, 47, "Print"],
Cell[142796, 4387, 4649, 129, 47, "Print"],
Cell[147448, 4518, 2824, 84, 47, "Print"],
Cell[150275, 4604, 4649, 129, 47, "Print"],
Cell[154927, 4735, 2824, 84, 47, "Print"],
Cell[157754, 4821, 3279, 95, 47, "Print"],
Cell[161036, 4918, 2832, 84, 47, "Print"],
Cell[163871, 5004, 2832, 84, 47, "Print"],
Cell[166706, 5090, 2832, 84, 47, "Print"],
Cell[169541, 5176, 2816, 84, 47, "Print"],
Cell[172360, 5262, 2816, 84, 47, "Print"],
Cell[175179, 5348, 2826, 84, 47, "Print"],
Cell[178008, 5434, 2816, 84, 47, "Print"],
Cell[180827, 5520, 2832, 84, 47, "Print"],
Cell[183662, 5606, 3281, 95, 47, "Print"],
Cell[186946, 5703, 2832, 84, 47, "Print"],
Cell[189781, 5789, 2832, 84, 47, "Print"],
Cell[192616, 5875, 2814, 84, 47, "Print"],
Cell[195433, 5961, 2823, 84, 47, "Print"],
Cell[198259, 6047, 2814, 84, 47, "Print"],
Cell[201076, 6133, 2830, 84, 47, "Print"],
Cell[203909, 6219, 2814, 84, 47, "Print"],
Cell[206726, 6305, 2832, 84, 47, "Print"],
Cell[209561, 6391, 3281, 95, 47, "Print"],
Cell[212845, 6488, 2832, 84, 47, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[215726, 6578, 172, 3, 47, "Input"],
Cell[CellGroupData[{
Cell[215923, 6585, 8152, 230, 47, "Print"],
Cell[224078, 6817, 4731, 136, 47, "Print"],
Cell[228812, 6955, 16513, 456, 94, "Print"],
Cell[245328, 7413, 4348, 127, 47, "Print"],
Cell[249679, 7542, 4348, 127, 47, "Print"],
Cell[254030, 7671, 4734, 136, 47, "Print"],
Cell[258767, 7809, 16513, 456, 94, "Print"],
Cell[275283, 8267, 4350, 127, 47, "Print"],
Cell[279636, 8396, 4731, 136, 47, "Print"],
Cell[284370, 8534, 16513, 456, 94, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[300932, 8996, 78, 1, 47, "Input"],
Cell[CellGroupData[{
Cell[301035, 9001, 10044, 280, 76, "Print"],
Cell[311082, 9283, 5316, 149, 76, "Print"],
Cell[316401, 9434, 5314, 149, 76, "Print"],
Cell[321718, 9585, 5316, 149, 76, "Print"],
Cell[327037, 9736, 5372, 151, 76, "Print"],
Cell[332412, 9889, 16284, 445, 149, "Print"],
Cell[348699, 10336, 4775, 136, 76, "Print"],
Cell[353477, 10474, 4775, 136, 76, "Print"],
Cell[358255, 10612, 5370, 151, 76, "Print"],
Cell[363628, 10765, 4775, 136, 76, "Print"],
Cell[368406, 10903, 16282, 445, 149, "Print"],
Cell[384691, 11350, 4773, 136, 76, "Print"],
Cell[389467, 11488, 5370, 151, 76, "Print"],
Cell[394840, 11641, 4773, 136, 76, "Print"],
Cell[399616, 11779, 4775, 136, 76, "Print"],
Cell[404394, 11917, 16284, 445, 149, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

