(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     30579,        999]
NotebookOptionsPosition[     28671,        927]
NotebookOutlinePosition[     29059,        944]
CellTagsIndexPosition[     29016,        941]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"coord", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z", ",", "t"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", " ", "=", " ", 
   RowBox[{"Length", "[", "coord", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", "[", "t", "]"}], ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"a", "[", "t", "]"}], ",", "0", ",", "0"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{"a", "[", "t", "]"}], ",", "0"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gInverse", " ", "=", " ", 
   RowBox[{"Inverse", "[", "g", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalGamma]", "=", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Sum", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"gInverse", "\[LeftDoubleBracket]", 
          RowBox[{"\[Lambda]", ",", "\[Sigma]"}], "\[RightDoubleBracket]"}], 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"g", "\[LeftDoubleBracket]", 
              RowBox[{"\[Sigma]", ",", "\[Nu]"}], "\[RightDoubleBracket]"}], 
             ",", 
             RowBox[{
             "coord", "\[LeftDoubleBracket]", "\[Mu]", 
              "\[RightDoubleBracket]"}]}], "]"}], "\[IndentingNewLine]", "+", 
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"g", "\[LeftDoubleBracket]", 
              RowBox[{"\[Sigma]", ",", "\[Mu]"}], "\[RightDoubleBracket]"}], 
             ",", 
             RowBox[{
             "coord", "\[LeftDoubleBracket]", "\[Nu]", 
              "\[RightDoubleBracket]"}]}], "]"}], "\[IndentingNewLine]", "-", 
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"g", "\[LeftDoubleBracket]", 
              RowBox[{"\[Mu]", ",", "\[Nu]"}], "\[RightDoubleBracket]"}], ",", 
             RowBox[{
             "coord", "\[LeftDoubleBracket]", "\[Sigma]", 
              "\[RightDoubleBracket]"}]}], "]"}]}], ")"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"\[Sigma]", ",", "1", ",", "d"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"\[Lambda]", ",", "1", ",", "d"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Mu]", ",", "1", ",", "d"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Nu]", ",", "1", ",", "d"}], "}"}]}], "]"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{
  3.691144644013545*^9, {3.6911454122057905`*^9, 3.6911455603268185`*^9}, {
   3.6911455905089235`*^9, 3.691145655626412*^9}, {3.6911456986885977`*^9, 
   3.6911458005539846`*^9}, {3.6911458332937684`*^9, 3.691146043821662*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[CapitalGamma]", "\[LeftDoubleBracket]", 
  RowBox[{"1", ",", "1", ",", "4"}], "\[RightDoubleBracket]"}]], "Input",
 CellChangeTimes->{{3.6911460462230577`*^9, 3.691146080357868*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["a", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}], 
  RowBox[{"2", " ", 
   RowBox[{"a", "[", "t", "]"}]}]]], "Output",
 CellChangeTimes->{{3.6911460555950875`*^9, 3.691146080610878*^9}, 
   3.6911461367775087`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"result", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"\[Mu]", ",", "\[Nu]"}], "]"}], 
       RowBox[{"b", "[", 
        RowBox[{"\[Nu]", ",", "\[Lambda]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Nu]", ",", "1", ",", "4"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Lambda]", ",", "1", ",", "4"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.69114636559982*^9, 3.6911463866113863`*^9}, {
  3.6911464940393405`*^9, 3.6911465630102267`*^9}, {3.691146777244768*^9, 
  3.6911467808364363`*^9}, {3.6911469406175084`*^9, 3.6911469435619183`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "1"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "2"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "3"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"1", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "4"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "1"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "2"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "3"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"2", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "4"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "1"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "2"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "3"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"3", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "4"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "1"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "2"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "2"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "3"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "3"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "1"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "2"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"2", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "3"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"3", ",", "4"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"4", ",", "4"}], "]"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"4", ",", "4"}], "]"}]}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.691146563244323*^9, 3.691146782796923*^9, 
  3.6911469439365673`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"result", "/.", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"\[Mu]_", ",", "1"}], "]"}], 
    RowBox[{"b", "[", 
     RowBox[{"1", ",", "\[Lambda]_"}], "]"}]}], "\[RuleDelayed]", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{"\[Mu]", ",", "\[Nu]"}], "]"}], 
     RowBox[{"b", "[", 
      RowBox[{"\[Nu]", ",", "\[Lambda]"}], "]"}]}], "-", 
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{"\[Mu]", ",", "2"}], "]"}], 
     RowBox[{"b", "[", 
      RowBox[{"2", ",", "\[Lambda]"}], "]"}]}], "-", 
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{"\[Mu]", ",", "3"}], "]"}], 
     RowBox[{"b", "[", 
      RowBox[{"3", ",", "\[Lambda]"}], "]"}]}], "-", 
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{"\[Mu]", ",", "4"}], "]"}], 
     RowBox[{"b", "[", 
      RowBox[{"4", ",", "\[Lambda]"}], "]"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.6911468220053844`*^9, 3.691146893315735*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "1"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "2"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "3"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "4"}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "1"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "2"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "3"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "4"}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"3", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "1"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"3", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "2"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"3", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "3"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"3", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "4"}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"4", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "1"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"4", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "2"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"4", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "3"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"4", ",", "\[Nu]"}], "]"}], " ", 
      RowBox[{"b", "[", 
       RowBox[{"\[Nu]", ",", "4"}], "]"}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.6911468936904*^9, 3.6911470015544796`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"DN", "@", "\[Mu]"}], ",", 
     RowBox[{"DN", "@", "\[Nu]"}]}], "]"}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"b", "[", 
      RowBox[{
       RowBox[{"UP", "@", "\[Nu]"}], ",", 
       RowBox[{"UP", "@", "\[Lambda]"}]}], "]"}], "+", 
     RowBox[{"c", "[", 
      RowBox[{
       RowBox[{"UP", "@", "\[Nu]"}], ",", 
       RowBox[{"UP", "@", "\[Lambda]"}]}], "]"}]}], ")"}]}], "//", 
  "Expand"}]], "Input",
 CellChangeTimes->{{3.691147454752675*^9, 3.6911474751462674`*^9}, {
  3.691147555393868*^9, 3.6911475640377097`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"DN", "[", "\[Mu]", "]"}], ",", 
     RowBox[{"DN", "[", "\[Nu]", "]"}]}], "]"}], " ", 
   RowBox[{"b", "[", 
    RowBox[{
     RowBox[{"UP", "[", "\[Nu]", "]"}], ",", 
     RowBox[{"UP", "[", "\[Lambda]", "]"}]}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"DN", "[", "\[Mu]", "]"}], ",", 
     RowBox[{"DN", "[", "\[Nu]", "]"}]}], "]"}], " ", 
   RowBox[{"c", "[", 
    RowBox[{
     RowBox[{"UP", "[", "\[Nu]", "]"}], ",", 
     RowBox[{"UP", "[", "\[Lambda]", "]"}]}], "]"}]}]}]], "Output",
 CellChangeTimes->{3.691147475458685*^9, 3.6911475648257575`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"s", "=", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{"DN", "@", "\[Mu]"}], "]"}], 
   RowBox[{"b", "[", 
    RowBox[{"UP", "@", "\[Mu]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.691147754189999*^9, 3.6911477783824577`*^9}, {
  3.6928372540080113`*^9, 3.6928372602578125`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"DN", "[", "\[Mu]", "]"}], "]"}], " ", 
  RowBox[{"b", "[", 
   RowBox[{"UP", "[", "\[Mu]", "]"}], "]"}]}]], "Output",
 CellChangeTimes->{{3.691147776508593*^9, 3.6911477789133744`*^9}, 
   3.6928372617954226`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 SuperscriptBox["s", "2"]], "Input",
 CellChangeTimes->{{3.691147779679057*^9, 3.691147782560252*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"a", "[", 
    RowBox[{"DN", "[", "\[Mu]", "]"}], "]"}], "2"], " ", 
  SuperscriptBox[
   RowBox[{"b", "[", 
    RowBox[{"UP", "[", "\[Mu]", "]"}], "]"}], "2"]}]], "Output",
 CellChangeTimes->{3.691147782886916*^9, 3.692837263194031*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Unique", "[", "]"}]], "Input",
 CellChangeTimes->{{3.691148047370454*^9, 3.6911480492218494`*^9}}],

Cell[BoxData["$3"], "Output",
 CellChangeTimes->{3.6911480501864986`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Unique", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6911480570996647`*^9, 3.6911480585217295`*^9}}],

Cell[BoxData["$4"], "Output",
 CellChangeTimes->{3.69114805894361*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Unique", "[", "]"}]], "Input",
 CellChangeTimes->{{3.691148059680381*^9, 3.6911480609309654`*^9}}],

Cell[BoxData["$5"], "Output",
 CellChangeTimes->{3.6911480613368063`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"s", ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Mu]", "=", 
      RowBox[{"Unique", "[", "]"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{"DN", "@", "\[Mu]"}], "]"}], 
     RowBox[{"b", "[", 
      RowBox[{"UP", "@", "\[Mu]"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.691148226082265*^9, 3.691148238184931*^9}, {
  3.692837332469121*^9, 3.692837344768648*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"s", "*", "s"}]], "Input",
 CellChangeTimes->{{3.6911482435903597`*^9, 3.6911482470330286`*^9}, {
  3.6911482783049145`*^9, 3.691148280415698*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"DN", "[", "$3", "]"}], "]"}], " ", 
  RowBox[{"a", "[", 
   RowBox[{"DN", "[", "$4", "]"}], "]"}], " ", 
  RowBox[{"b", "[", 
   RowBox[{"UP", "[", "$3", "]"}], "]"}], " ", 
  RowBox[{"b", "[", 
   RowBox[{"UP", "[", "$4", "]"}], "]"}]}]], "Output",
 CellChangeTimes->{3.691148248111374*^9, 3.6911482808060303`*^9, 
  3.6928373475679483`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Work", " ", "for", " ", "one", " ", "term", " ", "after", " ", 
     RowBox[{
      StyleBox["Expand",
       FontSlant->"Italic"], ".", " ", "\[IndentingNewLine]", "Need"}], " ", 
     "first", " ", "to", " ", "find", " ", "out", " ", "the", " ", "dummy", 
     " ", "indices"}], ",", " ", 
    RowBox[{"and", " ", "for", " ", "each", " ", "index", " ", "do", " ", 
     RowBox[{"below", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"UTot", "@", "\[Mu]"}], ",", " ", 
      RowBox[{"DTot", "@", "\[Mu]"}]}], "]"}], "/.", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"UTot", "@", "\[Mu]"}], "\[Rule]", 
         RowBox[{"UP", "@", "i"}]}], ",", 
        RowBox[{
         RowBox[{"DTot", "@", "\[Mu]"}], "\[Rule]", 
         RowBox[{"DN", "@", "i"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"UTot", "@", "\[Mu]"}], "\[Rule]", 
         RowBox[{"UE", "@", "0"}]}], ",", 
        RowBox[{
         RowBox[{"DTot", "@", "\[Mu]"}], "\[Rule]", 
         RowBox[{"DE", "@", "0"}]}]}], "}"}]}], "}"}]}], " ", "//", 
   "Total"}]}]], "Input",
 CellChangeTimes->{{3.692848838902793*^9, 3.69284886328963*^9}, 
   3.6928490236780367`*^9, {3.6928491979907465`*^9, 3.692849349616109*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{
    RowBox[{"UE", "[", "0", "]"}], ",", 
    RowBox[{"DE", "[", "0", "]"}]}], "]"}], "+", 
  RowBox[{"f", "[", 
   RowBox[{
    RowBox[{"UP", "[", "i", "]"}], ",", 
    RowBox[{"DN", "[", "i", "]"}]}], "]"}]}]], "Output",
 CellChangeTimes->{{3.6928492779129705`*^9, 3.6928492842136235`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tsr", " ", "=", " ", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"UP", "@", "\[Mu]"}], ",", 
     RowBox[{"UP", "@", "\[Nu]"}], ",", 
     RowBox[{"UP", "@", "\[Lambda]"}], ",", " ", 
     RowBox[{"DN", "@", "\[Nu]"}]}], "]"}], 
   RowBox[{"b", "[", 
    RowBox[{
     RowBox[{"DN", "@", "\[Lambda]"}], ",", 
     RowBox[{"DN", "@", "\[Rho]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6928495790406857`*^9, 3.692849647622159*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{
    RowBox[{"UP", "[", "\[Mu]", "]"}], ",", 
    RowBox[{"UP", "[", "\[Nu]", "]"}], ",", 
    RowBox[{"UP", "[", "\[Lambda]", "]"}], ",", 
    RowBox[{"DN", "[", "\[Nu]", "]"}]}], "]"}], " ", 
  RowBox[{"b", "[", 
   RowBox[{
    RowBox[{"DN", "[", "\[Lambda]", "]"}], ",", 
    RowBox[{"DN", "[", "\[Rho]", "]"}]}], "]"}]}]], "Output",
 CellChangeTimes->{{3.692849620318142*^9, 3.6928496484908476`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cases", "[", 
   RowBox[{"tsr", ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"UP", "|", "DN"}], ")"}], "[", "\[Mu]_", "]"}], 
     "\[RuleDelayed]", "\[Mu]"}], ",", " ", "Infinity"}], "]"}], " ", "//", 
  " ", "Tally"}]], "Input",
 CellChangeTimes->{{3.692849651923006*^9, 3.692849790940606*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Mu]", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Nu]", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Lambda]", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Rho]", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.6928496701638975`*^9, 3.6928496819311314`*^9}, 
   3.6928497584787793`*^9, 3.692849791462519*^9, 3.692849841194146*^9, 
   3.692850076934122*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"list", " ", "of", " ", "free"}], ",", " ", 
     RowBox[{"list", " ", "of", " ", "dummy"}]}], "}"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Cases", "[", 
     RowBox[{"%", ",", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a_", ",", "1"}], "}"}], "\[RuleDelayed]", "a"}]}], "]"}], 
    ",", " ", 
    RowBox[{"Cases", "[", 
     RowBox[{"%", ",", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a_", ",", "2"}], "}"}], "\[RuleDelayed]", "a"}]}], "]"}]}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.692850079147212*^9, 3.6928501421488914`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Mu]", ",", "\[Rho]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Nu]", ",", "\[Lambda]"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.6928501425945873`*^9}]
}, Open  ]]
},
WindowSize->{1853, 1037},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
Magnification:>1.5 Inherited,
FrontEndVersion->"10.3 for Microsoft Windows (64-bit) (2015\:5e7410\:67089\
\:65e5)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 3211, 82, 502, "Input"],
Cell[CellGroupData[{
Cell[3794, 106, 208, 3, 45, "Input"],
Cell[4005, 111, 285, 8, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4327, 124, 768, 19, 45, "Input"],
Cell[5098, 145, 10860, 348, 241, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15995, 498, 948, 29, 45, "Input"],
Cell[16946, 529, 2897, 91, 73, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19880, 625, 616, 19, 45, "Input"],
Cell[20499, 646, 674, 20, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21210, 671, 306, 8, 45, "Input"],
Cell[21519, 681, 270, 7, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21826, 693, 116, 2, 47, "Input"],
Cell[21945, 697, 290, 8, 46, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22272, 710, 122, 2, 45, "Input"],
Cell[22397, 714, 73, 1, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22507, 720, 124, 2, 45, "Input"],
Cell[22634, 724, 70, 1, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22741, 730, 122, 2, 45, "Input"],
Cell[22866, 734, 73, 1, 44, "Output"]
}, Open  ]],
Cell[22954, 738, 453, 13, 45, "Input"],
Cell[CellGroupData[{
Cell[23432, 755, 170, 3, 45, "Input"],
Cell[23605, 760, 399, 11, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24041, 776, 1433, 38, 104, "Input"],
Cell[25477, 816, 348, 10, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25862, 831, 475, 13, 45, "Input"],
Cell[26340, 846, 461, 12, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26838, 863, 359, 10, 45, "Input"],
Cell[27200, 875, 478, 13, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27715, 893, 701, 22, 75, "Input"],
Cell[28419, 917, 236, 7, 44, "Output"]
}, Open  ]]
}
]
*)

