def dim4sym_det(g, simp = lambda x: x.simplify_rational()):
    detmat = g[0][0]*g[1][1]*g[2][2]*g[3][3] - g[0][0]*g[1][1]*g[2][3]**2 - g[0][0]*g[1][2]**2*g[3][3] + 2*g[0][0]*g[1][2]*g[1][3]*g[2][3] - g[0][0]*g[1][3]**2*g[2][2] - g[0][1]**2*g[2][2]*g[3][3] + g[0][1]**2*g[2][3]**2 + 2*g[0][1]*g[0][2]*g[1][2]*g[3][3] - 2*g[0][1]*g[0][2]*g[1][3]*g[2][3] - 2*g[0][1]*g[0][3]*g[1][2]*g[2][3] + 2*g[0][1]*g[0][3]*g[1][3]*g[2][2] - g[0][2]**2*g[1][1]*g[3][3] + g[0][2]**2*g[1][3]**2 + 2*g[0][2]*g[0][3]*g[1][1]*g[2][3] - 2*g[0][2]*g[0][3]*g[1][2]*g[1][3] - g[0][3]**2*g[1][1]*g[2][2] + g[0][3]**2*g[1][2]**2

    detmat_simp = simp(detmat)

    return detmat_simp



def dim4sym_invert(g, simp = lambda x: x.simplify_rational()):
    invmat = [[((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) + (((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - (g[0][1]*g[0][3]/g[0][0] - g[1][3])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) + g[0][3]/g[0][0])**2/((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3]) - g[0][1]**2/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]**2) + 1/g[0][0], ((g[0][1]*g[0][3]/g[0][0] - g[1][3])/(g[0][1]**2/g[0][0] - g[1][1]) - (g[0][1]*g[0][2]/g[0][0] - g[1][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]**2/g[0][0] - g[1][1])*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])))*(((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - (g[0][1]*g[0][3]/g[0][0] - g[1][3])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) + g[0][3]/g[0][0])/((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3]) - ((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/((g[0][1]**2/g[0][0] - g[1][1])*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])) + g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]), ((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) + ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])*(((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - (g[0][1]*g[0][3]/g[0][0] - g[1][3])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) + g[0][3]/g[0][0])/(((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3])), -(((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - (g[0][1]*g[0][3]/g[0][0] - g[1][3])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) + g[0][3]/g[0][0])/((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3])], [((g[0][1]*g[0][3]/g[0][0] - g[1][3])/(g[0][1]**2/g[0][0] - g[1][1]) - (g[0][1]*g[0][2]/g[0][0] - g[1][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]**2/g[0][0] - g[1][1])*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])))*(((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - (g[0][1]*g[0][3]/g[0][0] - g[1][3])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) + g[0][3]/g[0][0])/((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3]) - ((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/((g[0][1]**2/g[0][0] - g[1][1])*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])) + g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]), ((g[0][1]*g[0][3]/g[0][0] - g[1][3])/(g[0][1]**2/g[0][0] - g[1][1]) - (g[0][1]*g[0][2]/g[0][0] - g[1][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]**2/g[0][0] - g[1][1])*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])))**2/((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3]) + (g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/((g[0][1]**2/g[0][0] - g[1][1])**2*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])) - 1/(g[0][1]**2/g[0][0] - g[1][1]), ((g[0][1]*g[0][3]/g[0][0] - g[1][3])/(g[0][1]**2/g[0][0] - g[1][1]) - (g[0][1]*g[0][2]/g[0][0] - g[1][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]**2/g[0][0] - g[1][1])*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])))*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/(((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3])) - (g[0][1]*g[0][2]/g[0][0] - g[1][2])/((g[0][1]**2/g[0][0] - g[1][1])*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])), -((g[0][1]*g[0][3]/g[0][0] - g[1][3])/(g[0][1]**2/g[0][0] - g[1][1]) - (g[0][1]*g[0][2]/g[0][0] - g[1][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]**2/g[0][0] - g[1][1])*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])))/((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3])], [((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) + ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])*(((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - (g[0][1]*g[0][3]/g[0][0] - g[1][3])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) + g[0][3]/g[0][0])/(((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3])), ((g[0][1]*g[0][3]/g[0][0] - g[1][3])/(g[0][1]**2/g[0][0] - g[1][1]) - (g[0][1]*g[0][2]/g[0][0] - g[1][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]**2/g[0][0] - g[1][1])*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])))*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/(((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3])) - (g[0][1]*g[0][2]/g[0][0] - g[1][2])/((g[0][1]**2/g[0][0] - g[1][1])*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])), 1/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) + ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/(((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])**2*((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3])), -((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/(((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3]))], [-(((g[0][1]*g[0][2]/g[0][0] - g[1][2])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) - g[0][2]/g[0][0])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - (g[0][1]*g[0][3]/g[0][0] - g[1][3])*g[0][1]/((g[0][1]**2/g[0][0] - g[1][1])*g[0][0]) + g[0][3]/g[0][0])/((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3]), -((g[0][1]*g[0][3]/g[0][0] - g[1][3])/(g[0][1]**2/g[0][0] - g[1][1]) - (g[0][1]*g[0][2]/g[0][0] - g[1][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/((g[0][1]**2/g[0][0] - g[1][1])*((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])))/((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3]), -((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])/(((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2])*((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3])), 1/((g[0][1]*g[0][3]/g[0][0] - g[1][3])**2/(g[0][1]**2/g[0][0] - g[1][1]) - ((g[0][1]*g[0][3]/g[0][0] - g[1][3])*(g[0][1]*g[0][2]/g[0][0] - g[1][2])/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]*g[0][3]/g[0][0] + g[2][3])**2/((g[0][1]*g[0][2]/g[0][0] - g[1][2])**2/(g[0][1]**2/g[0][0] - g[1][1]) - g[0][2]**2/g[0][0] + g[2][2]) - g[0][3]**2/g[0][0] + g[3][3])]]


    invmat_simp = [[simp(invmat[i][j]) for j in (0,1,2,3)] for i in (0,1,2,3)]

    return invmat_simp
    
